/* umockdev-ioctl.c generated by valac 0.56.17, the Vala compiler
 * generated from umockdev-ioctl.vala, do not modify */

/**
 * UMockdevIoctlClient:
 *
 * The #UMockdevIoctlClient struct represents an opened client side FD in order
 * to emulate ioctl calls on this device.
 *
 * Since: 0.16
 */
/**
 * UMockdevIoctlClient::handle-ioctl:
 * @client: A #UMockdevIoctlClient
 *
 * Called when an ioctl is requested by the client.
 *
 * This is the per-client signal. See #UMockdevIoctlBase::handle-ioctl on #UMockdevIoctlBase.
 *
 * Since: 0.16
 */
/**
 * UMockdevIoctlClient::handle-read:
 * @client: A #UMockdevIoctlClient
 *
 * Called when a read is requested by the client.
 *
 * This is the per-client signal. See #UMockdevIoctlBase::handle-read on #UMockdevIoctlBase.
 *
 * Since: 0.16
 */
/**
 * UMockdevIoctlBaseClass:
 * @handle_ioctl: Override ioctl emulation
 * @handle_read: Override read emulation
 * @handle_write: Override write_emulation
 * @client_connected: A device was opened
 * @client_vanished: A device was closed
 *
 * The base class for an device ioctl and read/write handling. You can either
 * override the corresponding vfuncs or connect to the signals to customize
 * the emulation.
 *
 * Since: 0.16
 */
/**
 * UMockdevIoctlBase:
 *
 * The #UMockdevIoctlBase class is a base class to emulate and record ioctl
 * operations of a client. It can be attached to an emulated device in the
 * testbed and will then be used.
 *
 * Since: 0.16
 */
/**
 * UMockdevIoctlBase::handle-ioctl:
 * @handler: A #UMockdevIoctlBase
 * @client: A #UMockdevIoctlClient
 *
 * Called when an ioctl is requested by the client.
 *
 * Access the #UMockdevIoctlClient:arg property of @client to retrieve the
 * argument of the ioctl. This is a pointer sized buffer initially with the
 * original argument passed to the ioctl. If this is pointing to a struct, use
 * umockdev_ioctl_data_resolve() to retrieve the underlying memory and update
 * the pointer. Resolve any further pointers in the structure in the same way.
 *
 * After resolving the memory, you can access it as if it was local. The memory
 * will be synced back to the client automatically if it has been modified
 * locally.
 *
 * Once processing is done, use umockdev_ioctl_client_complete() to let the
 * client continue with the result of the emulation. You can also use
 * umockdev_ioctl_client_abort() to kill the client. Note that this handling
 * does not need to be immediate. It is valid to immediately return #TRUE from
 * this function and call umockdev_ioctl_client_complete() at a later point.
 *
 * Note that this function will be called from a worker thread with a private
 * #GMainContext for the #UMockdevTestbed. Do not block this context for longer
 * periods. The complete handler may be called from a different thread.
 *
 * Returns: #TRUE if the request is being handled, #FALSE otherwise.
 * Since: 0.16
 */
/**
 * UMockdevIoctlBase::handle-read:
 * @handler: A #UMockdevIoctlBase
 * @client: A #UMockdevIoctlClient
 *
 * Called when a read is requested by the client.
 *
 * The result buffer is represented by #UMockdevIoctlClient:arg of @client.
 * Retrieve its length to find out the requested read length. The content of
 * the buffer has already been retrieved, and you can freely use and update it.
 *
 * See #UMockdevIoctlBase::handle-ioctl for some more information.
 *
 * Returns: #TRUE if the request is being handled, #FALSE otherwise.
 * Since: 0.16
 */

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <string.h>
#include <stdlib.h>
#include "ioctl_tree.h"
#include "linux/ioctl.h"
#include <errno.h>
#include <gobject/gvaluecollector.h>
#include <glib/gstdio.h>
#include <gio/gunixsocketaddress.h>
#include <unistd.h>
#include <stdio.h>
#include "cros_ec.h"
#include "linux/usbdevice_fs.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define UMOCKDEV_TYPE_IOCTL_DATA (umockdev_ioctl_data_get_type ())
#define UMOCKDEV_IOCTL_DATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_IOCTL_DATA, UMockdevIoctlData))
#define UMOCKDEV_IOCTL_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_IOCTL_DATA, UMockdevIoctlDataClass))
#define UMOCKDEV_IS_IOCTL_DATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_IOCTL_DATA))
#define UMOCKDEV_IS_IOCTL_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_IOCTL_DATA))
#define UMOCKDEV_IOCTL_DATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_IOCTL_DATA, UMockdevIoctlDataClass))

typedef struct _UMockdevIoctlData UMockdevIoctlData;
typedef struct _UMockdevIoctlDataClass UMockdevIoctlDataClass;
typedef struct _UMockdevIoctlDataPrivate UMockdevIoctlDataPrivate;
enum  {
	UMOCKDEV_IOCTL_DATA_0_PROPERTY,
	UMOCKDEV_IOCTL_DATA_NUM_PROPERTIES
};
static GParamSpec* umockdev_ioctl_data_properties[UMOCKDEV_IOCTL_DATA_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _UmockdevIoctlDataFlushData UmockdevIoctlDataFlushData;

#define UMOCKDEV_TYPE_IOCTL_CLIENT (umockdev_ioctl_client_get_type ())
#define UMOCKDEV_IOCTL_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_IOCTL_CLIENT, UMockdevIoctlClient))
#define UMOCKDEV_IOCTL_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_IOCTL_CLIENT, UMockdevIoctlClientClass))
#define UMOCKDEV_IS_IOCTL_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_IOCTL_CLIENT))
#define UMOCKDEV_IS_IOCTL_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_IOCTL_CLIENT))
#define UMOCKDEV_IOCTL_CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_IOCTL_CLIENT, UMockdevIoctlClientClass))

typedef struct _UMockdevIoctlClient UMockdevIoctlClient;
typedef struct _UMockdevIoctlClientClass UMockdevIoctlClientClass;
typedef struct _UMockdevIoctlClientPrivate UMockdevIoctlClientPrivate;

#define UMOCKDEV_TYPE_IOCTL_BASE (umockdev_ioctl_base_get_type ())
#define UMOCKDEV_IOCTL_BASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_IOCTL_BASE, UMockdevIoctlBase))
#define UMOCKDEV_IOCTL_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_IOCTL_BASE, UMockdevIoctlBaseClass))
#define UMOCKDEV_IS_IOCTL_BASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_IOCTL_BASE))
#define UMOCKDEV_IS_IOCTL_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_IOCTL_BASE))
#define UMOCKDEV_IOCTL_BASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_IOCTL_BASE, UMockdevIoctlBaseClass))

typedef struct _UMockdevIoctlBase UMockdevIoctlBase;
typedef struct _UMockdevIoctlBaseClass UMockdevIoctlBaseClass;
enum  {
	UMOCKDEV_IOCTL_CLIENT_0_PROPERTY,
	UMOCKDEV_IOCTL_CLIENT_DEVNODE_PROPERTY,
	UMOCKDEV_IOCTL_CLIENT_REQUEST_PROPERTY,
	UMOCKDEV_IOCTL_CLIENT_ARG_PROPERTY,
	UMOCKDEV_IOCTL_CLIENT_CONNECTED_PROPERTY,
	UMOCKDEV_IOCTL_CLIENT_NUM_PROPERTIES
};
static GParamSpec* umockdev_ioctl_client_properties[UMOCKDEV_IOCTL_CLIENT_NUM_PROPERTIES];
#define _g_main_context_unref0(var) ((var == NULL) ? NULL : (var = (g_main_context_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _UmockdevIoctlClientCompleteAsyncData UmockdevIoctlClientCompleteAsyncData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _ioctl_tree_free0(var) ((var == NULL) ? NULL : (var = (ioctl_tree_free (var), NULL)))
typedef struct _UmockdevIoctlClientReadIoctlData UmockdevIoctlClientReadIoctlData;

#define UMOCKDEV_TYPE_START_LISTEN_CLOSURE (umockdev_start_listen_closure_get_type ())
#define UMOCKDEV_START_LISTEN_CLOSURE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_START_LISTEN_CLOSURE, UMockdevStartListenClosure))
#define UMOCKDEV_START_LISTEN_CLOSURE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_START_LISTEN_CLOSURE, UMockdevStartListenClosureClass))
#define UMOCKDEV_IS_START_LISTEN_CLOSURE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_START_LISTEN_CLOSURE))
#define UMOCKDEV_IS_START_LISTEN_CLOSURE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_START_LISTEN_CLOSURE))
#define UMOCKDEV_START_LISTEN_CLOSURE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_START_LISTEN_CLOSURE, UMockdevStartListenClosureClass))

typedef struct _UMockdevStartListenClosure UMockdevStartListenClosure;
typedef struct _UMockdevStartListenClosureClass UMockdevStartListenClosureClass;
typedef struct _UMockdevStartListenClosurePrivate UMockdevStartListenClosurePrivate;
typedef struct _UMockdevParamSpecStartListenClosure UMockdevParamSpecStartListenClosure;
typedef struct _UMockdevIoctlBasePrivate UMockdevIoctlBasePrivate;
enum  {
	UMOCKDEV_IOCTL_BASE_0_PROPERTY,
	UMOCKDEV_IOCTL_BASE_NUM_PROPERTIES
};
static GParamSpec* umockdev_ioctl_base_properties[UMOCKDEV_IOCTL_BASE_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _UmockdevIoctlBaseSocketListenData UmockdevIoctlBaseSocketListenData;
#define _umockdev_start_listen_closure_unref0(var) ((var == NULL) ? NULL : (var = (umockdev_start_listen_closure_unref (var), NULL)))
enum  {
	UMOCKDEV_IOCTL_BASE_CLIENT_CONNECTED_SIGNAL,
	UMOCKDEV_IOCTL_BASE_CLIENT_VANISHED_SIGNAL,
	UMOCKDEV_IOCTL_BASE_NUM_SIGNALS
};
static guint umockdev_ioctl_base_signals[UMOCKDEV_IOCTL_BASE_NUM_SIGNALS] = {0};

#define UMOCKDEV_TYPE_IOCTL_TREE_HANDLER (umockdev_ioctl_tree_handler_get_type ())
#define UMOCKDEV_IOCTL_TREE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_IOCTL_TREE_HANDLER, UMockdevIoctlTreeHandler))
#define UMOCKDEV_IOCTL_TREE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_IOCTL_TREE_HANDLER, UMockdevIoctlTreeHandlerClass))
#define UMOCKDEV_IS_IOCTL_TREE_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_IOCTL_TREE_HANDLER))
#define UMOCKDEV_IS_IOCTL_TREE_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_IOCTL_TREE_HANDLER))
#define UMOCKDEV_IOCTL_TREE_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_IOCTL_TREE_HANDLER, UMockdevIoctlTreeHandlerClass))

typedef struct _UMockdevIoctlTreeHandler UMockdevIoctlTreeHandler;
typedef struct _UMockdevIoctlTreeHandlerClass UMockdevIoctlTreeHandlerClass;
typedef struct _UMockdevIoctlTreeHandlerPrivate UMockdevIoctlTreeHandlerPrivate;
enum  {
	UMOCKDEV_IOCTL_TREE_HANDLER_0_PROPERTY,
	UMOCKDEV_IOCTL_TREE_HANDLER_NUM_PROPERTIES
};
static GParamSpec* umockdev_ioctl_tree_handler_properties[UMOCKDEV_IOCTL_TREE_HANDLER_NUM_PROPERTIES];
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))

#define UMOCKDEV_TYPE_IOCTL_TREE_RECORDER (umockdev_ioctl_tree_recorder_get_type ())
#define UMOCKDEV_IOCTL_TREE_RECORDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UMOCKDEV_TYPE_IOCTL_TREE_RECORDER, UMockdevIoctlTreeRecorder))
#define UMOCKDEV_IOCTL_TREE_RECORDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UMOCKDEV_TYPE_IOCTL_TREE_RECORDER, UMockdevIoctlTreeRecorderClass))
#define UMOCKDEV_IS_IOCTL_TREE_RECORDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UMOCKDEV_TYPE_IOCTL_TREE_RECORDER))
#define UMOCKDEV_IS_IOCTL_TREE_RECORDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UMOCKDEV_TYPE_IOCTL_TREE_RECORDER))
#define UMOCKDEV_IOCTL_TREE_RECORDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UMOCKDEV_TYPE_IOCTL_TREE_RECORDER, UMockdevIoctlTreeRecorderClass))

typedef struct _UMockdevIoctlTreeRecorder UMockdevIoctlTreeRecorder;
typedef struct _UMockdevIoctlTreeRecorderClass UMockdevIoctlTreeRecorderClass;
typedef struct _UMockdevIoctlTreeRecorderPrivate UMockdevIoctlTreeRecorderPrivate;
enum  {
	UMOCKDEV_IOCTL_TREE_RECORDER_0_PROPERTY,
	UMOCKDEV_IOCTL_TREE_RECORDER_NUM_PROPERTIES
};
static GParamSpec* umockdev_ioctl_tree_recorder_properties[UMOCKDEV_IOCTL_TREE_RECORDER_NUM_PROPERTIES];
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _UMockdevIoctlData {
	GObject parent_instance;
	guint8* data;
	gint data_len;
	gulong client_addr;
	UMockdevIoctlDataPrivate * priv;
};

struct _UMockdevIoctlDataClass {
	GObjectClass parent_class;
};

struct _UMockdevIoctlDataPrivate {
	guint8* client_data;
	gint client_data_length1;
	gint _client_data_size_;
	GIOStream* stream;
	UMockdevIoctlData** children;
	gint children_length1;
	gint _children_size_;
	gsize* children_offset;
	gint children_offset_length1;
	gint _children_offset_size_;
};

struct _UmockdevIoctlDataFlushData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	UMockdevIoctlData* self;
	guint8* submit_data;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint submit_data_length1;
	gint _submit_data_size_;
	gint i;
	gboolean _tmp2_;
	gint _tmp3_;
	UMockdevIoctlData** _tmp4_;
	gint _tmp4__length1;
	UMockdevIoctlData** _tmp5_;
	gint _tmp5__length1;
	UMockdevIoctlData* _tmp6_;
	guint8* _tmp7_;
	gint _tmp7__length1;
	gsize* _tmp8_;
	gint _tmp8__length1;
	gsize _tmp9_;
	UMockdevIoctlData** _tmp10_;
	gint _tmp10__length1;
	UMockdevIoctlData* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	guint8* _tmp14_;
	gint _tmp14__length1;
	guint8* _tmp15_;
	gint _tmp15__length1;
	guint8* _tmp16_;
	gint _tmp16__length1;
	guint8* _tmp17_;
	gint _tmp17__length1;
	guint8* _tmp18_;
	gint _tmp18__length1;
	GOutputStream* output;
	GIOStream* _tmp19_;
	GOutputStream* _tmp20_;
	GOutputStream* _tmp21_;
	gulong args[3];
	guint8* _tmp22_;
	gint _tmp22__length1;
	GOutputStream* _tmp23_;
	GOutputStream* _tmp24_;
	guint8* _tmp25_;
	gint _tmp25__length1;
	GError* _inner_error0_;
};

struct _UMockdevIoctlClient {
	GObject parent_instance;
	UMockdevIoctlClientPrivate * priv;
};

struct _UMockdevIoctlClientClass {
	GObjectClass parent_class;
};

struct _UMockdevIoctlClientPrivate {
	UMockdevIoctlBase* handler;
	GIOStream* stream;
	GMainContext* _ctx;
	gchar* _devnode;
	gulong _request;
	UMockdevIoctlData* _arg;
	gulong _cmd;
	gboolean _abort;
	glong result;
	gint result_errno;
};

struct _UmockdevIoctlClientCompleteAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	UMockdevIoctlClient* self;
	GOutputStream* output;
	GIOStream* _tmp0_;
	GOutputStream* _tmp1_;
	GOutputStream* _tmp2_;
	gulong args[3];
	UMockdevIoctlData* _tmp3_;
	GOutputStream* _tmp4_;
	GError* _inner_error0_;
};

struct _UmockdevIoctlClientReadIoctlData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	UMockdevIoctlClient* self;
	GInputStream* input;
	GIOStream* _tmp0_;
	GInputStream* _tmp1_;
	GInputStream* _tmp2_;
	gsize bytes;
	gulong args[3];
	GInputStream* _tmp3_;
	gsize _tmp4_;
	GIOStream* _tmp5_;
	gboolean _tmp6_;
	GInputStream* _tmp7_;
	GIOStream* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	gulong _tmp11_;
	gulong _tmp12_;
	gulong _tmp13_;
	gulong _tmp14_;
	gulong _tmp15_;
	gulong _tmp16_;
	GIOStream* _tmp17_;
	UMockdevIoctlData* _tmp18_;
	UMockdevIoctlData* _tmp19_;
	guint8* _tmp20_;
	UMockdevIoctlData* _tmp21_;
	guint8* _tmp22_;
	gint _tmp22__length1;
	gulong _tmp23_;
	GIOStream* _tmp24_;
	UMockdevIoctlData* _tmp25_;
	UMockdevIoctlData* _tmp26_;
	gulong _tmp27_;
	guint8* _tmp28_;
	UMockdevIoctlData* _tmp29_;
	gulong _tmp30_;
	UMockdevIoctlData* _tmp31_;
	GError* e;
	GError* _tmp32_;
	const gchar* _tmp33_;
	gboolean handled;
	gulong _tmp34_;
	gboolean _tmp35_;
	gulong _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp38_;
	gulong _tmp39_;
	UMockdevIoctlBase* _tmp40_;
	gboolean _tmp41_;
	gulong _tmp42_;
	UMockdevIoctlBase* _tmp43_;
	gboolean _tmp44_;
	UMockdevIoctlBase* _tmp45_;
	gboolean _tmp46_;
	gboolean _tmp47_;
	gulong _tmp48_;
	ioctl_tree* tree;
	UMockdevIoctlData* data;
	gulong size;
	gulong type;
	gint ret;
	gint my_errno;
	UMockdevIoctlData* _tmp49_;
	UMockdevIoctlData* _tmp50_;
	UMockdevIoctlData* _tmp51_;
	UMockdevIoctlData* _tmp52_;
	GError* _vala1_e;
	GError* _tmp53_;
	const gchar* _tmp54_;
	ioctl_tree* _tmp55_;
	UMockdevIoctlData* _tmp56_;
	guint8* _tmp57_;
	gint _tmp57__length1;
	gint _tmp58_;
	GError* _inner_error0_;
};

struct _UMockdevStartListenClosure {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UMockdevIoctlBase* handler;
	GSocketListener* listener;
	gchar* devnode;
	UMockdevStartListenClosurePrivate * priv;
};

struct _UMockdevStartListenClosureClass {
	GTypeClass parent_class;
	void (*finalize) (UMockdevStartListenClosure *self);
};

struct _UMockdevParamSpecStartListenClosure {
	GParamSpec parent_instance;
};

struct _UMockdevIoctlBase {
	GObject parent_instance;
	UMockdevIoctlBasePrivate * priv;
};

struct _UMockdevIoctlBaseClass {
	GObjectClass parent_class;
	gboolean (*handle_ioctl) (UMockdevIoctlBase* self, UMockdevIoctlClient* client);
	gboolean (*handle_read) (UMockdevIoctlBase* self, UMockdevIoctlClient* client);
	gboolean (*handle_write) (UMockdevIoctlBase* self, UMockdevIoctlClient* client);
	void (*client_connected) (UMockdevIoctlBase* self, UMockdevIoctlClient* client);
	void (*client_vanished) (UMockdevIoctlBase* self, UMockdevIoctlClient* client);
};

struct _UMockdevIoctlBasePrivate {
	GHashTable* listeners;
	GRecMutex __lock_listeners;
};

struct _UmockdevIoctlBaseSocketListenData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	UMockdevIoctlBase* self;
	GSocketListener* listener;
	gchar* devnode;
	GCancellable* cancellable;
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	gconstpointer _tmp2_;
	GCancellable* _tmp3_;
	GHashTable* _tmp4_;
	GSocketConnection* connection;
	UMockdevIoctlClient* client;
	GSocketConnection* _tmp5_;
	GSocketConnection* _tmp6_;
	GSocketConnection* _tmp7_;
	GSocketConnection* _tmp8_;
	UMockdevIoctlClient* _tmp9_;
	UMockdevIoctlClient* _tmp10_;
	UMockdevIoctlClient* _tmp11_;
	GError* e;
	const gchar* _tmp12_;
	GError* _inner_error0_;
};

struct _UMockdevIoctlTreeHandler {
	UMockdevIoctlBase parent_instance;
	UMockdevIoctlTreeHandlerPrivate * priv;
};

struct _UMockdevIoctlTreeHandlerClass {
	UMockdevIoctlBaseClass parent_class;
};

struct _UMockdevIoctlTreeHandlerPrivate {
	ioctl_tree* tree;
};

struct _UMockdevIoctlTreeRecorder {
	UMockdevIoctlBase parent_instance;
	UMockdevIoctlTreeRecorderPrivate * priv;
};

struct _UMockdevIoctlTreeRecorderClass {
	UMockdevIoctlBaseClass parent_class;
};

struct _UMockdevIoctlTreeRecorderPrivate {
	gboolean write_log;
	gchar* logfile;
	gchar* device;
	ioctl_tree* tree;
};

static gint UMockdevIoctlData_private_offset;
static gpointer umockdev_ioctl_data_parent_class = NULL;
static gint UMockdevIoctlClient_private_offset;
static gpointer umockdev_ioctl_client_parent_class = NULL;
static gpointer umockdev_start_listen_closure_parent_class = NULL;
static gint UMockdevIoctlBase_private_offset;
static gpointer umockdev_ioctl_base_parent_class = NULL;
VALA_EXTERN UMockdevIoctlData* umockdev_last_submit_urb;
UMockdevIoctlData* umockdev_last_submit_urb = NULL;
static gint UMockdevIoctlTreeHandler_private_offset;
static gpointer umockdev_ioctl_tree_handler_parent_class = NULL;
static gint UMockdevIoctlTreeRecorder_private_offset;
static gpointer umockdev_ioctl_tree_recorder_parent_class = NULL;

VALA_EXTERN gboolean umockdev_signal_accumulator_true_handled (GSignalInvocationHint* ihint,
                                                   GValue* return_accu,
                                                   GValue* handler_return,
                                                   void* data);
VALA_EXTERN GType umockdev_ioctl_data_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UMockdevIoctlData, g_object_unref)
VALA_EXTERN UMockdevIoctlData* umockdev_ioctl_data_new (GIOStream* stream);
VALA_EXTERN UMockdevIoctlData* umockdev_ioctl_data_construct (GType object_type,
                                                  GIOStream* stream);
VALA_EXTERN UMockdevIoctlData* umockdev_ioctl_data_ref (UMockdevIoctlData* self);
VALA_EXTERN void umockdev_ioctl_data_unref (UMockdevIoctlData* self);
VALA_EXTERN UMockdevIoctlData* umockdev_ioctl_data_resolve (UMockdevIoctlData* self,
                                                gsize offset,
                                                gsize len,
                                                GError** error);
static void _vala_array_add1 (UMockdevIoctlData** * array,
                       gint* length,
                       gint* size,
                       UMockdevIoctlData* value);
static void _vala_array_add2 (gsize* * array,
                       gint* length,
                       gint* size,
                       gsize value);
VALA_EXTERN void umockdev_ioctl_data_load_data (UMockdevIoctlData* self,
                                    GError** error);
VALA_EXTERN gboolean umockdev_ioctl_data_set_ptr (UMockdevIoctlData* self,
                                      gsize offset,
                                      UMockdevIoctlData* child);
static void _vala_array_add3 (UMockdevIoctlData** * array,
                       gint* length,
                       gint* size,
                       UMockdevIoctlData* value);
static void _vala_array_add4 (gsize* * array,
                       gint* length,
                       gint* size,
                       gsize value);
VALA_EXTERN gboolean umockdev_ioctl_data_reload (UMockdevIoctlData* self,
                                     GError** error);
VALA_EXTERN void umockdev_ioctl_data_update (UMockdevIoctlData* self,
                                 gsize offset,
                                 guint8* new_data,
                                 gint new_data_length1);
VALA_EXTERN void umockdev_ioctl_data_retrieve (UMockdevIoctlData* self,
                                   guint8** read_data,
                                   gint* read_data_length1);
static guint8* _vala_array_dup1 (guint8* self,
                          gssize length);
static void umockdev_ioctl_data_flush_data_free (gpointer _data);
VALA_EXTERN void umockdev_ioctl_data_flush (UMockdevIoctlData* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
VALA_EXTERN void umockdev_ioctl_data_flush_finish (UMockdevIoctlData* self,
                                       GAsyncResult* _res_,
                                       GError** error);
static gboolean umockdev_ioctl_data_flush_co (UmockdevIoctlDataFlushData* _data_);
static guint8* _vala_array_dup2 (guint8* self,
                          gssize length);
static void umockdev_ioctl_data_flush_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
VALA_EXTERN void umockdev_ioctl_data_flush_sync (UMockdevIoctlData* self,
                                     GError** error);
static guint8* _vala_array_dup3 (guint8* self,
                          gssize length);
static void umockdev_ioctl_data_finalize (GObject * obj);
static GType umockdev_ioctl_data_get_type_once (void);
VALA_EXTERN GType umockdev_ioctl_client_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UMockdevIoctlClient, g_object_unref)
VALA_EXTERN GType umockdev_ioctl_base_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UMockdevIoctlBase, g_object_unref)
VALA_EXTERN const gchar* umockdev_ioctl_client_get_devnode (UMockdevIoctlClient* self);
VALA_EXTERN gulong umockdev_ioctl_client_get_request (UMockdevIoctlClient* self);
VALA_EXTERN UMockdevIoctlData* umockdev_ioctl_client_get_arg (UMockdevIoctlClient* self);
VALA_EXTERN gboolean umockdev_ioctl_client_get_connected (UMockdevIoctlClient* self);
VALA_EXTERN gint umockdev_ioctl_client_execute (UMockdevIoctlClient* self,
                                    gint* errno_,
                                    GError** error);
VALA_EXTERN void umockdev_ioctl_client_complete (UMockdevIoctlClient* self,
                                     glong res,
                                     gint errno_);
static gboolean umockdev_ioctl_client_complete_idle (UMockdevIoctlClient* self);
static gboolean _umockdev_ioctl_client_complete_idle_gsource_func (gpointer self);
VALA_EXTERN void umockdev_ioctl_client_abort (UMockdevIoctlClient* self);
static void umockdev_ioctl_client_complete_async_data_free (gpointer _data);
static void umockdev_ioctl_client_complete_async (UMockdevIoctlClient* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static void umockdev_ioctl_client_complete_finish (UMockdevIoctlClient* self,
                                            GAsyncResult* _res_,
                                            GError** error);
static gboolean umockdev_ioctl_client_complete_async_co (UmockdevIoctlClientCompleteAsyncData* _data_);
static void umockdev_ioctl_client_complete_async_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
VALA_EXTERN void umockdev_ioctl_client_read_ioctl (UMockdevIoctlClient* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
VALA_EXTERN void umockdev_ioctl_client_read_ioctl_finish (UMockdevIoctlClient* self,
                                              GAsyncResult* _res_);
static void umockdev_ioctl_client_read_ioctl_data_free (gpointer _data);
static gboolean umockdev_ioctl_client_read_ioctl_co (UmockdevIoctlClientReadIoctlData* _data_);
static void umockdev_ioctl_client_read_ioctl_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static gboolean umockdev_ioctl_client_notify_closed_idle (UMockdevIoctlClient* self);
static void umockdev_ioctl_client_notify_closed_cb (UMockdevIoctlClient* self);
static gboolean _umockdev_ioctl_client_notify_closed_idle_gsource_func (gpointer self);
VALA_EXTERN UMockdevIoctlClient* umockdev_ioctl_client_new (UMockdevIoctlBase* handler,
                                                GIOStream* stream,
                                                const gchar* devnode);
VALA_EXTERN UMockdevIoctlClient* umockdev_ioctl_client_construct (GType object_type,
                                                      UMockdevIoctlBase* handler,
                                                      GIOStream* stream,
                                                      const gchar* devnode);
static gboolean _umockdev_signal_accumulator_true_handled_gsignal_accumulator (GSignalInvocationHint* ihint,
                                                                        GValue* return_accu,
                                                                        GValue* handler_return,
                                                                        void* data);
static void umockdev_ioctl_client_finalize (GObject * obj);
static GType umockdev_ioctl_client_get_type_once (void);
static void _vala_umockdev_ioctl_client_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
VALA_EXTERN gpointer umockdev_start_listen_closure_ref (gpointer instance);
VALA_EXTERN void umockdev_start_listen_closure_unref (gpointer instance);
VALA_EXTERN GParamSpec* umockdev_param_spec_start_listen_closure (const gchar* name,
                                                      const gchar* nick,
                                                      const gchar* blurb,
                                                      GType object_type,
                                                      GParamFlags flags);
VALA_EXTERN void umockdev_value_set_start_listen_closure (GValue* value,
                                              gpointer v_object);
VALA_EXTERN void umockdev_value_take_start_listen_closure (GValue* value,
                                               gpointer v_object);
VALA_EXTERN gpointer umockdev_value_get_start_listen_closure (const GValue* value);
VALA_EXTERN GType umockdev_start_listen_closure_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UMockdevStartListenClosure, umockdev_start_listen_closure_unref)
VALA_EXTERN UMockdevStartListenClosure* umockdev_start_listen_closure_new (UMockdevIoctlBase* handler,
                                                               GSocketListener* listener,
                                                               const gchar* devnode);
VALA_EXTERN UMockdevStartListenClosure* umockdev_start_listen_closure_construct (GType object_type,
                                                                     UMockdevIoctlBase* handler,
                                                                     GSocketListener* listener,
                                                                     const gchar* devnode);
VALA_EXTERN gboolean umockdev_start_listen_closure_cb (UMockdevStartListenClosure* self);
VALA_EXTERN void umockdev_ioctl_base_socket_listen (UMockdevIoctlBase* self,
                                        GSocketListener* listener,
                                        const gchar* devnode,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
VALA_EXTERN void umockdev_ioctl_base_socket_listen_finish (UMockdevIoctlBase* self,
                                               GAsyncResult* _res_);
static void umockdev_start_listen_closure_finalize (UMockdevStartListenClosure * obj);
static GType umockdev_start_listen_closure_get_type_once (void);
VALA_EXTERN gboolean umockdev_ioctl_base_handle_ioctl (UMockdevIoctlBase* self,
                                           UMockdevIoctlClient* client);
VALA_EXTERN gboolean umockdev_ioctl_base_handle_read (UMockdevIoctlBase* self,
                                          UMockdevIoctlClient* client);
VALA_EXTERN gboolean umockdev_ioctl_base_handle_write (UMockdevIoctlBase* self,
                                           UMockdevIoctlClient* client);
static void umockdev_ioctl_base_socket_listen_data_free (gpointer _data);
static gboolean umockdev_ioctl_base_socket_listen_co (UmockdevIoctlBaseSocketListenData* _data_);
static void umockdev_ioctl_base_socket_listen_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
VALA_EXTERN void umockdev_ioctl_base_register_path (UMockdevIoctlBase* self,
                                        GMainContext* ctx,
                                        const gchar* devnode,
                                        const gchar* sockpath);
static gboolean _umockdev_start_listen_closure_cb_gsource_func (gpointer self);
VALA_EXTERN void umockdev_ioctl_base_unregister_all (UMockdevIoctlBase* self);
static gboolean ___lambda4_ (UMockdevIoctlBase* self,
                      const gchar* key,
                      GCancellable* val);
static gboolean ____lambda4__ghr_func (gconstpointer key,
                                gconstpointer value,
                                gpointer self);
static gboolean umockdev_ioctl_base_real_handle_ioctl (UMockdevIoctlBase* self,
                                                UMockdevIoctlClient* client);
static gboolean umockdev_ioctl_base_real_handle_read (UMockdevIoctlBase* self,
                                               UMockdevIoctlClient* client);
static gboolean umockdev_ioctl_base_real_handle_write (UMockdevIoctlBase* self,
                                                UMockdevIoctlClient* client);
static void umockdev_ioctl_base_real_client_connected (UMockdevIoctlBase* self,
                                                UMockdevIoctlClient* client);
static void umockdev_ioctl_base_real_client_vanished (UMockdevIoctlBase* self,
                                               UMockdevIoctlClient* client);
VALA_EXTERN UMockdevIoctlBase* umockdev_ioctl_base_new (void);
VALA_EXTERN UMockdevIoctlBase* umockdev_ioctl_base_construct (GType object_type);
static GObject * umockdev_ioctl_base_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void umockdev_ioctl_base_finalize (GObject * obj);
static GType umockdev_ioctl_base_get_type_once (void);
VALA_EXTERN GType umockdev_ioctl_tree_handler_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UMockdevIoctlTreeHandler, g_object_unref)
VALA_EXTERN UMockdevIoctlTreeHandler* umockdev_ioctl_tree_handler_new (const gchar* file);
VALA_EXTERN UMockdevIoctlTreeHandler* umockdev_ioctl_tree_handler_construct (GType object_type,
                                                                 const gchar* file);
static gboolean umockdev_ioctl_tree_handler_real_handle_ioctl (UMockdevIoctlBase* base,
                                                        UMockdevIoctlClient* client);
static void umockdev_ioctl_tree_handler_finalize (GObject * obj);
static GType umockdev_ioctl_tree_handler_get_type_once (void);
VALA_EXTERN GType umockdev_ioctl_tree_recorder_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UMockdevIoctlTreeRecorder, g_object_unref)
VALA_EXTERN void umockdev_ioctl_base_client_connected (UMockdevIoctlBase* self,
                                           UMockdevIoctlClient* client);
static void umockdev_ioctl_tree_recorder_flush_log (UMockdevIoctlTreeRecorder* self);
VALA_EXTERN UMockdevIoctlTreeRecorder* umockdev_ioctl_tree_recorder_new (const gchar* device,
                                                             const gchar* file);
VALA_EXTERN UMockdevIoctlTreeRecorder* umockdev_ioctl_tree_recorder_construct (GType object_type,
                                                                   const gchar* device,
                                                                   const gchar* file);
static gboolean umockdev_ioctl_tree_recorder_real_handle_ioctl (UMockdevIoctlBase* base,
                                                         UMockdevIoctlClient* client);
static void umockdev_ioctl_tree_recorder_real_client_connected (UMockdevIoctlBase* base,
                                                         UMockdevIoctlClient* client);
static void umockdev_ioctl_tree_recorder_finalize (GObject * obj);
static GType umockdev_ioctl_tree_recorder_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
 * SECTION:umockdev-ioctl
 * @title: umockdev-ioctl
 * @short_description: Emulate ioctl and read/write calls for devices.
 *
 * These classes permit emulation of ioctl and read/write calls including
 * fully customizing the behaviour by creating an #UMockdevIoctlBase instance or
 * subclass instance and attaching it using umockdev_testbed_attach_ioctl().
 */
gboolean
umockdev_signal_accumulator_true_handled (GSignalInvocationHint* ihint,
                                          GValue* return_accu,
                                          GValue* handler_return,
                                          void* data)
{
	gboolean handled = FALSE;
	gboolean continue_emission = FALSE;
	gboolean result;
#line 18 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (ihint != NULL, FALSE);
#line 18 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (return_accu != NULL, FALSE);
#line 18 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (handler_return != NULL, FALSE);
#line 26 "../src/umockdev-ioctl.vala"
	handled = g_value_get_boolean (handler_return);
#line 27 "../src/umockdev-ioctl.vala"
	g_value_set_boolean (return_accu, handled);
#line 28 "../src/umockdev-ioctl.vala"
	continue_emission = !handled;
#line 30 "../src/umockdev-ioctl.vala"
	result = continue_emission;
#line 30 "../src/umockdev-ioctl.vala"
	return result;
#line 828 "umockdev-ioctl.c"
}

static inline gpointer
umockdev_ioctl_data_get_instance_private (UMockdevIoctlData* self)
{
	return G_STRUCT_MEMBER_P (self, UMockdevIoctlData_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 65 "../src/umockdev-ioctl.vala"
	return self ? g_object_ref (self) : NULL;
#line 842 "umockdev-ioctl.c"
}

UMockdevIoctlData*
umockdev_ioctl_data_construct (GType object_type,
                               GIOStream* stream)
{
	UMockdevIoctlData * self = NULL;
	GIOStream* _tmp0_;
#line 63 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (stream != NULL, NULL);
#line 63 "../src/umockdev-ioctl.vala"
	self = (UMockdevIoctlData*) g_object_new (object_type, NULL);
#line 65 "../src/umockdev-ioctl.vala"
	_tmp0_ = _g_object_ref0 (stream);
#line 65 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (self->priv->stream);
#line 65 "../src/umockdev-ioctl.vala"
	self->priv->stream = _tmp0_;
#line 63 "../src/umockdev-ioctl.vala"
	return self;
#line 863 "umockdev-ioctl.c"
}

UMockdevIoctlData*
umockdev_ioctl_data_new (GIOStream* stream)
{
#line 63 "../src/umockdev-ioctl.vala"
	return umockdev_ioctl_data_construct (UMOCKDEV_TYPE_IOCTL_DATA, stream);
#line 871 "umockdev-ioctl.c"
}

/**
     * umockdev_ioctl_data_ref:
     * @self: A #UMockdevIoctlData
     *
     * Deprecated, same as g_object_ref().
     */
UMockdevIoctlData*
umockdev_ioctl_data_ref (UMockdevIoctlData* self)
{
	UMockdevIoctlData* _tmp0_;
	UMockdevIoctlData* result;
#line 75 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "../src/umockdev-ioctl.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (self, UMOCKDEV_TYPE_IOCTL_DATA, UMockdevIoctlData));
#line 77 "../src/umockdev-ioctl.vala"
	result = _tmp0_;
#line 77 "../src/umockdev-ioctl.vala"
	return result;
#line 893 "umockdev-ioctl.c"
}

/**
     * umockdev_ioctl_data_unref:
     * @self: A #UMockdevIoctlData
     *
     * Deprecated, same as g_object_unref().
     */
void
umockdev_ioctl_data_unref (UMockdevIoctlData* self)
{
#line 87 "../src/umockdev-ioctl.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/umockdev-ioctl.vala"
	g_object_unref ((GObject*) self);
#line 909 "umockdev-ioctl.c"
}

/**
     * umockdev_ioctl_data_resolve:
     * @self: A #UMockdevIoctlData
     * @offset: Byte offset of pointer inside data
     * @len: Length of the to be resolved data
     * @error: return location for a GError, or %NULL
     *
     * Resolve an address inside the data. After this operation, the pointer
     * inside data points to a local copy of the memory. Any local modifications
     * will be synced back by umockdev_ioctl_client_complete() and
     * umockdev_ioctl_client_execute().
     *
     * You may call this multiple times on the same pointer in order to fetch
     * the existing information.
     *
     * Returns: #UMockdevIoctlData, or #NULL on error
     * Since: 0.16
     */
static void
_vala_array_add1 (UMockdevIoctlData** * array,
                  gint* length,
                  gint* size,
                  UMockdevIoctlData* value)
{
#line 125 "../src/umockdev-ioctl.vala"
	if ((*length) == (*size)) {
#line 125 "../src/umockdev-ioctl.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 125 "../src/umockdev-ioctl.vala"
		*array = g_renew (UMockdevIoctlData*, *array, (*size) + 1);
#line 942 "umockdev-ioctl.c"
	}
#line 125 "../src/umockdev-ioctl.vala"
	(*array)[(*length)++] = value;
#line 125 "../src/umockdev-ioctl.vala"
	(*array)[*length] = NULL;
#line 948 "umockdev-ioctl.c"
}

static void
_vala_array_add2 (gsize* * array,
                  gint* length,
                  gint* size,
                  gsize value)
{
#line 126 "../src/umockdev-ioctl.vala"
	if ((*length) == (*size)) {
#line 126 "../src/umockdev-ioctl.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 126 "../src/umockdev-ioctl.vala"
		*array = g_renew (gsize, *array, *size);
#line 963 "umockdev-ioctl.c"
	}
#line 126 "../src/umockdev-ioctl.vala"
	(*array)[(*length)++] = value;
#line 967 "umockdev-ioctl.c"
}

UMockdevIoctlData*
umockdev_ioctl_data_resolve (UMockdevIoctlData* self,
                             gsize offset,
                             gsize len,
                             GError** error)
{
	UMockdevIoctlData* res = NULL;
	guint8* _tmp8_;
	gint _tmp8__length1;
	GIOStream* _tmp9_;
	UMockdevIoctlData* _tmp10_;
	UMockdevIoctlData* _tmp11_;
	guint8* _tmp12_;
	UMockdevIoctlData* _tmp13_;
	guint8* _tmp14_;
	gint _tmp14__length1;
	UMockdevIoctlData* _tmp15_;
	UMockdevIoctlData* _tmp16_;
	gboolean _tmp17_ = FALSE;
	UMockdevIoctlData* _tmp18_;
	guint8* _tmp19_;
	gint _tmp19__length1;
	UMockdevIoctlData* _tmp20_;
	guint8* _tmp21_;
	gint _tmp21__length1;
	UMockdevIoctlData* _tmp22_;
	GError* _inner_error0_ = NULL;
	UMockdevIoctlData* result;
#line 110 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1000 "umockdev-ioctl.c"
	{
		gint i = 0;
#line 113 "../src/umockdev-ioctl.vala"
		i = 0;
#line 1005 "umockdev-ioctl.c"
		{
			gboolean _tmp0_ = FALSE;
#line 113 "../src/umockdev-ioctl.vala"
			_tmp0_ = TRUE;
#line 113 "../src/umockdev-ioctl.vala"
			while (TRUE) {
#line 1012 "umockdev-ioctl.c"
				UMockdevIoctlData** _tmp2_;
				gint _tmp2__length1;
				gsize* _tmp3_;
				gint _tmp3__length1;
				gsize _tmp4_;
#line 113 "../src/umockdev-ioctl.vala"
				if (!_tmp0_) {
#line 1020 "umockdev-ioctl.c"
					gint _tmp1_;
#line 113 "../src/umockdev-ioctl.vala"
					_tmp1_ = i;
#line 113 "../src/umockdev-ioctl.vala"
					i = _tmp1_ + 1;
#line 1026 "umockdev-ioctl.c"
				}
#line 113 "../src/umockdev-ioctl.vala"
				_tmp0_ = FALSE;
#line 113 "../src/umockdev-ioctl.vala"
				_tmp2_ = self->priv->children;
#line 113 "../src/umockdev-ioctl.vala"
				_tmp2__length1 = self->priv->children_length1;
#line 113 "../src/umockdev-ioctl.vala"
				if (!(i < _tmp2__length1)) {
#line 113 "../src/umockdev-ioctl.vala"
					break;
#line 1038 "umockdev-ioctl.c"
				}
#line 114 "../src/umockdev-ioctl.vala"
				_tmp3_ = self->priv->children_offset;
#line 114 "../src/umockdev-ioctl.vala"
				_tmp3__length1 = self->priv->children_offset_length1;
#line 114 "../src/umockdev-ioctl.vala"
				_tmp4_ = _tmp3_[i];
#line 114 "../src/umockdev-ioctl.vala"
				if (_tmp4_ == offset) {
#line 1048 "umockdev-ioctl.c"
					UMockdevIoctlData** _tmp5_;
					gint _tmp5__length1;
					UMockdevIoctlData* _tmp6_;
					UMockdevIoctlData* _tmp7_;
#line 115 "../src/umockdev-ioctl.vala"
					_tmp5_ = self->priv->children;
#line 115 "../src/umockdev-ioctl.vala"
					_tmp5__length1 = self->priv->children_length1;
#line 115 "../src/umockdev-ioctl.vala"
					_tmp6_ = _tmp5_[i];
#line 115 "../src/umockdev-ioctl.vala"
					_tmp7_ = _g_object_ref0 (_tmp6_);
#line 115 "../src/umockdev-ioctl.vala"
					result = _tmp7_;
#line 115 "../src/umockdev-ioctl.vala"
					_g_object_unref0 (res);
#line 115 "../src/umockdev-ioctl.vala"
					return result;
#line 1067 "umockdev-ioctl.c"
				}
			}
		}
	}
#line 118 "../src/umockdev-ioctl.vala"
	_tmp8_ = self->data;
#line 118 "../src/umockdev-ioctl.vala"
	_tmp8__length1 = self->data_len;
#line 118 "../src/umockdev-ioctl.vala"
	if ((offset + sizeof (gsize)) > ((gsize) _tmp8__length1)) {
#line 119 "../src/umockdev-ioctl.vala"
		result = NULL;
#line 119 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (res);
#line 119 "../src/umockdev-ioctl.vala"
		return result;
#line 1084 "umockdev-ioctl.c"
	}
#line 121 "../src/umockdev-ioctl.vala"
	_tmp9_ = self->priv->stream;
#line 121 "../src/umockdev-ioctl.vala"
	_tmp10_ = umockdev_ioctl_data_new (_tmp9_);
#line 121 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (res);
#line 121 "../src/umockdev-ioctl.vala"
	res = _tmp10_;
#line 122 "../src/umockdev-ioctl.vala"
	_tmp11_ = res;
#line 122 "../src/umockdev-ioctl.vala"
	_tmp12_ = g_new0 (guint8, len);
#line 122 "../src/umockdev-ioctl.vala"
	_tmp11_->data = (g_free (_tmp11_->data), NULL);
#line 122 "../src/umockdev-ioctl.vala"
	_tmp11_->data = _tmp12_;
#line 122 "../src/umockdev-ioctl.vala"
	_tmp11_->data_len = len;
#line 123 "../src/umockdev-ioctl.vala"
	_tmp13_ = res;
#line 123 "../src/umockdev-ioctl.vala"
	_tmp14_ = self->data;
#line 123 "../src/umockdev-ioctl.vala"
	_tmp14__length1 = self->data_len;
#line 123 "../src/umockdev-ioctl.vala"
	_tmp13_->client_addr = (gulong) (*((gsize*) (&_tmp14_[offset])));
#line 125 "../src/umockdev-ioctl.vala"
	_tmp15_ = res;
#line 125 "../src/umockdev-ioctl.vala"
	_tmp16_ = _g_object_ref0 (_tmp15_);
#line 125 "../src/umockdev-ioctl.vala"
	_vala_array_add1 (&self->priv->children, &self->priv->children_length1, &self->priv->_children_size_, _tmp16_);
#line 126 "../src/umockdev-ioctl.vala"
	_vala_array_add2 (&self->priv->children_offset, &self->priv->children_offset_length1, &self->priv->_children_offset_size_, offset);
#line 129 "../src/umockdev-ioctl.vala"
	_tmp18_ = res;
#line 129 "../src/umockdev-ioctl.vala"
	if (_tmp18_->client_addr == ((gulong) 0)) {
#line 129 "../src/umockdev-ioctl.vala"
		_tmp17_ = TRUE;
#line 1126 "umockdev-ioctl.c"
	} else {
#line 129 "../src/umockdev-ioctl.vala"
		_tmp17_ = len == ((gsize) 0);
#line 1130 "umockdev-ioctl.c"
	}
#line 129 "../src/umockdev-ioctl.vala"
	if (_tmp17_) {
#line 130 "../src/umockdev-ioctl.vala"
		result = NULL;
#line 130 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (res);
#line 130 "../src/umockdev-ioctl.vala"
		return result;
#line 1140 "umockdev-ioctl.c"
	}
#line 132 "../src/umockdev-ioctl.vala"
	_tmp19_ = self->data;
#line 132 "../src/umockdev-ioctl.vala"
	_tmp19__length1 = self->data_len;
#line 132 "../src/umockdev-ioctl.vala"
	_tmp20_ = res;
#line 132 "../src/umockdev-ioctl.vala"
	_tmp21_ = _tmp20_->data;
#line 132 "../src/umockdev-ioctl.vala"
	_tmp21__length1 = _tmp20_->data_len;
#line 132 "../src/umockdev-ioctl.vala"
	*((gsize*) (&_tmp19_[offset])) = (gsize) _tmp21_;
#line 134 "../src/umockdev-ioctl.vala"
	_tmp22_ = res;
#line 134 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_data_load_data (_tmp22_, &_inner_error0_);
#line 134 "../src/umockdev-ioctl.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 134 "../src/umockdev-ioctl.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 134 "../src/umockdev-ioctl.vala"
			g_propagate_error (error, _inner_error0_);
#line 134 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (res);
#line 134 "../src/umockdev-ioctl.vala"
			return NULL;
#line 1168 "umockdev-ioctl.c"
		} else {
#line 134 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (res);
#line 134 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 134 "../src/umockdev-ioctl.vala"
			g_clear_error (&_inner_error0_);
#line 134 "../src/umockdev-ioctl.vala"
			return NULL;
#line 1178 "umockdev-ioctl.c"
		}
	}
#line 136 "../src/umockdev-ioctl.vala"
	result = res;
#line 136 "../src/umockdev-ioctl.vala"
	return result;
#line 1185 "umockdev-ioctl.c"
}

/**
     * umockdev_ioctl_data_set_ptr:
     * @self: A #UMockdevIoctlData
     * @offset: Byte offset of pointer inside data
     * @child: Memory block that the pointer should point to
     * @error: return location for a GError, or %NULL
     *
     * Basically the reverse operation of umockdev_ioctl_data_resolve(). It sets
     * the pointer at @offset to point to the data from @child in a way that
     * can be synchronised back to the client.
     *
     * Use of this is rare, but e.g. required to reap USB URBs.
     *
     * The function will only work correctly for pointer elements that have not
     * been resolved before.
     *
     * Returns: %TRUE on success, %FALSE
     * Since: 0.16
     */
static void
_vala_array_add3 (UMockdevIoctlData** * array,
                  gint* length,
                  gint* size,
                  UMockdevIoctlData* value)
{
#line 166 "../src/umockdev-ioctl.vala"
	if ((*length) == (*size)) {
#line 166 "../src/umockdev-ioctl.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 166 "../src/umockdev-ioctl.vala"
		*array = g_renew (UMockdevIoctlData*, *array, (*size) + 1);
#line 1219 "umockdev-ioctl.c"
	}
#line 166 "../src/umockdev-ioctl.vala"
	(*array)[(*length)++] = value;
#line 166 "../src/umockdev-ioctl.vala"
	(*array)[*length] = NULL;
#line 1225 "umockdev-ioctl.c"
}

static void
_vala_array_add4 (gsize* * array,
                  gint* length,
                  gint* size,
                  gsize value)
{
#line 167 "../src/umockdev-ioctl.vala"
	if ((*length) == (*size)) {
#line 167 "../src/umockdev-ioctl.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 167 "../src/umockdev-ioctl.vala"
		*array = g_renew (gsize, *array, *size);
#line 1240 "umockdev-ioctl.c"
	}
#line 167 "../src/umockdev-ioctl.vala"
	(*array)[(*length)++] = value;
#line 1244 "umockdev-ioctl.c"
}

gboolean
umockdev_ioctl_data_set_ptr (UMockdevIoctlData* self,
                             gsize offset,
                             UMockdevIoctlData* child)
{
	gsize* _tmp0_;
	gint _tmp0__length1;
	guint8* _tmp1_;
	gint _tmp1__length1;
	UMockdevIoctlData* _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
	gboolean result;
#line 158 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (child != NULL, FALSE);
#line 160 "../src/umockdev-ioctl.vala"
	_tmp0_ = self->priv->children_offset;
#line 160 "../src/umockdev-ioctl.vala"
	_tmp0__length1 = self->priv->children_offset_length1;
#line 1270 "umockdev-ioctl.c"
	{
		gsize* o_collection = NULL;
		gint o_collection_length1 = 0;
		gint _o_collection_size_ = 0;
		gint o_it = 0;
#line 160 "../src/umockdev-ioctl.vala"
		o_collection = _tmp0_;
#line 160 "../src/umockdev-ioctl.vala"
		o_collection_length1 = _tmp0__length1;
#line 160 "../src/umockdev-ioctl.vala"
		for (o_it = 0; o_it < o_collection_length1; o_it = o_it + 1) {
#line 1282 "umockdev-ioctl.c"
			gsize o = 0UL;
#line 160 "../src/umockdev-ioctl.vala"
			o = o_collection[o_it];
#line 1286 "umockdev-ioctl.c"
			{
#line 161 "../src/umockdev-ioctl.vala"
				_vala_assert (o != offset, "o != offset");
#line 1290 "umockdev-ioctl.c"
			}
		}
	}
#line 164 "../src/umockdev-ioctl.vala"
	_tmp1_ = self->data;
#line 164 "../src/umockdev-ioctl.vala"
	_tmp1__length1 = self->data_len;
#line 164 "../src/umockdev-ioctl.vala"
	_vala_assert ((offset + sizeof (gsize)) <= ((gsize) _tmp1__length1), "offset + sizeof(size_t) <= data.length");
#line 166 "../src/umockdev-ioctl.vala"
	_tmp2_ = _g_object_ref0 (child);
#line 166 "../src/umockdev-ioctl.vala"
	_vala_array_add3 (&self->priv->children, &self->priv->children_length1, &self->priv->_children_size_, _tmp2_);
#line 167 "../src/umockdev-ioctl.vala"
	_vala_array_add4 (&self->priv->children_offset, &self->priv->children_offset_length1, &self->priv->_children_offset_size_, offset);
#line 169 "../src/umockdev-ioctl.vala"
	_tmp3_ = self->data;
#line 169 "../src/umockdev-ioctl.vala"
	_tmp3__length1 = self->data_len;
#line 169 "../src/umockdev-ioctl.vala"
	_tmp4_ = child->data;
#line 169 "../src/umockdev-ioctl.vala"
	_tmp4__length1 = child->data_len;
#line 169 "../src/umockdev-ioctl.vala"
	*((gsize*) (&_tmp3_[offset])) = (gsize) _tmp4_;
#line 171 "../src/umockdev-ioctl.vala"
	result = TRUE;
#line 171 "../src/umockdev-ioctl.vala"
	return result;
#line 1320 "umockdev-ioctl.c"
}

/**
     * umockdev_ioctl_data_reload:
     * @self: A #UMockdevIoctlData
     * @error: return location for a GError, or %NULL
     *
     * This function allows reloading the data from the client side in case
     * you expect client modifications to have happened in the meantime (e.g.
     * between two separate ioctl's).
     * It is very unlikely that such an explicit reload is needed.
     *
     * Doing this unresolves any resolved pointers. Take care to re-resolve
     * them and use the newly resolved #UMockdevIoctlData in case you need to
     * access the data.
     *
     * Returns: #TRUE on success, #FALSE otherwise
     * Since: 0.16
     */
gboolean
umockdev_ioctl_data_reload (UMockdevIoctlData* self,
                            GError** error)
{
	gint _tmp2_;
	gint _tmp3_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 191 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 192 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_data_load_data (self, &_inner_error0_);
#line 192 "../src/umockdev-ioctl.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 192 "../src/umockdev-ioctl.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 1356 "umockdev-ioctl.c"
			gboolean _tmp0_ = FALSE;
#line 192 "../src/umockdev-ioctl.vala"
			g_propagate_error (error, _inner_error0_);
#line 192 "../src/umockdev-ioctl.vala"
			return _tmp0_;
#line 1362 "umockdev-ioctl.c"
		} else {
			gboolean _tmp1_ = FALSE;
#line 192 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 192 "../src/umockdev-ioctl.vala"
			g_clear_error (&_inner_error0_);
#line 192 "../src/umockdev-ioctl.vala"
			return _tmp1_;
#line 1371 "umockdev-ioctl.c"
		}
	}
#line 194 "../src/umockdev-ioctl.vala"
	_tmp2_ = 0;
#line 194 "../src/umockdev-ioctl.vala"
	self->priv->children = g_renew (UMockdevIoctlData*, self->priv->children, 0);
#line 194 "../src/umockdev-ioctl.vala"
	(_tmp2_ > self->priv->children_length1) ? memset (self->priv->children + self->priv->children_length1, 0, sizeof (UMockdevIoctlData*) * (_tmp2_ - self->priv->children_length1)) : NULL;
#line 194 "../src/umockdev-ioctl.vala"
	self->priv->children_length1 = _tmp2_;
#line 194 "../src/umockdev-ioctl.vala"
	self->priv->_children_size_ = _tmp2_;
#line 195 "../src/umockdev-ioctl.vala"
	_tmp3_ = 0;
#line 195 "../src/umockdev-ioctl.vala"
	self->priv->children_offset = g_renew (gsize, self->priv->children_offset, 0);
#line 195 "../src/umockdev-ioctl.vala"
	(_tmp3_ > self->priv->children_offset_length1) ? memset (self->priv->children_offset + self->priv->children_offset_length1, 0, sizeof (gsize) * (_tmp3_ - self->priv->children_offset_length1)) : NULL;
#line 195 "../src/umockdev-ioctl.vala"
	self->priv->children_offset_length1 = _tmp3_;
#line 195 "../src/umockdev-ioctl.vala"
	self->priv->_children_offset_size_ = _tmp3_;
#line 197 "../src/umockdev-ioctl.vala"
	result = TRUE;
#line 197 "../src/umockdev-ioctl.vala"
	return result;
#line 1398 "umockdev-ioctl.c"
}

/**
     * umockdev_ioctl_update:
     * @self: A #UMockdevIoctlData
     * @offset: Offset into data
     * @new_data: (array length=length): Data to set
     * @new_data_length1: Lenght of binary data, must be smaller or equal to actual length
     *
     * Set data to a specific value. This is essentially a memcpy call, it is
     * only useful for e.g. python where the bindings cannot make the data
     * writable otherwise.
     *
     * Since: 0.18
     */
void
umockdev_ioctl_data_update (UMockdevIoctlData* self,
                            gsize offset,
                            guint8* new_data,
                            gint new_data_length1)
{
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint8* _tmp1_;
	gint _tmp1__length1;
#line 213 "../src/umockdev-ioctl.vala"
	g_return_if_fail (self != NULL);
#line 214 "../src/umockdev-ioctl.vala"
	_tmp0_ = self->data;
#line 214 "../src/umockdev-ioctl.vala"
	_tmp0__length1 = self->data_len;
#line 214 "../src/umockdev-ioctl.vala"
	_vala_assert ((offset + new_data_length1) <= ((gsize) _tmp0__length1), "offset + new_data.length <= data.length");
#line 216 "../src/umockdev-ioctl.vala"
	_tmp1_ = self->data;
#line 216 "../src/umockdev-ioctl.vala"
	_tmp1__length1 = self->data_len;
#line 216 "../src/umockdev-ioctl.vala"
	memcpy (&_tmp1_[offset], new_data, (gsize) new_data_length1);
#line 1438 "umockdev-ioctl.c"
}

/**
     * umockdev_ioctl_retrieve:
     * @self: A #UMockdevIoctlData
     * @read_data: (array length=length) (out): Data to set
     * @read_data_length1: (out): Lenght of binary data, must be smaller or equal to actual length
     *
     * Simply returns the data struct member. This function purely exists for
     * GIR based bindings, as the vala generated bindings do not correctly
     * tag the array length, and direct access to the struct member is not
     * possible.
     *
     * Since: 0.18
     */
static guint8*
_vala_array_dup1 (guint8* self,
                  gssize length)
{
#line 233 "../src/umockdev-ioctl.vala"
	if (length > 0) {
#line 233 "../src/umockdev-ioctl.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 1462 "umockdev-ioctl.c"
	}
#line 233 "../src/umockdev-ioctl.vala"
	return NULL;
#line 1466 "umockdev-ioctl.c"
}

void
umockdev_ioctl_data_retrieve (UMockdevIoctlData* self,
                              guint8** read_data,
                              gint* read_data_length1)
{
	guint8* _vala_read_data = NULL;
	gint _vala_read_data_length1 = 0;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint8* _tmp1_;
	gint _tmp1__length1;
#line 232 "../src/umockdev-ioctl.vala"
	g_return_if_fail (self != NULL);
#line 233 "../src/umockdev-ioctl.vala"
	_tmp0_ = self->data;
#line 233 "../src/umockdev-ioctl.vala"
	_tmp0__length1 = self->data_len;
#line 233 "../src/umockdev-ioctl.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 233 "../src/umockdev-ioctl.vala"
	_tmp1__length1 = _tmp0__length1;
#line 233 "../src/umockdev-ioctl.vala"
	_vala_read_data = (g_free (_vala_read_data), NULL);
#line 233 "../src/umockdev-ioctl.vala"
	_vala_read_data = _tmp1_;
#line 233 "../src/umockdev-ioctl.vala"
	_vala_read_data_length1 = _tmp1__length1;
#line 232 "../src/umockdev-ioctl.vala"
	if (read_data) {
#line 232 "../src/umockdev-ioctl.vala"
		*read_data = _vala_read_data;
#line 1500 "umockdev-ioctl.c"
	} else {
#line 232 "../src/umockdev-ioctl.vala"
		_vala_read_data = (g_free (_vala_read_data), NULL);
#line 1504 "umockdev-ioctl.c"
	}
#line 232 "../src/umockdev-ioctl.vala"
	if (read_data_length1) {
#line 232 "../src/umockdev-ioctl.vala"
		*read_data_length1 = _vala_read_data_length1;
#line 1510 "umockdev-ioctl.c"
	}
}

void
umockdev_ioctl_data_load_data (UMockdevIoctlData* self,
                               GError** error)
{
	GOutputStream* output = NULL;
	GIOStream* _tmp0_;
	GOutputStream* _tmp1_;
	GOutputStream* _tmp2_;
	GInputStream* input = NULL;
	GIOStream* _tmp3_;
	GInputStream* _tmp4_;
	GInputStream* _tmp5_;
	gulong args[3] = {0};
	guint8* _tmp6_;
	gint _tmp6__length1;
	guint8* _tmp7_;
	guint8* _tmp8_;
	gint _tmp8__length1;
	GOutputStream* _tmp9_;
	GInputStream* _tmp10_;
	guint8* _tmp11_;
	gint _tmp11__length1;
	guint8* _tmp12_;
	gint _tmp12__length1;
	guint8* _tmp13_;
	gint _tmp13__length1;
	guint8* _tmp14_;
	gint _tmp14__length1;
	GError* _inner_error0_ = NULL;
#line 236 "../src/umockdev-ioctl.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/umockdev-ioctl.vala"
	_tmp0_ = self->priv->stream;
#line 237 "../src/umockdev-ioctl.vala"
	_tmp1_ = g_io_stream_get_output_stream (_tmp0_);
#line 237 "../src/umockdev-ioctl.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 237 "../src/umockdev-ioctl.vala"
	output = _tmp2_;
#line 238 "../src/umockdev-ioctl.vala"
	_tmp3_ = self->priv->stream;
#line 238 "../src/umockdev-ioctl.vala"
	_tmp4_ = g_io_stream_get_input_stream (_tmp3_);
#line 238 "../src/umockdev-ioctl.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 238 "../src/umockdev-ioctl.vala"
	input = _tmp5_;
#line 242 "../src/umockdev-ioctl.vala"
	if (self->client_addr == ((gulong) 0)) {
#line 243 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (input);
#line 243 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (output);
#line 243 "../src/umockdev-ioctl.vala"
		return;
#line 1569 "umockdev-ioctl.c"
	}
#line 245 "../src/umockdev-ioctl.vala"
	_tmp6_ = self->data;
#line 245 "../src/umockdev-ioctl.vala"
	_tmp6__length1 = self->data_len;
#line 245 "../src/umockdev-ioctl.vala"
	_tmp7_ = g_new0 (guint8, _tmp6__length1);
#line 245 "../src/umockdev-ioctl.vala"
	self->priv->client_data = (g_free (self->priv->client_data), NULL);
#line 245 "../src/umockdev-ioctl.vala"
	self->priv->client_data = _tmp7_;
#line 245 "../src/umockdev-ioctl.vala"
	self->priv->client_data_length1 = _tmp6__length1;
#line 245 "../src/umockdev-ioctl.vala"
	self->priv->_client_data_size_ = self->priv->client_data_length1;
#line 247 "../src/umockdev-ioctl.vala"
	args[0] = (gulong) 5;
#line 248 "../src/umockdev-ioctl.vala"
	args[1] = self->client_addr;
#line 249 "../src/umockdev-ioctl.vala"
	_tmp8_ = self->data;
#line 249 "../src/umockdev-ioctl.vala"
	_tmp8__length1 = self->data_len;
#line 249 "../src/umockdev-ioctl.vala"
	args[2] = (gulong) _tmp8__length1;
#line 251 "../src/umockdev-ioctl.vala"
	_tmp9_ = output;
#line 251 "../src/umockdev-ioctl.vala"
	g_output_stream_write_all (_tmp9_, (guint8*) args, (gsize) ((3 * sizeof (gulong)) / sizeof (guint8)), NULL, NULL, &_inner_error0_);
#line 251 "../src/umockdev-ioctl.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 251 "../src/umockdev-ioctl.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 251 "../src/umockdev-ioctl.vala"
			g_propagate_error (error, _inner_error0_);
#line 251 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (input);
#line 251 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (output);
#line 251 "../src/umockdev-ioctl.vala"
			return;
#line 1611 "umockdev-ioctl.c"
		} else {
#line 251 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (input);
#line 251 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (output);
#line 251 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 251 "../src/umockdev-ioctl.vala"
			g_clear_error (&_inner_error0_);
#line 251 "../src/umockdev-ioctl.vala"
			return;
#line 1623 "umockdev-ioctl.c"
		}
	}
#line 252 "../src/umockdev-ioctl.vala"
	_tmp10_ = input;
#line 252 "../src/umockdev-ioctl.vala"
	_tmp11_ = self->priv->client_data;
#line 252 "../src/umockdev-ioctl.vala"
	_tmp11__length1 = self->priv->client_data_length1;
#line 252 "../src/umockdev-ioctl.vala"
	g_input_stream_read_all (_tmp10_, _tmp11_, (gsize) _tmp11__length1, NULL, NULL, &_inner_error0_);
#line 252 "../src/umockdev-ioctl.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 252 "../src/umockdev-ioctl.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 252 "../src/umockdev-ioctl.vala"
			g_propagate_error (error, _inner_error0_);
#line 252 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (input);
#line 252 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (output);
#line 252 "../src/umockdev-ioctl.vala"
			return;
#line 1646 "umockdev-ioctl.c"
		} else {
#line 252 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (input);
#line 252 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (output);
#line 252 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 252 "../src/umockdev-ioctl.vala"
			g_clear_error (&_inner_error0_);
#line 252 "../src/umockdev-ioctl.vala"
			return;
#line 1658 "umockdev-ioctl.c"
		}
	}
#line 254 "../src/umockdev-ioctl.vala"
	_tmp12_ = self->data;
#line 254 "../src/umockdev-ioctl.vala"
	_tmp12__length1 = self->data_len;
#line 254 "../src/umockdev-ioctl.vala"
	_tmp13_ = self->priv->client_data;
#line 254 "../src/umockdev-ioctl.vala"
	_tmp13__length1 = self->priv->client_data_length1;
#line 254 "../src/umockdev-ioctl.vala"
	_tmp14_ = self->data;
#line 254 "../src/umockdev-ioctl.vala"
	_tmp14__length1 = self->data_len;
#line 254 "../src/umockdev-ioctl.vala"
	memcpy (_tmp12_, _tmp13_, (gsize) _tmp14__length1);
#line 236 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (input);
#line 236 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (output);
#line 1679 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_data_flush_data_free (gpointer _data)
{
	UmockdevIoctlDataFlushData* _data_;
	_data_ = _data;
#line 46 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (_data_->self);
#line 46 "../src/umockdev-ioctl.vala"
	g_slice_free (UmockdevIoctlDataFlushData, _data_);
#line 1691 "umockdev-ioctl.c"
}

void
umockdev_ioctl_data_flush (UMockdevIoctlData* self,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	UmockdevIoctlDataFlushData* _data_;
	UMockdevIoctlData* _tmp0_;
#line 46 "../src/umockdev-ioctl.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/umockdev-ioctl.vala"
	_data_ = g_slice_new0 (UmockdevIoctlDataFlushData);
#line 46 "../src/umockdev-ioctl.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 46 "../src/umockdev-ioctl.vala"
	g_task_set_task_data (_data_->_async_result, _data_, umockdev_ioctl_data_flush_data_free);
#line 46 "../src/umockdev-ioctl.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 46 "../src/umockdev-ioctl.vala"
	_data_->self = _tmp0_;
#line 46 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_data_flush_co (_data_);
#line 1715 "umockdev-ioctl.c"
}

void
umockdev_ioctl_data_flush_finish (UMockdevIoctlData* self,
                                  GAsyncResult* _res_,
                                  GError** error)
{
	UmockdevIoctlDataFlushData* _data_;
#line 46 "../src/umockdev-ioctl.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 46 "../src/umockdev-ioctl.vala"
	if (NULL == _data_) {
#line 46 "../src/umockdev-ioctl.vala"
		return;
#line 1730 "umockdev-ioctl.c"
	}
}

static guint8*
_vala_array_dup2 (guint8* self,
                  gssize length)
{
#line 262 "../src/umockdev-ioctl.vala"
	if (length > 0) {
#line 262 "../src/umockdev-ioctl.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 1742 "umockdev-ioctl.c"
	}
#line 262 "../src/umockdev-ioctl.vala"
	return NULL;
#line 1746 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_data_flush_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	UmockdevIoctlDataFlushData* _data_;
#line 265 "../src/umockdev-ioctl.vala"
	_data_ = _user_data_;
#line 265 "../src/umockdev-ioctl.vala"
	_data_->_source_object_ = source_object;
#line 265 "../src/umockdev-ioctl.vala"
	_data_->_res_ = _res_;
#line 265 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_data_flush_co (_data_);
#line 1763 "umockdev-ioctl.c"
}

static gboolean
umockdev_ioctl_data_flush_co (UmockdevIoctlDataFlushData* _data_)
{
#line 261 "../src/umockdev-ioctl.vala"
	switch (_data_->_state_) {
#line 261 "../src/umockdev-ioctl.vala"
		case 0:
#line 1773 "umockdev-ioctl.c"
		goto _state_0;
#line 261 "../src/umockdev-ioctl.vala"
		case 1:
#line 1777 "umockdev-ioctl.c"
		goto _state_1;
#line 261 "../src/umockdev-ioctl.vala"
		case 2:
#line 1781 "umockdev-ioctl.c"
		goto _state_2;
#line 261 "../src/umockdev-ioctl.vala"
		case 3:
#line 1785 "umockdev-ioctl.c"
		goto _state_3;
		default:
#line 261 "../src/umockdev-ioctl.vala"
		g_assert_not_reached ();
#line 1790 "umockdev-ioctl.c"
	}
	_state_0:
#line 262 "../src/umockdev-ioctl.vala"
	_data_->_tmp0_ = _data_->self->data;
#line 262 "../src/umockdev-ioctl.vala"
	_data_->_tmp0__length1 = _data_->self->data_len;
#line 262 "../src/umockdev-ioctl.vala"
	_data_->_tmp1_ = (_data_->_tmp0_ != NULL) ? _vala_array_dup2 (_data_->_tmp0_, _data_->_tmp0__length1) : _data_->_tmp0_;
#line 262 "../src/umockdev-ioctl.vala"
	_data_->_tmp1__length1 = _data_->_tmp0__length1;
#line 262 "../src/umockdev-ioctl.vala"
	_data_->submit_data = _data_->_tmp1_;
#line 262 "../src/umockdev-ioctl.vala"
	_data_->submit_data_length1 = _data_->_tmp1__length1;
#line 262 "../src/umockdev-ioctl.vala"
	_data_->_submit_data_size_ = _data_->submit_data_length1;
#line 1807 "umockdev-ioctl.c"
	{
#line 264 "../src/umockdev-ioctl.vala"
		_data_->i = 0;
#line 1811 "umockdev-ioctl.c"
		{
#line 264 "../src/umockdev-ioctl.vala"
			_data_->_tmp2_ = TRUE;
#line 264 "../src/umockdev-ioctl.vala"
			while (TRUE) {
#line 264 "../src/umockdev-ioctl.vala"
				if (!_data_->_tmp2_) {
#line 264 "../src/umockdev-ioctl.vala"
					_data_->_tmp3_ = _data_->i;
#line 264 "../src/umockdev-ioctl.vala"
					_data_->i = _data_->_tmp3_ + 1;
#line 1823 "umockdev-ioctl.c"
				}
#line 264 "../src/umockdev-ioctl.vala"
				_data_->_tmp2_ = FALSE;
#line 264 "../src/umockdev-ioctl.vala"
				_data_->_tmp4_ = _data_->self->priv->children;
#line 264 "../src/umockdev-ioctl.vala"
				_data_->_tmp4__length1 = _data_->self->priv->children_length1;
#line 264 "../src/umockdev-ioctl.vala"
				if (!(_data_->i < _data_->_tmp4__length1)) {
#line 264 "../src/umockdev-ioctl.vala"
					break;
#line 1835 "umockdev-ioctl.c"
				}
#line 265 "../src/umockdev-ioctl.vala"
				_data_->_tmp5_ = _data_->self->priv->children;
#line 265 "../src/umockdev-ioctl.vala"
				_data_->_tmp5__length1 = _data_->self->priv->children_length1;
#line 265 "../src/umockdev-ioctl.vala"
				_data_->_tmp6_ = _data_->_tmp5_[_data_->i];
#line 265 "../src/umockdev-ioctl.vala"
				_data_->_state_ = 1;
#line 265 "../src/umockdev-ioctl.vala"
				umockdev_ioctl_data_flush (_data_->_tmp6_, umockdev_ioctl_data_flush_ready, _data_);
#line 265 "../src/umockdev-ioctl.vala"
				return FALSE;
#line 1849 "umockdev-ioctl.c"
				_state_1:
#line 265 "../src/umockdev-ioctl.vala"
				umockdev_ioctl_data_flush_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 265 "../src/umockdev-ioctl.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 265 "../src/umockdev-ioctl.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 265 "../src/umockdev-ioctl.vala"
					_data_->submit_data = (g_free (_data_->submit_data), NULL);
#line 265 "../src/umockdev-ioctl.vala"
					g_object_unref (_data_->_async_result);
#line 265 "../src/umockdev-ioctl.vala"
					return FALSE;
#line 1863 "umockdev-ioctl.c"
				}
#line 267 "../src/umockdev-ioctl.vala"
				_data_->_tmp7_ = _data_->submit_data;
#line 267 "../src/umockdev-ioctl.vala"
				_data_->_tmp7__length1 = _data_->submit_data_length1;
#line 267 "../src/umockdev-ioctl.vala"
				_data_->_tmp8_ = _data_->self->priv->children_offset;
#line 267 "../src/umockdev-ioctl.vala"
				_data_->_tmp8__length1 = _data_->self->priv->children_offset_length1;
#line 267 "../src/umockdev-ioctl.vala"
				_data_->_tmp9_ = _data_->_tmp8_[_data_->i];
#line 267 "../src/umockdev-ioctl.vala"
				_data_->_tmp10_ = _data_->self->priv->children;
#line 267 "../src/umockdev-ioctl.vala"
				_data_->_tmp10__length1 = _data_->self->priv->children_length1;
#line 267 "../src/umockdev-ioctl.vala"
				_data_->_tmp11_ = _data_->_tmp10_[_data_->i];
#line 267 "../src/umockdev-ioctl.vala"
				*((gsize*) (&_data_->_tmp7_[_data_->_tmp9_])) = (gsize) _data_->_tmp11_->client_addr;
#line 1883 "umockdev-ioctl.c"
			}
		}
	}
#line 270 "../src/umockdev-ioctl.vala"
	if (_data_->self->client_addr != ((gulong) 0)) {
#line 271 "../src/umockdev-ioctl.vala"
		_data_->_tmp14_ = _data_->submit_data;
#line 271 "../src/umockdev-ioctl.vala"
		_data_->_tmp14__length1 = _data_->submit_data_length1;
#line 271 "../src/umockdev-ioctl.vala"
		_data_->_tmp15_ = _data_->self->priv->client_data;
#line 271 "../src/umockdev-ioctl.vala"
		_data_->_tmp15__length1 = _data_->self->priv->client_data_length1;
#line 271 "../src/umockdev-ioctl.vala"
		_data_->_tmp13_ = _data_->_tmp14__length1 == _data_->_tmp15__length1;
#line 1899 "umockdev-ioctl.c"
	} else {
#line 270 "../src/umockdev-ioctl.vala"
		_data_->_tmp13_ = FALSE;
#line 1903 "umockdev-ioctl.c"
	}
#line 270 "../src/umockdev-ioctl.vala"
	if (_data_->_tmp13_) {
#line 272 "../src/umockdev-ioctl.vala"
		_data_->_tmp16_ = _data_->submit_data;
#line 272 "../src/umockdev-ioctl.vala"
		_data_->_tmp16__length1 = _data_->submit_data_length1;
#line 272 "../src/umockdev-ioctl.vala"
		_data_->_tmp17_ = _data_->self->priv->client_data;
#line 272 "../src/umockdev-ioctl.vala"
		_data_->_tmp17__length1 = _data_->self->priv->client_data_length1;
#line 272 "../src/umockdev-ioctl.vala"
		_data_->_tmp18_ = _data_->submit_data;
#line 272 "../src/umockdev-ioctl.vala"
		_data_->_tmp18__length1 = _data_->submit_data_length1;
#line 272 "../src/umockdev-ioctl.vala"
		_data_->_tmp12_ = memcmp (_data_->_tmp16_, _data_->_tmp17_, (gsize) _data_->_tmp18__length1) != 0;
#line 1921 "umockdev-ioctl.c"
	} else {
#line 270 "../src/umockdev-ioctl.vala"
		_data_->_tmp12_ = FALSE;
#line 1925 "umockdev-ioctl.c"
	}
#line 270 "../src/umockdev-ioctl.vala"
	if (_data_->_tmp12_) {
#line 274 "../src/umockdev-ioctl.vala"
		_data_->_tmp19_ = _data_->self->priv->stream;
#line 274 "../src/umockdev-ioctl.vala"
		_data_->_tmp20_ = g_io_stream_get_output_stream (_data_->_tmp19_);
#line 274 "../src/umockdev-ioctl.vala"
		_data_->_tmp21_ = _g_object_ref0 (_data_->_tmp20_);
#line 274 "../src/umockdev-ioctl.vala"
		_data_->output = _data_->_tmp21_;
#line 277 "../src/umockdev-ioctl.vala"
		_data_->args[0] = (gulong) 6;
#line 278 "../src/umockdev-ioctl.vala"
		_data_->args[1] = _data_->self->client_addr;
#line 279 "../src/umockdev-ioctl.vala"
		_data_->_tmp22_ = _data_->submit_data;
#line 279 "../src/umockdev-ioctl.vala"
		_data_->_tmp22__length1 = _data_->submit_data_length1;
#line 279 "../src/umockdev-ioctl.vala"
		_data_->args[2] = (gulong) _data_->_tmp22__length1;
#line 281 "../src/umockdev-ioctl.vala"
		_data_->_tmp23_ = _data_->output;
#line 281 "../src/umockdev-ioctl.vala"
		_data_->_state_ = 2;
#line 281 "../src/umockdev-ioctl.vala"
		g_output_stream_write_all_async (_data_->_tmp23_, (guint8*) _data_->args, (gsize) ((3 * sizeof (gulong)) / sizeof (guint8)), 0, NULL, umockdev_ioctl_data_flush_ready, _data_);
#line 281 "../src/umockdev-ioctl.vala"
		return FALSE;
#line 1955 "umockdev-ioctl.c"
		_state_2:
#line 281 "../src/umockdev-ioctl.vala"
		g_output_stream_write_all_finish (_data_->_tmp23_, _data_->_res_, NULL, &_data_->_inner_error0_);
#line 281 "../src/umockdev-ioctl.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 281 "../src/umockdev-ioctl.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 281 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->output);
#line 281 "../src/umockdev-ioctl.vala"
			_data_->submit_data = (g_free (_data_->submit_data), NULL);
#line 281 "../src/umockdev-ioctl.vala"
			g_object_unref (_data_->_async_result);
#line 281 "../src/umockdev-ioctl.vala"
			return FALSE;
#line 1971 "umockdev-ioctl.c"
		}
#line 282 "../src/umockdev-ioctl.vala"
		_data_->_tmp24_ = _data_->output;
#line 282 "../src/umockdev-ioctl.vala"
		_data_->_tmp25_ = _data_->submit_data;
#line 282 "../src/umockdev-ioctl.vala"
		_data_->_tmp25__length1 = _data_->submit_data_length1;
#line 282 "../src/umockdev-ioctl.vala"
		_data_->_state_ = 3;
#line 282 "../src/umockdev-ioctl.vala"
		g_output_stream_write_all_async (_data_->_tmp24_, _data_->_tmp25_, (gsize) _data_->_tmp25__length1, 0, NULL, umockdev_ioctl_data_flush_ready, _data_);
#line 282 "../src/umockdev-ioctl.vala"
		return FALSE;
#line 1985 "umockdev-ioctl.c"
		_state_3:
#line 282 "../src/umockdev-ioctl.vala"
		g_output_stream_write_all_finish (_data_->_tmp24_, _data_->_res_, NULL, &_data_->_inner_error0_);
#line 282 "../src/umockdev-ioctl.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 282 "../src/umockdev-ioctl.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 282 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->output);
#line 282 "../src/umockdev-ioctl.vala"
			_data_->submit_data = (g_free (_data_->submit_data), NULL);
#line 282 "../src/umockdev-ioctl.vala"
			g_object_unref (_data_->_async_result);
#line 282 "../src/umockdev-ioctl.vala"
			return FALSE;
#line 2001 "umockdev-ioctl.c"
		}
#line 270 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (_data_->output);
#line 2005 "umockdev-ioctl.c"
	}
#line 261 "../src/umockdev-ioctl.vala"
	_data_->submit_data = (g_free (_data_->submit_data), NULL);
#line 261 "../src/umockdev-ioctl.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 261 "../src/umockdev-ioctl.vala"
	if (_data_->_state_ != 0) {
#line 261 "../src/umockdev-ioctl.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 261 "../src/umockdev-ioctl.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2017 "umockdev-ioctl.c"
		}
	}
#line 261 "../src/umockdev-ioctl.vala"
	g_object_unref (_data_->_async_result);
#line 261 "../src/umockdev-ioctl.vala"
	return FALSE;
#line 2024 "umockdev-ioctl.c"
}

static guint8*
_vala_array_dup3 (guint8* self,
                  gssize length)
{
#line 287 "../src/umockdev-ioctl.vala"
	if (length > 0) {
#line 287 "../src/umockdev-ioctl.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 2035 "umockdev-ioctl.c"
	}
#line 287 "../src/umockdev-ioctl.vala"
	return NULL;
#line 2039 "umockdev-ioctl.c"
}

void
umockdev_ioctl_data_flush_sync (UMockdevIoctlData* self,
                                GError** error)
{
	guint8* submit_data = NULL;
	guint8* _tmp0_;
	gint _tmp0__length1;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint submit_data_length1;
	gint _submit_data_size_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 286 "../src/umockdev-ioctl.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/umockdev-ioctl.vala"
	_tmp0_ = self->data;
#line 287 "../src/umockdev-ioctl.vala"
	_tmp0__length1 = self->data_len;
#line 287 "../src/umockdev-ioctl.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup3 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 287 "../src/umockdev-ioctl.vala"
	_tmp1__length1 = _tmp0__length1;
#line 287 "../src/umockdev-ioctl.vala"
	submit_data = _tmp1_;
#line 287 "../src/umockdev-ioctl.vala"
	submit_data_length1 = _tmp1__length1;
#line 287 "../src/umockdev-ioctl.vala"
	_submit_data_size_ = submit_data_length1;
#line 2072 "umockdev-ioctl.c"
	{
		gint i = 0;
#line 289 "../src/umockdev-ioctl.vala"
		i = 0;
#line 2077 "umockdev-ioctl.c"
		{
			gboolean _tmp2_ = FALSE;
#line 289 "../src/umockdev-ioctl.vala"
			_tmp2_ = TRUE;
#line 289 "../src/umockdev-ioctl.vala"
			while (TRUE) {
#line 2084 "umockdev-ioctl.c"
				UMockdevIoctlData** _tmp4_;
				gint _tmp4__length1;
				UMockdevIoctlData** _tmp5_;
				gint _tmp5__length1;
				UMockdevIoctlData* _tmp6_;
				guint8* _tmp7_;
				gint _tmp7__length1;
				gsize* _tmp8_;
				gint _tmp8__length1;
				gsize _tmp9_;
				UMockdevIoctlData** _tmp10_;
				gint _tmp10__length1;
				UMockdevIoctlData* _tmp11_;
#line 289 "../src/umockdev-ioctl.vala"
				if (!_tmp2_) {
#line 2100 "umockdev-ioctl.c"
					gint _tmp3_;
#line 289 "../src/umockdev-ioctl.vala"
					_tmp3_ = i;
#line 289 "../src/umockdev-ioctl.vala"
					i = _tmp3_ + 1;
#line 2106 "umockdev-ioctl.c"
				}
#line 289 "../src/umockdev-ioctl.vala"
				_tmp2_ = FALSE;
#line 289 "../src/umockdev-ioctl.vala"
				_tmp4_ = self->priv->children;
#line 289 "../src/umockdev-ioctl.vala"
				_tmp4__length1 = self->priv->children_length1;
#line 289 "../src/umockdev-ioctl.vala"
				if (!(i < _tmp4__length1)) {
#line 289 "../src/umockdev-ioctl.vala"
					break;
#line 2118 "umockdev-ioctl.c"
				}
#line 290 "../src/umockdev-ioctl.vala"
				_tmp5_ = self->priv->children;
#line 290 "../src/umockdev-ioctl.vala"
				_tmp5__length1 = self->priv->children_length1;
#line 290 "../src/umockdev-ioctl.vala"
				_tmp6_ = _tmp5_[i];
#line 290 "../src/umockdev-ioctl.vala"
				umockdev_ioctl_data_flush_sync (_tmp6_, &_inner_error0_);
#line 290 "../src/umockdev-ioctl.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 290 "../src/umockdev-ioctl.vala"
					if (_inner_error0_->domain == G_IO_ERROR) {
#line 290 "../src/umockdev-ioctl.vala"
						g_propagate_error (error, _inner_error0_);
#line 290 "../src/umockdev-ioctl.vala"
						submit_data = (g_free (submit_data), NULL);
#line 290 "../src/umockdev-ioctl.vala"
						return;
#line 2138 "umockdev-ioctl.c"
					} else {
#line 290 "../src/umockdev-ioctl.vala"
						submit_data = (g_free (submit_data), NULL);
#line 290 "../src/umockdev-ioctl.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 290 "../src/umockdev-ioctl.vala"
						g_clear_error (&_inner_error0_);
#line 290 "../src/umockdev-ioctl.vala"
						return;
#line 2148 "umockdev-ioctl.c"
					}
				}
#line 292 "../src/umockdev-ioctl.vala"
				_tmp7_ = submit_data;
#line 292 "../src/umockdev-ioctl.vala"
				_tmp7__length1 = submit_data_length1;
#line 292 "../src/umockdev-ioctl.vala"
				_tmp8_ = self->priv->children_offset;
#line 292 "../src/umockdev-ioctl.vala"
				_tmp8__length1 = self->priv->children_offset_length1;
#line 292 "../src/umockdev-ioctl.vala"
				_tmp9_ = _tmp8_[i];
#line 292 "../src/umockdev-ioctl.vala"
				_tmp10_ = self->priv->children;
#line 292 "../src/umockdev-ioctl.vala"
				_tmp10__length1 = self->priv->children_length1;
#line 292 "../src/umockdev-ioctl.vala"
				_tmp11_ = _tmp10_[i];
#line 292 "../src/umockdev-ioctl.vala"
				*((gulong*) (&_tmp7_[_tmp9_])) = _tmp11_->client_addr;
#line 2169 "umockdev-ioctl.c"
			}
		}
	}
#line 295 "../src/umockdev-ioctl.vala"
	if (self->client_addr != ((gulong) 0)) {
#line 2175 "umockdev-ioctl.c"
		guint8* _tmp14_;
		gint _tmp14__length1;
		guint8* _tmp15_;
		gint _tmp15__length1;
#line 296 "../src/umockdev-ioctl.vala"
		_tmp14_ = submit_data;
#line 296 "../src/umockdev-ioctl.vala"
		_tmp14__length1 = submit_data_length1;
#line 296 "../src/umockdev-ioctl.vala"
		_tmp15_ = self->priv->client_data;
#line 296 "../src/umockdev-ioctl.vala"
		_tmp15__length1 = self->priv->client_data_length1;
#line 296 "../src/umockdev-ioctl.vala"
		_tmp13_ = _tmp14__length1 == _tmp15__length1;
#line 2190 "umockdev-ioctl.c"
	} else {
#line 295 "../src/umockdev-ioctl.vala"
		_tmp13_ = FALSE;
#line 2194 "umockdev-ioctl.c"
	}
#line 295 "../src/umockdev-ioctl.vala"
	if (_tmp13_) {
#line 2198 "umockdev-ioctl.c"
		guint8* _tmp16_;
		gint _tmp16__length1;
		guint8* _tmp17_;
		gint _tmp17__length1;
		guint8* _tmp18_;
		gint _tmp18__length1;
#line 297 "../src/umockdev-ioctl.vala"
		_tmp16_ = submit_data;
#line 297 "../src/umockdev-ioctl.vala"
		_tmp16__length1 = submit_data_length1;
#line 297 "../src/umockdev-ioctl.vala"
		_tmp17_ = self->priv->client_data;
#line 297 "../src/umockdev-ioctl.vala"
		_tmp17__length1 = self->priv->client_data_length1;
#line 297 "../src/umockdev-ioctl.vala"
		_tmp18_ = submit_data;
#line 297 "../src/umockdev-ioctl.vala"
		_tmp18__length1 = submit_data_length1;
#line 297 "../src/umockdev-ioctl.vala"
		_tmp12_ = memcmp (_tmp16_, _tmp17_, (gsize) _tmp18__length1) != 0;
#line 2219 "umockdev-ioctl.c"
	} else {
#line 295 "../src/umockdev-ioctl.vala"
		_tmp12_ = FALSE;
#line 2223 "umockdev-ioctl.c"
	}
#line 295 "../src/umockdev-ioctl.vala"
	if (_tmp12_) {
#line 2227 "umockdev-ioctl.c"
		GOutputStream* output = NULL;
		GIOStream* _tmp19_;
		GOutputStream* _tmp20_;
		GOutputStream* _tmp21_;
		gulong args[3] = {0};
		guint8* _tmp22_;
		gint _tmp22__length1;
		GOutputStream* _tmp23_;
		GOutputStream* _tmp24_;
		guint8* _tmp25_;
		gint _tmp25__length1;
#line 299 "../src/umockdev-ioctl.vala"
		_tmp19_ = self->priv->stream;
#line 299 "../src/umockdev-ioctl.vala"
		_tmp20_ = g_io_stream_get_output_stream (_tmp19_);
#line 299 "../src/umockdev-ioctl.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 299 "../src/umockdev-ioctl.vala"
		output = _tmp21_;
#line 302 "../src/umockdev-ioctl.vala"
		args[0] = (gulong) 6;
#line 303 "../src/umockdev-ioctl.vala"
		args[1] = self->client_addr;
#line 304 "../src/umockdev-ioctl.vala"
		_tmp22_ = submit_data;
#line 304 "../src/umockdev-ioctl.vala"
		_tmp22__length1 = submit_data_length1;
#line 304 "../src/umockdev-ioctl.vala"
		args[2] = (gulong) _tmp22__length1;
#line 306 "../src/umockdev-ioctl.vala"
		_tmp23_ = output;
#line 306 "../src/umockdev-ioctl.vala"
		g_output_stream_write_all (_tmp23_, (guint8*) args, (gsize) ((3 * sizeof (gulong)) / sizeof (guint8)), NULL, NULL, &_inner_error0_);
#line 306 "../src/umockdev-ioctl.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 306 "../src/umockdev-ioctl.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 306 "../src/umockdev-ioctl.vala"
				g_propagate_error (error, _inner_error0_);
#line 306 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (output);
#line 306 "../src/umockdev-ioctl.vala"
				submit_data = (g_free (submit_data), NULL);
#line 306 "../src/umockdev-ioctl.vala"
				return;
#line 2273 "umockdev-ioctl.c"
			} else {
#line 306 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (output);
#line 306 "../src/umockdev-ioctl.vala"
				submit_data = (g_free (submit_data), NULL);
#line 306 "../src/umockdev-ioctl.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 306 "../src/umockdev-ioctl.vala"
				g_clear_error (&_inner_error0_);
#line 306 "../src/umockdev-ioctl.vala"
				return;
#line 2285 "umockdev-ioctl.c"
			}
		}
#line 307 "../src/umockdev-ioctl.vala"
		_tmp24_ = output;
#line 307 "../src/umockdev-ioctl.vala"
		_tmp25_ = submit_data;
#line 307 "../src/umockdev-ioctl.vala"
		_tmp25__length1 = submit_data_length1;
#line 307 "../src/umockdev-ioctl.vala"
		g_output_stream_write_all (_tmp24_, _tmp25_, (gsize) _tmp25__length1, NULL, NULL, &_inner_error0_);
#line 307 "../src/umockdev-ioctl.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 307 "../src/umockdev-ioctl.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 307 "../src/umockdev-ioctl.vala"
				g_propagate_error (error, _inner_error0_);
#line 307 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (output);
#line 307 "../src/umockdev-ioctl.vala"
				submit_data = (g_free (submit_data), NULL);
#line 307 "../src/umockdev-ioctl.vala"
				return;
#line 2308 "umockdev-ioctl.c"
			} else {
#line 307 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (output);
#line 307 "../src/umockdev-ioctl.vala"
				submit_data = (g_free (submit_data), NULL);
#line 307 "../src/umockdev-ioctl.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 307 "../src/umockdev-ioctl.vala"
				g_clear_error (&_inner_error0_);
#line 307 "../src/umockdev-ioctl.vala"
				return;
#line 2320 "umockdev-ioctl.c"
			}
		}
#line 295 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (output);
#line 2325 "umockdev-ioctl.c"
	}
#line 286 "../src/umockdev-ioctl.vala"
	submit_data = (g_free (submit_data), NULL);
#line 2329 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_data_class_init (UMockdevIoctlDataClass * klass,
                                gpointer klass_data)
{
#line 46 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_data_parent_class = g_type_class_peek_parent (klass);
#line 46 "../src/umockdev-ioctl.vala"
	g_type_class_adjust_private_offset (klass, &UMockdevIoctlData_private_offset);
#line 46 "../src/umockdev-ioctl.vala"
	G_OBJECT_CLASS (klass)->finalize = umockdev_ioctl_data_finalize;
#line 2342 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_data_instance_init (UMockdevIoctlData * self,
                                   gpointer klass)
{
#line 46 "../src/umockdev-ioctl.vala"
	self->priv = umockdev_ioctl_data_get_instance_private (self);
#line 2351 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_data_finalize (GObject * obj)
{
	UMockdevIoctlData * self;
#line 46 "../src/umockdev-ioctl.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UMOCKDEV_TYPE_IOCTL_DATA, UMockdevIoctlData);
#line 51 "../src/umockdev-ioctl.vala"
	self->priv->client_data = (g_free (self->priv->client_data), NULL);
#line 54 "../src/umockdev-ioctl.vala"
	self->data = (g_free (self->data), NULL);
#line 58 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (self->priv->stream);
#line 60 "../src/umockdev-ioctl.vala"
	self->priv->children = (_vala_array_free (self->priv->children, self->priv->children_length1, (GDestroyNotify) g_object_unref), NULL);
#line 61 "../src/umockdev-ioctl.vala"
	self->priv->children_offset = (g_free (self->priv->children_offset), NULL);
#line 46 "../src/umockdev-ioctl.vala"
	G_OBJECT_CLASS (umockdev_ioctl_data_parent_class)->finalize (obj);
#line 2372 "umockdev-ioctl.c"
}

/**
 * UMockdevIoctlData:
 *
 * The #UMockdevIoctlData struct is a container designed to read and write
 * memory from the client process.
 *
 * After memory has been resolved, the corresponding pointer will point to
 * local memory that can be used normally. The memory will automatically be
 * synced back by umockdev_ioctl_client_complete().
 *
 * Since: 0.16
 */
static GType
umockdev_ioctl_data_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UMockdevIoctlDataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) umockdev_ioctl_data_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UMockdevIoctlData), 0, (GInstanceInitFunc) umockdev_ioctl_data_instance_init, NULL };
	GType umockdev_ioctl_data_type_id;
	umockdev_ioctl_data_type_id = g_type_register_static (G_TYPE_OBJECT, "UMockdevIoctlData", &g_define_type_info, 0);
	UMockdevIoctlData_private_offset = g_type_add_instance_private (umockdev_ioctl_data_type_id, sizeof (UMockdevIoctlDataPrivate));
	return umockdev_ioctl_data_type_id;
}

GType
umockdev_ioctl_data_get_type (void)
{
	static volatile gsize umockdev_ioctl_data_type_id__once = 0;
	if (g_once_init_enter (&umockdev_ioctl_data_type_id__once)) {
		GType umockdev_ioctl_data_type_id;
		umockdev_ioctl_data_type_id = umockdev_ioctl_data_get_type_once ();
		g_once_init_leave (&umockdev_ioctl_data_type_id__once, umockdev_ioctl_data_type_id);
	}
	return umockdev_ioctl_data_type_id__once;
}

static inline gpointer
umockdev_ioctl_client_get_instance_private (UMockdevIoctlClient* self)
{
	return G_STRUCT_MEMBER_P (self, UMockdevIoctlClient_private_offset);
}

const gchar*
umockdev_ioctl_client_get_devnode (UMockdevIoctlClient* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 357 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 357 "../src/umockdev-ioctl.vala"
	_tmp0_ = self->priv->_devnode;
#line 357 "../src/umockdev-ioctl.vala"
	result = _tmp0_;
#line 357 "../src/umockdev-ioctl.vala"
	return result;
#line 2428 "umockdev-ioctl.c"
}

gulong
umockdev_ioctl_client_get_request (UMockdevIoctlClient* self)
{
	gulong result;
#line 360 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 360 "../src/umockdev-ioctl.vala"
	result = self->priv->_request;
#line 360 "../src/umockdev-ioctl.vala"
	return result;
#line 2441 "umockdev-ioctl.c"
}

UMockdevIoctlData*
umockdev_ioctl_client_get_arg (UMockdevIoctlClient* self)
{
	UMockdevIoctlData* result;
	UMockdevIoctlData* _tmp0_;
#line 362 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 362 "../src/umockdev-ioctl.vala"
	_tmp0_ = self->priv->_arg;
#line 362 "../src/umockdev-ioctl.vala"
	result = _tmp0_;
#line 362 "../src/umockdev-ioctl.vala"
	return result;
#line 2457 "umockdev-ioctl.c"
}

gboolean
umockdev_ioctl_client_get_connected (UMockdevIoctlClient* self)
{
	gboolean result;
	GIOStream* _tmp0_;
#line 365 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 366 "../src/umockdev-ioctl.vala"
	_tmp0_ = self->priv->stream;
#line 366 "../src/umockdev-ioctl.vala"
	result = !g_io_stream_is_closed (_tmp0_);
#line 366 "../src/umockdev-ioctl.vala"
	return result;
#line 2473 "umockdev-ioctl.c"
}

/**
     * umockdev_ioctl_client_execute:
     * @self: A #UMockdevIoctlClient
     * @errno_: Return location for errno
     * @error: return location for a GError, or %NULL
     *
     * This function is not generally useful. It exists for umockdev itself
     * in order to implement recording.
     *
     * Execute the ioctl on the client side. Note that this flushes any
     * modifications of the ioctl data. As such, pointers that were already
     * resolved (including the initial ioctl argument itself) need to be
     * resolved again.
     *
     * It is only valid to call this while an uncompleted command is being
     * processed.
     *
     * This call is thread-safe.
     *
     * Returns: The client side result of the ioctl call
     *
     * Since: 0.16
     */
gint
umockdev_ioctl_client_execute (UMockdevIoctlClient* self,
                               gint* errno_,
                               GError** error)
{
	gint _vala_errno_ = 0;
	GOutputStream* output = NULL;
	GIOStream* _tmp0_;
	GOutputStream* _tmp1_;
	GOutputStream* _tmp2_;
	GInputStream* input = NULL;
	GIOStream* _tmp3_;
	GInputStream* _tmp4_;
	GInputStream* _tmp5_;
	gulong args[3] = {0};
	UMockdevIoctlData* _tmp6_;
	GOutputStream* _tmp9_;
	GInputStream* _tmp12_;
	gulong _tmp15_;
	UMockdevIoctlData* _tmp16_;
	gulong _tmp19_;
	gulong _tmp20_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 404 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 405 "../src/umockdev-ioctl.vala"
	_tmp0_ = self->priv->stream;
#line 405 "../src/umockdev-ioctl.vala"
	_tmp1_ = g_io_stream_get_output_stream (_tmp0_);
#line 405 "../src/umockdev-ioctl.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 405 "../src/umockdev-ioctl.vala"
	output = _tmp2_;
#line 406 "../src/umockdev-ioctl.vala"
	_tmp3_ = self->priv->stream;
#line 406 "../src/umockdev-ioctl.vala"
	_tmp4_ = g_io_stream_get_input_stream (_tmp3_);
#line 406 "../src/umockdev-ioctl.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 406 "../src/umockdev-ioctl.vala"
	input = _tmp5_;
#line 409 "../src/umockdev-ioctl.vala"
	_vala_assert (self->priv->_cmd != ((gulong) 0), "_cmd != 0");
#line 411 "../src/umockdev-ioctl.vala"
	_tmp6_ = self->priv->_arg;
#line 411 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_data_flush_sync (_tmp6_, &_inner_error0_);
#line 411 "../src/umockdev-ioctl.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 411 "../src/umockdev-ioctl.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 2551 "umockdev-ioctl.c"
			gint _tmp7_ = -1;
#line 411 "../src/umockdev-ioctl.vala"
			g_propagate_error (error, _inner_error0_);
#line 411 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (input);
#line 411 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (output);
#line 411 "../src/umockdev-ioctl.vala"
			return _tmp7_;
#line 2561 "umockdev-ioctl.c"
		} else {
			gint _tmp8_ = -1;
#line 411 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (input);
#line 411 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (output);
#line 411 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 411 "../src/umockdev-ioctl.vala"
			g_clear_error (&_inner_error0_);
#line 411 "../src/umockdev-ioctl.vala"
			return _tmp8_;
#line 2574 "umockdev-ioctl.c"
		}
	}
#line 413 "../src/umockdev-ioctl.vala"
	args[0] = (gulong) 4;
#line 414 "../src/umockdev-ioctl.vala"
	args[1] = (gulong) 0;
#line 415 "../src/umockdev-ioctl.vala"
	args[2] = (gulong) 0;
#line 417 "../src/umockdev-ioctl.vala"
	_tmp9_ = output;
#line 417 "../src/umockdev-ioctl.vala"
	g_output_stream_write_all (_tmp9_, (guint8*) args, (gsize) ((3 * sizeof (gulong)) / sizeof (guint8)), NULL, NULL, &_inner_error0_);
#line 417 "../src/umockdev-ioctl.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 417 "../src/umockdev-ioctl.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 2591 "umockdev-ioctl.c"
			gint _tmp10_ = -1;
#line 417 "../src/umockdev-ioctl.vala"
			g_propagate_error (error, _inner_error0_);
#line 417 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (input);
#line 417 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (output);
#line 417 "../src/umockdev-ioctl.vala"
			return _tmp10_;
#line 2601 "umockdev-ioctl.c"
		} else {
			gint _tmp11_ = -1;
#line 417 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (input);
#line 417 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (output);
#line 417 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 417 "../src/umockdev-ioctl.vala"
			g_clear_error (&_inner_error0_);
#line 417 "../src/umockdev-ioctl.vala"
			return _tmp11_;
#line 2614 "umockdev-ioctl.c"
		}
	}
#line 418 "../src/umockdev-ioctl.vala"
	_tmp12_ = input;
#line 418 "../src/umockdev-ioctl.vala"
	g_input_stream_read_all (_tmp12_, (guint8*) args, (gsize) ((3 * sizeof (gulong)) / sizeof (guint8)), NULL, NULL, &_inner_error0_);
#line 418 "../src/umockdev-ioctl.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 418 "../src/umockdev-ioctl.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 2625 "umockdev-ioctl.c"
			gint _tmp13_ = -1;
#line 418 "../src/umockdev-ioctl.vala"
			g_propagate_error (error, _inner_error0_);
#line 418 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (input);
#line 418 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (output);
#line 418 "../src/umockdev-ioctl.vala"
			return _tmp13_;
#line 2635 "umockdev-ioctl.c"
		} else {
			gint _tmp14_ = -1;
#line 418 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (input);
#line 418 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (output);
#line 418 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 418 "../src/umockdev-ioctl.vala"
			g_clear_error (&_inner_error0_);
#line 418 "../src/umockdev-ioctl.vala"
			return _tmp14_;
#line 2648 "umockdev-ioctl.c"
		}
	}
#line 420 "../src/umockdev-ioctl.vala"
	_tmp15_ = args[0];
#line 420 "../src/umockdev-ioctl.vala"
	_vala_assert (_tmp15_ == ((gulong) 2), "args[0] == 2");
#line 424 "../src/umockdev-ioctl.vala"
	_tmp16_ = self->priv->_arg;
#line 424 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_data_reload (_tmp16_, &_inner_error0_);
#line 424 "../src/umockdev-ioctl.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 424 "../src/umockdev-ioctl.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 2663 "umockdev-ioctl.c"
			gint _tmp17_ = -1;
#line 424 "../src/umockdev-ioctl.vala"
			g_propagate_error (error, _inner_error0_);
#line 424 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (input);
#line 424 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (output);
#line 424 "../src/umockdev-ioctl.vala"
			return _tmp17_;
#line 2673 "umockdev-ioctl.c"
		} else {
			gint _tmp18_ = -1;
#line 424 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (input);
#line 424 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (output);
#line 424 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 424 "../src/umockdev-ioctl.vala"
			g_clear_error (&_inner_error0_);
#line 424 "../src/umockdev-ioctl.vala"
			return _tmp18_;
#line 2686 "umockdev-ioctl.c"
		}
	}
#line 426 "../src/umockdev-ioctl.vala"
	_tmp19_ = args[2];
#line 426 "../src/umockdev-ioctl.vala"
	_vala_errno_ = (gint) _tmp19_;
#line 428 "../src/umockdev-ioctl.vala"
	_tmp20_ = args[1];
#line 428 "../src/umockdev-ioctl.vala"
	result = (gint) _tmp20_;
#line 428 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (input);
#line 428 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (output);
#line 428 "../src/umockdev-ioctl.vala"
	if (errno_) {
#line 428 "../src/umockdev-ioctl.vala"
		*errno_ = _vala_errno_;
#line 2705 "umockdev-ioctl.c"
	}
#line 428 "../src/umockdev-ioctl.vala"
	return result;
#line 2709 "umockdev-ioctl.c"
}

/**
     * umockdev_ioctl_client_complete:
     * @self: A #UMockdevIoctlClient
     * @res: Return value of ioctl
     * @errno_: errno of ioctl
     *
     * Asynchronously completes the ioctl invocation of the client. This is
     * equivalent to calling umockdev_ioctl_client_complete() with the
     * invocation.
     *
     * This call is thread-safe.
     *
     * Since: 0.16
     */
static gboolean
_umockdev_ioctl_client_complete_idle_gsource_func (gpointer self)
{
	gboolean result;
	result = umockdev_ioctl_client_complete_idle ((UMockdevIoctlClient*) self);
#line 455 "../src/umockdev-ioctl.vala"
	return result;
#line 2733 "umockdev-ioctl.c"
}

void
umockdev_ioctl_client_complete (UMockdevIoctlClient* self,
                                glong res,
                                gint errno_)
{
	GMainContext* _tmp0_;
#line 445 "../src/umockdev-ioctl.vala"
	g_return_if_fail (self != NULL);
#line 447 "../src/umockdev-ioctl.vala"
	_vala_assert (self->priv->_cmd != ((gulong) 0), "_cmd != 0");
#line 448 "../src/umockdev-ioctl.vala"
	self->priv->_cmd = (gulong) 0;
#line 449 "../src/umockdev-ioctl.vala"
	self->priv->_request = (gulong) 0;
#line 451 "../src/umockdev-ioctl.vala"
	self->priv->result = res;
#line 452 "../src/umockdev-ioctl.vala"
	self->priv->result_errno = errno_;
#line 455 "../src/umockdev-ioctl.vala"
	_tmp0_ = self->priv->_ctx;
#line 455 "../src/umockdev-ioctl.vala"
	g_main_context_invoke_full (_tmp0_, G_PRIORITY_DEFAULT, _umockdev_ioctl_client_complete_idle_gsource_func, g_object_ref (self), g_object_unref);
#line 2758 "umockdev-ioctl.c"
}

/**
     * umockdev_ioctl_client_abort:
     * @self: A #UMockdevIoctlClient
     *
     * Asynchronously terminates the child by asking it to execute exit(1).
     *
     * This call is thread-safe.
     *
     * Since: 0.16
     */
void
umockdev_ioctl_client_abort (UMockdevIoctlClient* self)
{
#line 468 "../src/umockdev-ioctl.vala"
	g_return_if_fail (self != NULL);
#line 469 "../src/umockdev-ioctl.vala"
	self->priv->_abort = TRUE;
#line 471 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_client_complete (self, (glong) 0, 0);
#line 2780 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_client_complete_async_data_free (gpointer _data)
{
	UmockdevIoctlClientCompleteAsyncData* _data_;
	_data_ = _data;
#line 351 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (_data_->self);
#line 351 "../src/umockdev-ioctl.vala"
	g_slice_free (UmockdevIoctlClientCompleteAsyncData, _data_);
#line 2792 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_client_complete_async (UMockdevIoctlClient* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	UmockdevIoctlClientCompleteAsyncData* _data_;
	UMockdevIoctlClient* _tmp0_;
#line 351 "../src/umockdev-ioctl.vala"
	g_return_if_fail (self != NULL);
#line 351 "../src/umockdev-ioctl.vala"
	_data_ = g_slice_new0 (UmockdevIoctlClientCompleteAsyncData);
#line 351 "../src/umockdev-ioctl.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 351 "../src/umockdev-ioctl.vala"
	g_task_set_task_data (_data_->_async_result, _data_, umockdev_ioctl_client_complete_async_data_free);
#line 351 "../src/umockdev-ioctl.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 351 "../src/umockdev-ioctl.vala"
	_data_->self = _tmp0_;
#line 351 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_client_complete_async_co (_data_);
#line 2816 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_client_complete_finish (UMockdevIoctlClient* self,
                                       GAsyncResult* _res_,
                                       GError** error)
{
	UmockdevIoctlClientCompleteAsyncData* _data_;
#line 351 "../src/umockdev-ioctl.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 351 "../src/umockdev-ioctl.vala"
	if (NULL == _data_) {
#line 351 "../src/umockdev-ioctl.vala"
		return;
#line 2831 "umockdev-ioctl.c"
	}
}

static void
umockdev_ioctl_client_complete_async_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	UmockdevIoctlClientCompleteAsyncData* _data_;
#line 478 "../src/umockdev-ioctl.vala"
	_data_ = _user_data_;
#line 478 "../src/umockdev-ioctl.vala"
	_data_->_source_object_ = source_object;
#line 478 "../src/umockdev-ioctl.vala"
	_data_->_res_ = _res_;
#line 478 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_client_complete_async_co (_data_);
#line 2849 "umockdev-ioctl.c"
}

static gboolean
umockdev_ioctl_client_complete_async_co (UmockdevIoctlClientCompleteAsyncData* _data_)
{
#line 474 "../src/umockdev-ioctl.vala"
	switch (_data_->_state_) {
#line 474 "../src/umockdev-ioctl.vala"
		case 0:
#line 2859 "umockdev-ioctl.c"
		goto _state_0;
#line 474 "../src/umockdev-ioctl.vala"
		case 1:
#line 2863 "umockdev-ioctl.c"
		goto _state_1;
#line 474 "../src/umockdev-ioctl.vala"
		case 2:
#line 2867 "umockdev-ioctl.c"
		goto _state_2;
		default:
#line 474 "../src/umockdev-ioctl.vala"
		g_assert_not_reached ();
#line 2872 "umockdev-ioctl.c"
	}
	_state_0:
#line 475 "../src/umockdev-ioctl.vala"
	_data_->_tmp0_ = _data_->self->priv->stream;
#line 475 "../src/umockdev-ioctl.vala"
	_data_->_tmp1_ = g_io_stream_get_output_stream (_data_->_tmp0_);
#line 475 "../src/umockdev-ioctl.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->_tmp1_);
#line 475 "../src/umockdev-ioctl.vala"
	_data_->output = _data_->_tmp2_;
#line 478 "../src/umockdev-ioctl.vala"
	_data_->_tmp3_ = _data_->self->priv->_arg;
#line 478 "../src/umockdev-ioctl.vala"
	_data_->_state_ = 1;
#line 478 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_data_flush (_data_->_tmp3_, umockdev_ioctl_client_complete_async_ready, _data_);
#line 478 "../src/umockdev-ioctl.vala"
	return FALSE;
#line 2891 "umockdev-ioctl.c"
	_state_1:
#line 478 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_data_flush_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error0_);
#line 478 "../src/umockdev-ioctl.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 478 "../src/umockdev-ioctl.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 478 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (_data_->output);
#line 478 "../src/umockdev-ioctl.vala"
		g_object_unref (_data_->_async_result);
#line 478 "../src/umockdev-ioctl.vala"
		return FALSE;
#line 2905 "umockdev-ioctl.c"
	}
#line 480 "../src/umockdev-ioctl.vala"
	if (!_data_->self->priv->_abort) {
#line 481 "../src/umockdev-ioctl.vala"
		_data_->args[0] = (gulong) 3;
#line 482 "../src/umockdev-ioctl.vala"
		_data_->args[1] = (gulong) _data_->self->priv->result;
#line 483 "../src/umockdev-ioctl.vala"
		_data_->args[2] = (gulong) _data_->self->priv->result_errno;
#line 2915 "umockdev-ioctl.c"
	} else {
#line 485 "../src/umockdev-ioctl.vala"
		_data_->args[0] = (gulong) 0xff;
#line 486 "../src/umockdev-ioctl.vala"
		_data_->args[1] = (gulong) 0;
#line 487 "../src/umockdev-ioctl.vala"
		_data_->args[2] = (gulong) 0;
#line 2923 "umockdev-ioctl.c"
	}
#line 491 "../src/umockdev-ioctl.vala"
	_data_->self->priv->_cmd = (gulong) 0;
#line 492 "../src/umockdev-ioctl.vala"
	_data_->self->priv->_request = (gulong) 0;
#line 493 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (_data_->self->priv->_arg);
#line 493 "../src/umockdev-ioctl.vala"
	_data_->self->priv->_arg = NULL;
#line 494 "../src/umockdev-ioctl.vala"
	_data_->self->priv->result = (glong) 0;
#line 495 "../src/umockdev-ioctl.vala"
	_data_->self->priv->result_errno = 0;
#line 497 "../src/umockdev-ioctl.vala"
	_data_->_tmp4_ = _data_->output;
#line 497 "../src/umockdev-ioctl.vala"
	_data_->_state_ = 2;
#line 497 "../src/umockdev-ioctl.vala"
	g_output_stream_write_all_async (_data_->_tmp4_, (guint8*) _data_->args, (gsize) ((3 * sizeof (gulong)) / sizeof (guint8)), 0, NULL, umockdev_ioctl_client_complete_async_ready, _data_);
#line 497 "../src/umockdev-ioctl.vala"
	return FALSE;
#line 2945 "umockdev-ioctl.c"
	_state_2:
#line 497 "../src/umockdev-ioctl.vala"
	g_output_stream_write_all_finish (_data_->_tmp4_, _data_->_res_, NULL, &_data_->_inner_error0_);
#line 497 "../src/umockdev-ioctl.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 497 "../src/umockdev-ioctl.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 497 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (_data_->output);
#line 497 "../src/umockdev-ioctl.vala"
		g_object_unref (_data_->_async_result);
#line 497 "../src/umockdev-ioctl.vala"
		return FALSE;
#line 2959 "umockdev-ioctl.c"
	}
#line 500 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_client_read_ioctl (_data_->self, NULL, NULL);
#line 474 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (_data_->output);
#line 474 "../src/umockdev-ioctl.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 474 "../src/umockdev-ioctl.vala"
	if (_data_->_state_ != 0) {
#line 474 "../src/umockdev-ioctl.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 474 "../src/umockdev-ioctl.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2973 "umockdev-ioctl.c"
		}
	}
#line 474 "../src/umockdev-ioctl.vala"
	g_object_unref (_data_->_async_result);
#line 474 "../src/umockdev-ioctl.vala"
	return FALSE;
#line 2980 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_client_read_ioctl_data_free (gpointer _data)
{
	UmockdevIoctlClientReadIoctlData* _data_;
	_data_ = _data;
#line 351 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (_data_->self);
#line 351 "../src/umockdev-ioctl.vala"
	g_slice_free (UmockdevIoctlClientReadIoctlData, _data_);
#line 2992 "umockdev-ioctl.c"
}

void
umockdev_ioctl_client_read_ioctl (UMockdevIoctlClient* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	UmockdevIoctlClientReadIoctlData* _data_;
	UMockdevIoctlClient* _tmp0_;
#line 351 "../src/umockdev-ioctl.vala"
	g_return_if_fail (self != NULL);
#line 351 "../src/umockdev-ioctl.vala"
	_data_ = g_slice_new0 (UmockdevIoctlClientReadIoctlData);
#line 351 "../src/umockdev-ioctl.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 351 "../src/umockdev-ioctl.vala"
	g_task_set_task_data (_data_->_async_result, _data_, umockdev_ioctl_client_read_ioctl_data_free);
#line 351 "../src/umockdev-ioctl.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 351 "../src/umockdev-ioctl.vala"
	_data_->self = _tmp0_;
#line 351 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_client_read_ioctl_co (_data_);
#line 3016 "umockdev-ioctl.c"
}

void
umockdev_ioctl_client_read_ioctl_finish (UMockdevIoctlClient* self,
                                         GAsyncResult* _res_)
{
	UmockdevIoctlClientReadIoctlData* _data_;
#line 351 "../src/umockdev-ioctl.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3026 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_client_read_ioctl_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	UmockdevIoctlClientReadIoctlData* _data_;
#line 512 "../src/umockdev-ioctl.vala"
	_data_ = _user_data_;
#line 512 "../src/umockdev-ioctl.vala"
	_data_->_source_object_ = source_object;
#line 512 "../src/umockdev-ioctl.vala"
	_data_->_res_ = _res_;
#line 512 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_client_read_ioctl_co (_data_);
#line 3043 "umockdev-ioctl.c"
}

static gboolean
umockdev_ioctl_client_read_ioctl_co (UmockdevIoctlClientReadIoctlData* _data_)
{
#line 505 "../src/umockdev-ioctl.vala"
	switch (_data_->_state_) {
#line 505 "../src/umockdev-ioctl.vala"
		case 0:
#line 3053 "umockdev-ioctl.c"
		goto _state_0;
#line 505 "../src/umockdev-ioctl.vala"
		case 1:
#line 3057 "umockdev-ioctl.c"
		goto _state_1;
#line 505 "../src/umockdev-ioctl.vala"
		case 2:
#line 3061 "umockdev-ioctl.c"
		goto _state_2;
#line 505 "../src/umockdev-ioctl.vala"
		case 3:
#line 3065 "umockdev-ioctl.c"
		goto _state_3;
		default:
#line 505 "../src/umockdev-ioctl.vala"
		g_assert_not_reached ();
#line 3070 "umockdev-ioctl.c"
	}
	_state_0:
#line 507 "../src/umockdev-ioctl.vala"
	_data_->_tmp0_ = _data_->self->priv->stream;
#line 507 "../src/umockdev-ioctl.vala"
	_data_->_tmp1_ = g_io_stream_get_input_stream (_data_->_tmp0_);
#line 507 "../src/umockdev-ioctl.vala"
	_data_->_tmp2_ = _g_object_ref0 (_data_->_tmp1_);
#line 507 "../src/umockdev-ioctl.vala"
	_data_->input = _data_->_tmp2_;
#line 3081 "umockdev-ioctl.c"
	{
#line 512 "../src/umockdev-ioctl.vala"
		_data_->_tmp3_ = _data_->input;
#line 512 "../src/umockdev-ioctl.vala"
		_data_->_tmp4_ = 0UL;
#line 512 "../src/umockdev-ioctl.vala"
		_data_->_state_ = 1;
#line 512 "../src/umockdev-ioctl.vala"
		g_input_stream_read_all_async (_data_->_tmp3_, (guint8*) _data_->args, (gsize) ((3 * sizeof (gulong)) / sizeof (guint8)), 0, NULL, umockdev_ioctl_client_read_ioctl_ready, _data_);
#line 512 "../src/umockdev-ioctl.vala"
		return FALSE;
#line 3093 "umockdev-ioctl.c"
		_state_1:
#line 512 "../src/umockdev-ioctl.vala"
		g_input_stream_read_all_finish (_data_->_tmp3_, _data_->_res_, &_data_->_tmp4_, &_data_->_inner_error0_);
#line 512 "../src/umockdev-ioctl.vala"
		_data_->bytes = _data_->_tmp4_;
#line 512 "../src/umockdev-ioctl.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3101 "umockdev-ioctl.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 511 "../src/umockdev-ioctl.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 3110 "umockdev-ioctl.c"
		{
#line 517 "../src/umockdev-ioctl.vala"
			_data_->_tmp5_ = _data_->self->priv->stream;
#line 517 "../src/umockdev-ioctl.vala"
			_data_->_state_ = 2;
#line 517 "../src/umockdev-ioctl.vala"
			g_io_stream_close_async (_data_->_tmp5_, G_PRIORITY_DEFAULT, NULL, umockdev_ioctl_client_read_ioctl_ready, _data_);
#line 517 "../src/umockdev-ioctl.vala"
			return FALSE;
#line 3120 "umockdev-ioctl.c"
			_state_2:
#line 517 "../src/umockdev-ioctl.vala"
			g_io_stream_close_finish (_data_->_tmp5_, _data_->_res_, &_data_->_inner_error0_);
#line 517 "../src/umockdev-ioctl.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 517 "../src/umockdev-ioctl.vala"
				if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 3128 "umockdev-ioctl.c"
					goto __catch1_g_io_error;
				}
#line 517 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (_data_->input);
#line 517 "../src/umockdev-ioctl.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 517 "../src/umockdev-ioctl.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 517 "../src/umockdev-ioctl.vala"
				g_object_unref (_data_->_async_result);
#line 517 "../src/umockdev-ioctl.vala"
				return FALSE;
#line 3141 "umockdev-ioctl.c"
			}
		}
		goto __finally1;
		__catch1_g_io_error:
		{
#line 516 "../src/umockdev-ioctl.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 3149 "umockdev-ioctl.c"
		}
		__finally1:
#line 516 "../src/umockdev-ioctl.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 516 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->input);
#line 516 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 516 "../src/umockdev-ioctl.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 516 "../src/umockdev-ioctl.vala"
			g_object_unref (_data_->_async_result);
#line 516 "../src/umockdev-ioctl.vala"
			return FALSE;
#line 3164 "umockdev-ioctl.c"
		}
#line 519 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (_data_->input);
#line 519 "../src/umockdev-ioctl.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 519 "../src/umockdev-ioctl.vala"
		if (_data_->_state_ != 0) {
#line 519 "../src/umockdev-ioctl.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 519 "../src/umockdev-ioctl.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3176 "umockdev-ioctl.c"
			}
		}
#line 519 "../src/umockdev-ioctl.vala"
		g_object_unref (_data_->_async_result);
#line 519 "../src/umockdev-ioctl.vala"
		return FALSE;
#line 3183 "umockdev-ioctl.c"
	}
	__finally0:
#line 511 "../src/umockdev-ioctl.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 511 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (_data_->input);
#line 511 "../src/umockdev-ioctl.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 511 "../src/umockdev-ioctl.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 511 "../src/umockdev-ioctl.vala"
		g_object_unref (_data_->_async_result);
#line 511 "../src/umockdev-ioctl.vala"
		return FALSE;
#line 3198 "umockdev-ioctl.c"
	}
#line 521 "../src/umockdev-ioctl.vala"
	_data_->_tmp7_ = _data_->input;
#line 521 "../src/umockdev-ioctl.vala"
	if (g_input_stream_is_closed (_data_->_tmp7_)) {
#line 521 "../src/umockdev-ioctl.vala"
		_data_->_tmp6_ = TRUE;
#line 3206 "umockdev-ioctl.c"
	} else {
#line 521 "../src/umockdev-ioctl.vala"
		_data_->_tmp6_ = _data_->bytes == ((gsize) 0);
#line 3210 "umockdev-ioctl.c"
	}
#line 521 "../src/umockdev-ioctl.vala"
	if (_data_->_tmp6_) {
#line 3214 "umockdev-ioctl.c"
		{
#line 524 "../src/umockdev-ioctl.vala"
			_data_->_tmp8_ = _data_->self->priv->stream;
#line 524 "../src/umockdev-ioctl.vala"
			_data_->_state_ = 3;
#line 524 "../src/umockdev-ioctl.vala"
			g_io_stream_close_async (_data_->_tmp8_, G_PRIORITY_DEFAULT, NULL, umockdev_ioctl_client_read_ioctl_ready, _data_);
#line 524 "../src/umockdev-ioctl.vala"
			return FALSE;
#line 3224 "umockdev-ioctl.c"
			_state_3:
#line 524 "../src/umockdev-ioctl.vala"
			g_io_stream_close_finish (_data_->_tmp8_, _data_->_res_, &_data_->_inner_error0_);
#line 524 "../src/umockdev-ioctl.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 524 "../src/umockdev-ioctl.vala"
				if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 3232 "umockdev-ioctl.c"
					goto __catch2_g_io_error;
				}
#line 524 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (_data_->input);
#line 524 "../src/umockdev-ioctl.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 524 "../src/umockdev-ioctl.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 524 "../src/umockdev-ioctl.vala"
				g_object_unref (_data_->_async_result);
#line 524 "../src/umockdev-ioctl.vala"
				return FALSE;
#line 3245 "umockdev-ioctl.c"
			}
		}
		goto __finally2;
		__catch2_g_io_error:
		{
#line 523 "../src/umockdev-ioctl.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 3253 "umockdev-ioctl.c"
		}
		__finally2:
#line 523 "../src/umockdev-ioctl.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 523 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->input);
#line 523 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 523 "../src/umockdev-ioctl.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 523 "../src/umockdev-ioctl.vala"
			g_object_unref (_data_->_async_result);
#line 523 "../src/umockdev-ioctl.vala"
			return FALSE;
#line 3268 "umockdev-ioctl.c"
		}
#line 526 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (_data_->input);
#line 526 "../src/umockdev-ioctl.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 526 "../src/umockdev-ioctl.vala"
		if (_data_->_state_ != 0) {
#line 526 "../src/umockdev-ioctl.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 526 "../src/umockdev-ioctl.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3280 "umockdev-ioctl.c"
			}
		}
#line 526 "../src/umockdev-ioctl.vala"
		g_object_unref (_data_->_async_result);
#line 526 "../src/umockdev-ioctl.vala"
		return FALSE;
#line 3287 "umockdev-ioctl.c"
	}
#line 529 "../src/umockdev-ioctl.vala"
	_data_->_tmp11_ = _data_->args[0];
#line 529 "../src/umockdev-ioctl.vala"
	if (_data_->_tmp11_ == ((gulong) 1)) {
#line 529 "../src/umockdev-ioctl.vala"
		_data_->_tmp10_ = TRUE;
#line 3295 "umockdev-ioctl.c"
	} else {
#line 529 "../src/umockdev-ioctl.vala"
		_data_->_tmp12_ = _data_->args[0];
#line 529 "../src/umockdev-ioctl.vala"
		_data_->_tmp10_ = _data_->_tmp12_ == ((gulong) 7);
#line 3301 "umockdev-ioctl.c"
	}
#line 529 "../src/umockdev-ioctl.vala"
	if (_data_->_tmp10_) {
#line 529 "../src/umockdev-ioctl.vala"
		_data_->_tmp9_ = TRUE;
#line 3307 "umockdev-ioctl.c"
	} else {
#line 529 "../src/umockdev-ioctl.vala"
		_data_->_tmp13_ = _data_->args[0];
#line 529 "../src/umockdev-ioctl.vala"
		_data_->_tmp9_ = _data_->_tmp13_ == ((gulong) 8);
#line 3313 "umockdev-ioctl.c"
	}
#line 529 "../src/umockdev-ioctl.vala"
	_vala_assert (_data_->_tmp9_, "args[0] == 1 || args[0] == 7 || args[0] == 8");
#line 530 "../src/umockdev-ioctl.vala"
	_data_->_tmp14_ = _data_->args[0];
#line 530 "../src/umockdev-ioctl.vala"
	_data_->self->priv->_cmd = _data_->_tmp14_;
#line 532 "../src/umockdev-ioctl.vala"
	_data_->_tmp15_ = _data_->args[0];
#line 532 "../src/umockdev-ioctl.vala"
	if (_data_->_tmp15_ == ((gulong) 1)) {
#line 533 "../src/umockdev-ioctl.vala"
		_data_->_tmp16_ = _data_->args[1];
#line 533 "../src/umockdev-ioctl.vala"
		_data_->self->priv->_request = _data_->_tmp16_;
#line 534 "../src/umockdev-ioctl.vala"
		_data_->_tmp17_ = _data_->self->priv->stream;
#line 534 "../src/umockdev-ioctl.vala"
		_data_->_tmp18_ = umockdev_ioctl_data_new (_data_->_tmp17_);
#line 534 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (_data_->self->priv->_arg);
#line 534 "../src/umockdev-ioctl.vala"
		_data_->self->priv->_arg = _data_->_tmp18_;
#line 535 "../src/umockdev-ioctl.vala"
		_data_->_tmp19_ = _data_->self->priv->_arg;
#line 535 "../src/umockdev-ioctl.vala"
		_data_->_tmp20_ = g_new0 (guint8, sizeof (gulong));
#line 535 "../src/umockdev-ioctl.vala"
		_data_->_tmp19_->data = (g_free (_data_->_tmp19_->data), NULL);
#line 535 "../src/umockdev-ioctl.vala"
		_data_->_tmp19_->data = _data_->_tmp20_;
#line 535 "../src/umockdev-ioctl.vala"
		_data_->_tmp19_->data_len = sizeof (gulong);
#line 536 "../src/umockdev-ioctl.vala"
		_data_->_tmp21_ = _data_->self->priv->_arg;
#line 536 "../src/umockdev-ioctl.vala"
		_data_->_tmp22_ = _data_->_tmp21_->data;
#line 536 "../src/umockdev-ioctl.vala"
		_data_->_tmp22__length1 = _data_->_tmp21_->data_len;
#line 536 "../src/umockdev-ioctl.vala"
		_data_->_tmp23_ = _data_->args[2];
#line 536 "../src/umockdev-ioctl.vala"
		*((gulong*) _data_->_tmp22_) = _data_->_tmp23_;
#line 3357 "umockdev-ioctl.c"
	} else {
#line 538 "../src/umockdev-ioctl.vala"
		_data_->self->priv->_request = (gulong) 0;
#line 539 "../src/umockdev-ioctl.vala"
		_data_->_tmp24_ = _data_->self->priv->stream;
#line 539 "../src/umockdev-ioctl.vala"
		_data_->_tmp25_ = umockdev_ioctl_data_new (_data_->_tmp24_);
#line 539 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (_data_->self->priv->_arg);
#line 539 "../src/umockdev-ioctl.vala"
		_data_->self->priv->_arg = _data_->_tmp25_;
#line 540 "../src/umockdev-ioctl.vala"
		_data_->_tmp26_ = _data_->self->priv->_arg;
#line 540 "../src/umockdev-ioctl.vala"
		_data_->_tmp27_ = _data_->args[2];
#line 540 "../src/umockdev-ioctl.vala"
		_data_->_tmp28_ = g_new0 (guint8, _data_->_tmp27_);
#line 540 "../src/umockdev-ioctl.vala"
		_data_->_tmp26_->data = (g_free (_data_->_tmp26_->data), NULL);
#line 540 "../src/umockdev-ioctl.vala"
		_data_->_tmp26_->data = _data_->_tmp28_;
#line 540 "../src/umockdev-ioctl.vala"
		_data_->_tmp26_->data_len = _data_->_tmp27_;
#line 541 "../src/umockdev-ioctl.vala"
		_data_->_tmp29_ = _data_->self->priv->_arg;
#line 541 "../src/umockdev-ioctl.vala"
		_data_->_tmp30_ = _data_->args[1];
#line 541 "../src/umockdev-ioctl.vala"
		_data_->_tmp29_->client_addr = _data_->_tmp30_;
#line 3387 "umockdev-ioctl.c"
		{
#line 544 "../src/umockdev-ioctl.vala"
			_data_->_tmp31_ = _data_->self->priv->_arg;
#line 544 "../src/umockdev-ioctl.vala"
			umockdev_ioctl_data_load_data (_data_->_tmp31_, &_data_->_inner_error0_);
#line 544 "../src/umockdev-ioctl.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 544 "../src/umockdev-ioctl.vala"
				if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 3397 "umockdev-ioctl.c"
					goto __catch3_g_io_error;
				}
#line 544 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (_data_->input);
#line 544 "../src/umockdev-ioctl.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 544 "../src/umockdev-ioctl.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 544 "../src/umockdev-ioctl.vala"
				g_object_unref (_data_->_async_result);
#line 544 "../src/umockdev-ioctl.vala"
				return FALSE;
#line 3410 "umockdev-ioctl.c"
			}
		}
		goto __finally3;
		__catch3_g_io_error:
		{
#line 543 "../src/umockdev-ioctl.vala"
			_data_->e = _data_->_inner_error0_;
#line 543 "../src/umockdev-ioctl.vala"
			_data_->_inner_error0_ = NULL;
#line 546 "../src/umockdev-ioctl.vala"
			_data_->_tmp32_ = _data_->e;
#line 546 "../src/umockdev-ioctl.vala"
			_data_->_tmp33_ = _data_->_tmp32_->message;
#line 546 "../src/umockdev-ioctl.vala"
			g_warning ("umockdev-ioctl.vala:546: Error resolving IOCtl data: %s", _data_->_tmp33_);
#line 547 "../src/umockdev-ioctl.vala"
			umockdev_ioctl_client_complete (_data_->self, (glong) -100, 0);
#line 548 "../src/umockdev-ioctl.vala"
			_g_error_free0 (_data_->e);
#line 548 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->input);
#line 548 "../src/umockdev-ioctl.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 548 "../src/umockdev-ioctl.vala"
			if (_data_->_state_ != 0) {
#line 548 "../src/umockdev-ioctl.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 548 "../src/umockdev-ioctl.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3440 "umockdev-ioctl.c"
				}
			}
#line 548 "../src/umockdev-ioctl.vala"
			g_object_unref (_data_->_async_result);
#line 548 "../src/umockdev-ioctl.vala"
			return FALSE;
#line 3447 "umockdev-ioctl.c"
		}
		__finally3:
#line 543 "../src/umockdev-ioctl.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 543 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->input);
#line 543 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 543 "../src/umockdev-ioctl.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 543 "../src/umockdev-ioctl.vala"
			g_object_unref (_data_->_async_result);
#line 543 "../src/umockdev-ioctl.vala"
			return FALSE;
#line 3462 "umockdev-ioctl.c"
		}
	}
#line 552 "../src/umockdev-ioctl.vala"
	_data_->handled = FALSE;
#line 554 "../src/umockdev-ioctl.vala"
	_data_->_tmp34_ = _data_->args[0];
#line 554 "../src/umockdev-ioctl.vala"
	if (_data_->_tmp34_ == ((gulong) 1)) {
#line 555 "../src/umockdev-ioctl.vala"
		_data_->_tmp35_ = FALSE;
#line 555 "../src/umockdev-ioctl.vala"
		g_signal_emit_by_name (_data_->self, "handle-ioctl", &_data_->_tmp35_, NULL);
#line 555 "../src/umockdev-ioctl.vala"
		_data_->handled = _data_->_tmp35_;
#line 3477 "umockdev-ioctl.c"
	} else {
#line 556 "../src/umockdev-ioctl.vala"
		_data_->_tmp36_ = _data_->args[0];
#line 556 "../src/umockdev-ioctl.vala"
		if (_data_->_tmp36_ == ((gulong) 7)) {
#line 557 "../src/umockdev-ioctl.vala"
			_data_->_tmp37_ = FALSE;
#line 557 "../src/umockdev-ioctl.vala"
			g_signal_emit_by_name (_data_->self, "handle-read", &_data_->_tmp37_, NULL);
#line 557 "../src/umockdev-ioctl.vala"
			_data_->handled = _data_->_tmp37_;
#line 3489 "umockdev-ioctl.c"
		} else {
#line 559 "../src/umockdev-ioctl.vala"
			_data_->_tmp38_ = FALSE;
#line 559 "../src/umockdev-ioctl.vala"
			g_signal_emit_by_name (_data_->self, "handle-write", &_data_->_tmp38_, NULL);
#line 559 "../src/umockdev-ioctl.vala"
			_data_->handled = _data_->_tmp38_;
#line 3497 "umockdev-ioctl.c"
		}
	}
#line 561 "../src/umockdev-ioctl.vala"
	if (!_data_->handled) {
#line 562 "../src/umockdev-ioctl.vala"
		_data_->_tmp39_ = _data_->args[0];
#line 562 "../src/umockdev-ioctl.vala"
		if (_data_->_tmp39_ == ((gulong) 1)) {
#line 563 "../src/umockdev-ioctl.vala"
			_data_->_tmp40_ = _data_->self->priv->handler;
#line 563 "../src/umockdev-ioctl.vala"
			_data_->_tmp41_ = FALSE;
#line 563 "../src/umockdev-ioctl.vala"
			g_signal_emit_by_name (_data_->_tmp40_, "handle-ioctl", _data_->self, &_data_->_tmp41_, NULL);
#line 563 "../src/umockdev-ioctl.vala"
			_data_->handled = _data_->_tmp41_;
#line 3514 "umockdev-ioctl.c"
		} else {
#line 564 "../src/umockdev-ioctl.vala"
			_data_->_tmp42_ = _data_->args[0];
#line 564 "../src/umockdev-ioctl.vala"
			if (_data_->_tmp42_ == ((gulong) 7)) {
#line 565 "../src/umockdev-ioctl.vala"
				_data_->_tmp43_ = _data_->self->priv->handler;
#line 565 "../src/umockdev-ioctl.vala"
				_data_->_tmp44_ = FALSE;
#line 565 "../src/umockdev-ioctl.vala"
				g_signal_emit_by_name (_data_->_tmp43_, "handle-read", _data_->self, &_data_->_tmp44_, NULL);
#line 565 "../src/umockdev-ioctl.vala"
				_data_->handled = _data_->_tmp44_;
#line 3528 "umockdev-ioctl.c"
			} else {
#line 567 "../src/umockdev-ioctl.vala"
				_data_->_tmp45_ = _data_->self->priv->handler;
#line 567 "../src/umockdev-ioctl.vala"
				_data_->_tmp46_ = FALSE;
#line 567 "../src/umockdev-ioctl.vala"
				g_signal_emit_by_name (_data_->_tmp45_, "handle-write", _data_->self, &_data_->_tmp46_, NULL);
#line 567 "../src/umockdev-ioctl.vala"
				_data_->handled = _data_->_tmp46_;
#line 3538 "umockdev-ioctl.c"
			}
		}
	}
#line 570 "../src/umockdev-ioctl.vala"
	if (!_data_->handled) {
#line 570 "../src/umockdev-ioctl.vala"
		_data_->_tmp48_ = _data_->args[0];
#line 570 "../src/umockdev-ioctl.vala"
		_data_->_tmp47_ = _data_->_tmp48_ == ((gulong) 1);
#line 3548 "umockdev-ioctl.c"
	} else {
#line 570 "../src/umockdev-ioctl.vala"
		_data_->_tmp47_ = FALSE;
#line 3552 "umockdev-ioctl.c"
	}
#line 570 "../src/umockdev-ioctl.vala"
	if (_data_->_tmp47_) {
#line 571 "../src/umockdev-ioctl.vala"
		_data_->tree = NULL;
#line 572 "../src/umockdev-ioctl.vala"
		_data_->data = NULL;
#line 573 "../src/umockdev-ioctl.vala"
		_data_->size = (gulong) ioctl_data_size_by_id (_data_->self->priv->_request);
#line 574 "../src/umockdev-ioctl.vala"
		_data_->type = (_data_->self->priv->_request >> _IOC_TYPESHIFT) & ((1 << _IOC_TYPEBITS) - 1);
#line 3564 "umockdev-ioctl.c"
		{
#line 579 "../src/umockdev-ioctl.vala"
			if (_data_->size > ((gulong) 0)) {
#line 580 "../src/umockdev-ioctl.vala"
				_data_->_tmp50_ = _data_->self->priv->_arg;
#line 580 "../src/umockdev-ioctl.vala"
				_data_->_tmp51_ = umockdev_ioctl_data_resolve (_data_->_tmp50_, (gsize) 0, (gsize) _data_->size, &_data_->_inner_error0_);
#line 580 "../src/umockdev-ioctl.vala"
				_data_->_tmp49_ = _data_->_tmp51_;
#line 580 "../src/umockdev-ioctl.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 580 "../src/umockdev-ioctl.vala"
					if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 3578 "umockdev-ioctl.c"
						goto __catch4_g_io_error;
					}
#line 580 "../src/umockdev-ioctl.vala"
					_g_object_unref0 (_data_->data);
#line 580 "../src/umockdev-ioctl.vala"
					_ioctl_tree_free0 (_data_->tree);
#line 580 "../src/umockdev-ioctl.vala"
					_g_object_unref0 (_data_->input);
#line 580 "../src/umockdev-ioctl.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 580 "../src/umockdev-ioctl.vala"
					g_clear_error (&_data_->_inner_error0_);
#line 580 "../src/umockdev-ioctl.vala"
					g_object_unref (_data_->_async_result);
#line 580 "../src/umockdev-ioctl.vala"
					return FALSE;
#line 3595 "umockdev-ioctl.c"
				}
#line 580 "../src/umockdev-ioctl.vala"
				_data_->_tmp52_ = _data_->_tmp49_;
#line 580 "../src/umockdev-ioctl.vala"
				_data_->_tmp49_ = NULL;
#line 580 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (_data_->data);
#line 580 "../src/umockdev-ioctl.vala"
				_data_->data = _data_->_tmp52_;
#line 579 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (_data_->_tmp49_);
#line 3607 "umockdev-ioctl.c"
			}
		}
		goto __finally4;
		__catch4_g_io_error:
		{
#line 578 "../src/umockdev-ioctl.vala"
			_data_->_vala1_e = _data_->_inner_error0_;
#line 578 "../src/umockdev-ioctl.vala"
			_data_->_inner_error0_ = NULL;
#line 582 "../src/umockdev-ioctl.vala"
			_data_->_tmp53_ = _data_->_vala1_e;
#line 582 "../src/umockdev-ioctl.vala"
			_data_->_tmp54_ = _data_->_tmp53_->message;
#line 582 "../src/umockdev-ioctl.vala"
			g_warning ("umockdev-ioctl.vala:582: Error resolving IOCtl data: %s", _data_->_tmp54_);
#line 584 "../src/umockdev-ioctl.vala"
			umockdev_ioctl_client_complete (_data_->self, (glong) -100, 0);
#line 585 "../src/umockdev-ioctl.vala"
			_g_error_free0 (_data_->_vala1_e);
#line 585 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->data);
#line 585 "../src/umockdev-ioctl.vala"
			_ioctl_tree_free0 (_data_->tree);
#line 585 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->input);
#line 585 "../src/umockdev-ioctl.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 585 "../src/umockdev-ioctl.vala"
			if (_data_->_state_ != 0) {
#line 585 "../src/umockdev-ioctl.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 585 "../src/umockdev-ioctl.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3641 "umockdev-ioctl.c"
				}
			}
#line 585 "../src/umockdev-ioctl.vala"
			g_object_unref (_data_->_async_result);
#line 585 "../src/umockdev-ioctl.vala"
			return FALSE;
#line 3648 "umockdev-ioctl.c"
		}
		__finally4:
#line 578 "../src/umockdev-ioctl.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 578 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->data);
#line 578 "../src/umockdev-ioctl.vala"
			_ioctl_tree_free0 (_data_->tree);
#line 578 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->input);
#line 578 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 578 "../src/umockdev-ioctl.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 578 "../src/umockdev-ioctl.vala"
			g_object_unref (_data_->_async_result);
#line 578 "../src/umockdev-ioctl.vala"
			return FALSE;
#line 3667 "umockdev-ioctl.c"
		}
#line 588 "../src/umockdev-ioctl.vala"
		if (((gchar) _data_->type) == 'E') {
#line 589 "../src/umockdev-ioctl.vala"
			errno = ENOENT;
#line 3673 "umockdev-ioctl.c"
		} else {
#line 591 "../src/umockdev-ioctl.vala"
			errno = ENOTTY;
#line 3677 "umockdev-ioctl.c"
		}
#line 593 "../src/umockdev-ioctl.vala"
		_data_->_tmp55_ = _data_->tree;
#line 593 "../src/umockdev-ioctl.vala"
		_data_->_tmp56_ = _data_->self->priv->_arg;
#line 593 "../src/umockdev-ioctl.vala"
		_data_->_tmp57_ = _data_->_tmp56_->data;
#line 593 "../src/umockdev-ioctl.vala"
		_data_->_tmp57__length1 = _data_->_tmp56_->data_len;
#line 593 "../src/umockdev-ioctl.vala"
		_data_->_tmp58_ = 0;
#line 593 "../src/umockdev-ioctl.vala"
		ioctl_tree_execute (_data_->_tmp55_, NULL, _data_->self->priv->_request, *((void**) _data_->_tmp57_), &_data_->_tmp58_);
#line 593 "../src/umockdev-ioctl.vala"
		_data_->ret = _data_->_tmp58_;
#line 594 "../src/umockdev-ioctl.vala"
		_data_->my_errno = errno;
#line 595 "../src/umockdev-ioctl.vala"
		errno = 0;
#line 597 "../src/umockdev-ioctl.vala"
		if (_data_->ret != -1) {
#line 598 "../src/umockdev-ioctl.vala"
			_data_->my_errno = 0;
#line 3701 "umockdev-ioctl.c"
		}
#line 601 "../src/umockdev-ioctl.vala"
		umockdev_ioctl_client_complete (_data_->self, (glong) _data_->ret, _data_->my_errno);
#line 570 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (_data_->data);
#line 570 "../src/umockdev-ioctl.vala"
		_ioctl_tree_free0 (_data_->tree);
#line 3709 "umockdev-ioctl.c"
	} else {
#line 602 "../src/umockdev-ioctl.vala"
		if (!_data_->handled) {
#line 603 "../src/umockdev-ioctl.vala"
			umockdev_ioctl_client_complete (_data_->self, (glong) -100, 0);
#line 3715 "umockdev-ioctl.c"
		}
	}
#line 505 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (_data_->input);
#line 505 "../src/umockdev-ioctl.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 505 "../src/umockdev-ioctl.vala"
	if (_data_->_state_ != 0) {
#line 505 "../src/umockdev-ioctl.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 505 "../src/umockdev-ioctl.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3728 "umockdev-ioctl.c"
		}
	}
#line 505 "../src/umockdev-ioctl.vala"
	g_object_unref (_data_->_async_result);
#line 505 "../src/umockdev-ioctl.vala"
	return FALSE;
#line 3735 "umockdev-ioctl.c"
}

static gboolean
umockdev_ioctl_client_complete_idle (UMockdevIoctlClient* self)
{
	gboolean result;
#line 607 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 612 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_client_complete_async (self, NULL, NULL);
#line 614 "../src/umockdev-ioctl.vala"
	result = FALSE;
#line 614 "../src/umockdev-ioctl.vala"
	return result;
#line 3750 "umockdev-ioctl.c"
}

static gboolean
umockdev_ioctl_client_notify_closed_idle (UMockdevIoctlClient* self)
{
	gboolean result;
#line 617 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 619 "../src/umockdev-ioctl.vala"
	g_object_notify ((GObject*) self, "connected");
#line 620 "../src/umockdev-ioctl.vala"
	result = FALSE;
#line 620 "../src/umockdev-ioctl.vala"
	return result;
#line 3765 "umockdev-ioctl.c"
}

static gboolean
_umockdev_ioctl_client_notify_closed_idle_gsource_func (gpointer self)
{
	gboolean result;
	result = umockdev_ioctl_client_notify_closed_idle ((UMockdevIoctlClient*) self);
#line 626 "../src/umockdev-ioctl.vala"
	return result;
#line 3775 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_client_notify_closed_cb (UMockdevIoctlClient* self)
{
	GMainContext* _tmp0_;
#line 623 "../src/umockdev-ioctl.vala"
	g_return_if_fail (self != NULL);
#line 626 "../src/umockdev-ioctl.vala"
	_tmp0_ = self->priv->_ctx;
#line 626 "../src/umockdev-ioctl.vala"
	g_main_context_invoke_full (_tmp0_, G_PRIORITY_DEFAULT, _umockdev_ioctl_client_notify_closed_idle_gsource_func, g_object_ref (self), g_object_unref);
#line 3788 "umockdev-ioctl.c"
}

static gpointer
_g_main_context_ref0 (gpointer self)
{
#line 634 "../src/umockdev-ioctl.vala"
	return self ? g_main_context_ref (self) : NULL;
#line 3796 "umockdev-ioctl.c"
}

UMockdevIoctlClient*
umockdev_ioctl_client_construct (GType object_type,
                                 UMockdevIoctlBase* handler,
                                 GIOStream* stream,
                                 const gchar* devnode)
{
	UMockdevIoctlClient * self = NULL;
	UMockdevIoctlBase* _tmp0_;
	GIOStream* _tmp1_;
	gchar* _tmp2_;
	GMainContext* _tmp3_;
	GMainContext* _tmp4_;
	GIOStream* _tmp5_;
#line 629 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (handler != NULL, NULL);
#line 629 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (stream != NULL, NULL);
#line 629 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (devnode != NULL, NULL);
#line 629 "../src/umockdev-ioctl.vala"
	self = (UMockdevIoctlClient*) g_object_new (object_type, NULL);
#line 631 "../src/umockdev-ioctl.vala"
	_tmp0_ = _g_object_ref0 (handler);
#line 631 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (self->priv->handler);
#line 631 "../src/umockdev-ioctl.vala"
	self->priv->handler = _tmp0_;
#line 632 "../src/umockdev-ioctl.vala"
	_tmp1_ = _g_object_ref0 (stream);
#line 632 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (self->priv->stream);
#line 632 "../src/umockdev-ioctl.vala"
	self->priv->stream = _tmp1_;
#line 633 "../src/umockdev-ioctl.vala"
	_tmp2_ = g_strdup (devnode);
#line 633 "../src/umockdev-ioctl.vala"
	_g_free0 (self->priv->_devnode);
#line 633 "../src/umockdev-ioctl.vala"
	self->priv->_devnode = _tmp2_;
#line 634 "../src/umockdev-ioctl.vala"
	_tmp3_ = g_main_context_get_thread_default ();
#line 634 "../src/umockdev-ioctl.vala"
	_tmp4_ = _g_main_context_ref0 (_tmp3_);
#line 634 "../src/umockdev-ioctl.vala"
	_g_main_context_unref0 (self->priv->_ctx);
#line 634 "../src/umockdev-ioctl.vala"
	self->priv->_ctx = _tmp4_;
#line 637 "../src/umockdev-ioctl.vala"
	_tmp5_ = self->priv->stream;
#line 637 "../src/umockdev-ioctl.vala"
	g_signal_connect_object (_tmp5_, "notify::closed", (GCallback) umockdev_ioctl_client_notify_closed_cb, (GObject*) self, G_CONNECT_SWAPPED);
#line 629 "../src/umockdev-ioctl.vala"
	return self;
#line 3852 "umockdev-ioctl.c"
}

UMockdevIoctlClient*
umockdev_ioctl_client_new (UMockdevIoctlBase* handler,
                           GIOStream* stream,
                           const gchar* devnode)
{
#line 629 "../src/umockdev-ioctl.vala"
	return umockdev_ioctl_client_construct (UMOCKDEV_TYPE_IOCTL_CLIENT, handler, stream, devnode);
#line 3862 "umockdev-ioctl.c"
}

static gboolean
_umockdev_signal_accumulator_true_handled_gsignal_accumulator (GSignalInvocationHint* ihint,
                                                               GValue* return_accu,
                                                               GValue* handler_return,
                                                               void* data)
{
	gboolean result;
	result = umockdev_signal_accumulator_true_handled (ihint, return_accu, handler_return, data);
#line 376 "../src/umockdev-ioctl.vala"
	return result;
#line 3875 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_client_class_init (UMockdevIoctlClientClass * klass,
                                  gpointer klass_data)
{
#line 351 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_client_parent_class = g_type_class_peek_parent (klass);
#line 351 "../src/umockdev-ioctl.vala"
	g_type_class_adjust_private_offset (klass, &UMockdevIoctlClient_private_offset);
#line 351 "../src/umockdev-ioctl.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_umockdev_ioctl_client_get_property;
#line 351 "../src/umockdev-ioctl.vala"
	G_OBJECT_CLASS (klass)->finalize = umockdev_ioctl_client_finalize;
#line 351 "../src/umockdev-ioctl.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UMOCKDEV_IOCTL_CLIENT_DEVNODE_PROPERTY, umockdev_ioctl_client_properties[UMOCKDEV_IOCTL_CLIENT_DEVNODE_PROPERTY] = g_param_spec_string ("devnode", "device node", "The device node the client opened", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 351 "../src/umockdev-ioctl.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UMOCKDEV_IOCTL_CLIENT_REQUEST_PROPERTY, umockdev_ioctl_client_properties[UMOCKDEV_IOCTL_CLIENT_REQUEST_PROPERTY] = g_param_spec_ulong ("request", "request", "The current ioctl request", 0, G_MAXULONG, 0UL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 351 "../src/umockdev-ioctl.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UMOCKDEV_IOCTL_CLIENT_ARG_PROPERTY, umockdev_ioctl_client_properties[UMOCKDEV_IOCTL_CLIENT_ARG_PROPERTY] = g_param_spec_object ("arg", "argument", "The ioctl argument, for read/write the passed buffer", UMOCKDEV_TYPE_IOCTL_DATA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 351 "../src/umockdev-ioctl.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UMOCKDEV_IOCTL_CLIENT_CONNECTED_PROPERTY, umockdev_ioctl_client_properties[UMOCKDEV_IOCTL_CLIENT_CONNECTED_PROPERTY] = g_param_spec_boolean ("connected", "connected", "Whether the client is still connected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 376 "../src/umockdev-ioctl.vala"
	g_signal_new ("handle-ioctl", UMOCKDEV_TYPE_IOCTL_CLIENT, G_SIGNAL_RUN_LAST, (guint) 0, _umockdev_signal_accumulator_true_handled_gsignal_accumulator, NULL, NULL, G_TYPE_BOOLEAN, (guint) 0, NULL);
#line 377 "../src/umockdev-ioctl.vala"
	g_signal_new ("handle-read", UMOCKDEV_TYPE_IOCTL_CLIENT, G_SIGNAL_RUN_LAST, (guint) 0, _umockdev_signal_accumulator_true_handled_gsignal_accumulator, NULL, NULL, G_TYPE_BOOLEAN, (guint) 0, NULL);
#line 378 "../src/umockdev-ioctl.vala"
	g_signal_new ("handle-write", UMOCKDEV_TYPE_IOCTL_CLIENT, G_SIGNAL_RUN_LAST, (guint) 0, _umockdev_signal_accumulator_true_handled_gsignal_accumulator, NULL, NULL, G_TYPE_BOOLEAN, (guint) 0, NULL);
#line 3904 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_client_instance_init (UMockdevIoctlClient * self,
                                     gpointer klass)
{
#line 351 "../src/umockdev-ioctl.vala"
	self->priv = umockdev_ioctl_client_get_instance_private (self);
#line 3913 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_client_finalize (GObject * obj)
{
	UMockdevIoctlClient * self;
	GIOStream* _tmp0_;
#line 351 "../src/umockdev-ioctl.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UMOCKDEV_TYPE_IOCTL_CLIENT, UMockdevIoctlClient);
#line 642 "../src/umockdev-ioctl.vala"
	_tmp0_ = self->priv->stream;
#line 642 "../src/umockdev-ioctl.vala"
	if (!g_io_stream_is_closed (_tmp0_)) {
#line 643 "../src/umockdev-ioctl.vala"
		g_critical ("umockdev-ioctl.vala:643: Destroying IoctlClient with open stream!");
#line 3929 "umockdev-ioctl.c"
	}
#line 352 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (self->priv->handler);
#line 353 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (self->priv->stream);
#line 354 "../src/umockdev-ioctl.vala"
	_g_main_context_unref0 (self->priv->_ctx);
#line 357 "../src/umockdev-ioctl.vala"
	_g_free0 (self->priv->_devnode);
#line 362 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (self->priv->_arg);
#line 351 "../src/umockdev-ioctl.vala"
	G_OBJECT_CLASS (umockdev_ioctl_client_parent_class)->finalize (obj);
#line 3943 "umockdev-ioctl.c"
}

/**
 * UMockdevIoctlClient::handle-write:
 * @client: A #UMockdevIoctlClient
 *
 * Called when a write is requested by the client.
 *
 * This is the per-client signal. See #UMockdevIoctlBase::handle-write on #UMockdevIoctlBase.
 *
 * Since: 0.16
 */
static GType
umockdev_ioctl_client_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UMockdevIoctlClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) umockdev_ioctl_client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UMockdevIoctlClient), 0, (GInstanceInitFunc) umockdev_ioctl_client_instance_init, NULL };
	GType umockdev_ioctl_client_type_id;
	umockdev_ioctl_client_type_id = g_type_register_static (G_TYPE_OBJECT, "UMockdevIoctlClient", &g_define_type_info, 0);
	UMockdevIoctlClient_private_offset = g_type_add_instance_private (umockdev_ioctl_client_type_id, sizeof (UMockdevIoctlClientPrivate));
	return umockdev_ioctl_client_type_id;
}

GType
umockdev_ioctl_client_get_type (void)
{
	static volatile gsize umockdev_ioctl_client_type_id__once = 0;
	if (g_once_init_enter (&umockdev_ioctl_client_type_id__once)) {
		GType umockdev_ioctl_client_type_id;
		umockdev_ioctl_client_type_id = umockdev_ioctl_client_get_type_once ();
		g_once_init_leave (&umockdev_ioctl_client_type_id__once, umockdev_ioctl_client_type_id);
	}
	return umockdev_ioctl_client_type_id__once;
}

static void
_vala_umockdev_ioctl_client_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	UMockdevIoctlClient * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, UMOCKDEV_TYPE_IOCTL_CLIENT, UMockdevIoctlClient);
#line 351 "../src/umockdev-ioctl.vala"
	switch (property_id) {
#line 351 "../src/umockdev-ioctl.vala"
		case UMOCKDEV_IOCTL_CLIENT_DEVNODE_PROPERTY:
#line 351 "../src/umockdev-ioctl.vala"
		g_value_set_string (value, umockdev_ioctl_client_get_devnode (self));
#line 351 "../src/umockdev-ioctl.vala"
		break;
#line 351 "../src/umockdev-ioctl.vala"
		case UMOCKDEV_IOCTL_CLIENT_REQUEST_PROPERTY:
#line 351 "../src/umockdev-ioctl.vala"
		g_value_set_ulong (value, umockdev_ioctl_client_get_request (self));
#line 351 "../src/umockdev-ioctl.vala"
		break;
#line 351 "../src/umockdev-ioctl.vala"
		case UMOCKDEV_IOCTL_CLIENT_ARG_PROPERTY:
#line 351 "../src/umockdev-ioctl.vala"
		g_value_set_object (value, umockdev_ioctl_client_get_arg (self));
#line 351 "../src/umockdev-ioctl.vala"
		break;
#line 351 "../src/umockdev-ioctl.vala"
		case UMOCKDEV_IOCTL_CLIENT_CONNECTED_PROPERTY:
#line 351 "../src/umockdev-ioctl.vala"
		g_value_set_boolean (value, umockdev_ioctl_client_get_connected (self));
#line 351 "../src/umockdev-ioctl.vala"
		break;
#line 4012 "umockdev-ioctl.c"
		default:
#line 351 "../src/umockdev-ioctl.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 351 "../src/umockdev-ioctl.vala"
		break;
#line 4018 "umockdev-ioctl.c"
	}
}

UMockdevStartListenClosure*
umockdev_start_listen_closure_construct (GType object_type,
                                         UMockdevIoctlBase* handler,
                                         GSocketListener* listener,
                                         const gchar* devnode)
{
	UMockdevStartListenClosure* self = NULL;
	UMockdevIoctlBase* _tmp0_;
	GSocketListener* _tmp1_;
	gchar* _tmp2_;
#line 739 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (handler != NULL, NULL);
#line 739 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (listener != NULL, NULL);
#line 739 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (devnode != NULL, NULL);
#line 739 "../src/umockdev-ioctl.vala"
	self = (UMockdevStartListenClosure*) g_type_create_instance (object_type);
#line 740 "../src/umockdev-ioctl.vala"
	_tmp0_ = _g_object_ref0 (handler);
#line 740 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (self->handler);
#line 740 "../src/umockdev-ioctl.vala"
	self->handler = _tmp0_;
#line 741 "../src/umockdev-ioctl.vala"
	_tmp1_ = _g_object_ref0 (listener);
#line 741 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (self->listener);
#line 741 "../src/umockdev-ioctl.vala"
	self->listener = _tmp1_;
#line 742 "../src/umockdev-ioctl.vala"
	_tmp2_ = g_strdup (devnode);
#line 742 "../src/umockdev-ioctl.vala"
	_g_free0 (self->devnode);
#line 742 "../src/umockdev-ioctl.vala"
	self->devnode = _tmp2_;
#line 739 "../src/umockdev-ioctl.vala"
	return self;
#line 4060 "umockdev-ioctl.c"
}

UMockdevStartListenClosure*
umockdev_start_listen_closure_new (UMockdevIoctlBase* handler,
                                   GSocketListener* listener,
                                   const gchar* devnode)
{
#line 739 "../src/umockdev-ioctl.vala"
	return umockdev_start_listen_closure_construct (UMOCKDEV_TYPE_START_LISTEN_CLOSURE, handler, listener, devnode);
#line 4070 "umockdev-ioctl.c"
}

gboolean
umockdev_start_listen_closure_cb (UMockdevStartListenClosure* self)
{
	UMockdevIoctlBase* _tmp0_;
	GSocketListener* _tmp1_;
	const gchar* _tmp2_;
	gboolean result;
#line 745 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 746 "../src/umockdev-ioctl.vala"
	_tmp0_ = self->handler;
#line 746 "../src/umockdev-ioctl.vala"
	_tmp1_ = self->listener;
#line 746 "../src/umockdev-ioctl.vala"
	_tmp2_ = self->devnode;
#line 746 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_base_socket_listen (_tmp0_, _tmp1_, _tmp2_, NULL, NULL);
#line 747 "../src/umockdev-ioctl.vala"
	result = FALSE;
#line 747 "../src/umockdev-ioctl.vala"
	return result;
#line 4094 "umockdev-ioctl.c"
}

static void
umockdev_value_start_listen_closure_init (GValue* value)
{
#line 734 "../src/umockdev-ioctl.vala"
	value->data[0].v_pointer = NULL;
#line 4102 "umockdev-ioctl.c"
}

static void
umockdev_value_start_listen_closure_free_value (GValue* value)
{
#line 734 "../src/umockdev-ioctl.vala"
	if (value->data[0].v_pointer) {
#line 734 "../src/umockdev-ioctl.vala"
		umockdev_start_listen_closure_unref (value->data[0].v_pointer);
#line 4112 "umockdev-ioctl.c"
	}
}

static void
umockdev_value_start_listen_closure_copy_value (const GValue* src_value,
                                                GValue* dest_value)
{
#line 734 "../src/umockdev-ioctl.vala"
	if (src_value->data[0].v_pointer) {
#line 734 "../src/umockdev-ioctl.vala"
		dest_value->data[0].v_pointer = umockdev_start_listen_closure_ref (src_value->data[0].v_pointer);
#line 4124 "umockdev-ioctl.c"
	} else {
#line 734 "../src/umockdev-ioctl.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4128 "umockdev-ioctl.c"
	}
}

static gpointer
umockdev_value_start_listen_closure_peek_pointer (const GValue* value)
{
#line 734 "../src/umockdev-ioctl.vala"
	return value->data[0].v_pointer;
#line 4137 "umockdev-ioctl.c"
}

static gchar*
umockdev_value_start_listen_closure_collect_value (GValue* value,
                                                   guint n_collect_values,
                                                   GTypeCValue* collect_values,
                                                   guint collect_flags)
{
#line 734 "../src/umockdev-ioctl.vala"
	if (collect_values[0].v_pointer) {
#line 4148 "umockdev-ioctl.c"
		UMockdevStartListenClosure * object;
		object = collect_values[0].v_pointer;
#line 734 "../src/umockdev-ioctl.vala"
		if (object->parent_instance.g_class == NULL) {
#line 734 "../src/umockdev-ioctl.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4155 "umockdev-ioctl.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 734 "../src/umockdev-ioctl.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4159 "umockdev-ioctl.c"
		}
#line 734 "../src/umockdev-ioctl.vala"
		value->data[0].v_pointer = umockdev_start_listen_closure_ref (object);
#line 4163 "umockdev-ioctl.c"
	} else {
#line 734 "../src/umockdev-ioctl.vala"
		value->data[0].v_pointer = NULL;
#line 4167 "umockdev-ioctl.c"
	}
#line 734 "../src/umockdev-ioctl.vala"
	return NULL;
#line 4171 "umockdev-ioctl.c"
}

static gchar*
umockdev_value_start_listen_closure_lcopy_value (const GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
	UMockdevStartListenClosure ** object_p;
	object_p = collect_values[0].v_pointer;
#line 734 "../src/umockdev-ioctl.vala"
	if (!object_p) {
#line 734 "../src/umockdev-ioctl.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4186 "umockdev-ioctl.c"
	}
#line 734 "../src/umockdev-ioctl.vala"
	if (!value->data[0].v_pointer) {
#line 734 "../src/umockdev-ioctl.vala"
		*object_p = NULL;
#line 4192 "umockdev-ioctl.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 734 "../src/umockdev-ioctl.vala"
		*object_p = value->data[0].v_pointer;
#line 4196 "umockdev-ioctl.c"
	} else {
#line 734 "../src/umockdev-ioctl.vala"
		*object_p = umockdev_start_listen_closure_ref (value->data[0].v_pointer);
#line 4200 "umockdev-ioctl.c"
	}
#line 734 "../src/umockdev-ioctl.vala"
	return NULL;
#line 4204 "umockdev-ioctl.c"
}

GParamSpec*
umockdev_param_spec_start_listen_closure (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags)
{
	UMockdevParamSpecStartListenClosure* spec;
#line 734 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (g_type_is_a (object_type, UMOCKDEV_TYPE_START_LISTEN_CLOSURE), NULL);
#line 734 "../src/umockdev-ioctl.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 734 "../src/umockdev-ioctl.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 734 "../src/umockdev-ioctl.vala"
	return G_PARAM_SPEC (spec);
#line 4223 "umockdev-ioctl.c"
}

gpointer
umockdev_value_get_start_listen_closure (const GValue* value)
{
#line 734 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UMOCKDEV_TYPE_START_LISTEN_CLOSURE), NULL);
#line 734 "../src/umockdev-ioctl.vala"
	return value->data[0].v_pointer;
#line 4233 "umockdev-ioctl.c"
}

void
umockdev_value_set_start_listen_closure (GValue* value,
                                         gpointer v_object)
{
	UMockdevStartListenClosure * old;
#line 734 "../src/umockdev-ioctl.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UMOCKDEV_TYPE_START_LISTEN_CLOSURE));
#line 734 "../src/umockdev-ioctl.vala"
	old = value->data[0].v_pointer;
#line 734 "../src/umockdev-ioctl.vala"
	if (v_object) {
#line 734 "../src/umockdev-ioctl.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UMOCKDEV_TYPE_START_LISTEN_CLOSURE));
#line 734 "../src/umockdev-ioctl.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 734 "../src/umockdev-ioctl.vala"
		value->data[0].v_pointer = v_object;
#line 734 "../src/umockdev-ioctl.vala"
		umockdev_start_listen_closure_ref (value->data[0].v_pointer);
#line 4255 "umockdev-ioctl.c"
	} else {
#line 734 "../src/umockdev-ioctl.vala"
		value->data[0].v_pointer = NULL;
#line 4259 "umockdev-ioctl.c"
	}
#line 734 "../src/umockdev-ioctl.vala"
	if (old) {
#line 734 "../src/umockdev-ioctl.vala"
		umockdev_start_listen_closure_unref (old);
#line 4265 "umockdev-ioctl.c"
	}
}

void
umockdev_value_take_start_listen_closure (GValue* value,
                                          gpointer v_object)
{
	UMockdevStartListenClosure * old;
#line 734 "../src/umockdev-ioctl.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UMOCKDEV_TYPE_START_LISTEN_CLOSURE));
#line 734 "../src/umockdev-ioctl.vala"
	old = value->data[0].v_pointer;
#line 734 "../src/umockdev-ioctl.vala"
	if (v_object) {
#line 734 "../src/umockdev-ioctl.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UMOCKDEV_TYPE_START_LISTEN_CLOSURE));
#line 734 "../src/umockdev-ioctl.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 734 "../src/umockdev-ioctl.vala"
		value->data[0].v_pointer = v_object;
#line 4286 "umockdev-ioctl.c"
	} else {
#line 734 "../src/umockdev-ioctl.vala"
		value->data[0].v_pointer = NULL;
#line 4290 "umockdev-ioctl.c"
	}
#line 734 "../src/umockdev-ioctl.vala"
	if (old) {
#line 734 "../src/umockdev-ioctl.vala"
		umockdev_start_listen_closure_unref (old);
#line 4296 "umockdev-ioctl.c"
	}
}

static void
umockdev_start_listen_closure_class_init (UMockdevStartListenClosureClass * klass,
                                          gpointer klass_data)
{
#line 734 "../src/umockdev-ioctl.vala"
	umockdev_start_listen_closure_parent_class = g_type_class_peek_parent (klass);
#line 734 "../src/umockdev-ioctl.vala"
	((UMockdevStartListenClosureClass *) klass)->finalize = umockdev_start_listen_closure_finalize;
#line 4308 "umockdev-ioctl.c"
}

static void
umockdev_start_listen_closure_instance_init (UMockdevStartListenClosure * self,
                                             gpointer klass)
{
#line 734 "../src/umockdev-ioctl.vala"
	self->ref_count = 1;
#line 4317 "umockdev-ioctl.c"
}

static void
umockdev_start_listen_closure_finalize (UMockdevStartListenClosure * obj)
{
	UMockdevStartListenClosure * self;
#line 734 "../src/umockdev-ioctl.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UMOCKDEV_TYPE_START_LISTEN_CLOSURE, UMockdevStartListenClosure);
#line 734 "../src/umockdev-ioctl.vala"
	g_signal_handlers_destroy (self);
#line 735 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (self->handler);
#line 736 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (self->listener);
#line 737 "../src/umockdev-ioctl.vala"
	_g_free0 (self->devnode);
#line 4334 "umockdev-ioctl.c"
}

/**
 * UMockdevIoctlBase::handle-write:
 * @handler: A #UMockdevIoctlBase
 * @client: A #UMockdevIoctlClient
 *
 * Called when a write is requested by the client.
 *
 * The written buffer is represented by #UMockdevIoctlClient:arg of @client.
 * Retrieve its length to find out the requested write length. The content of
 * the buffer has already been retrieved, and you can freely use it.
 *
 * See #UMockdevIoctlBase::handle-ioctl for some more information.
 *
 * Returns: #TRUE if the request is being handled, #FALSE otherwise.
 * Since: 0.16
 */
static GType
umockdev_start_listen_closure_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { umockdev_value_start_listen_closure_init, umockdev_value_start_listen_closure_free_value, umockdev_value_start_listen_closure_copy_value, umockdev_value_start_listen_closure_peek_pointer, "p", umockdev_value_start_listen_closure_collect_value, "p", umockdev_value_start_listen_closure_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (UMockdevStartListenClosureClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) umockdev_start_listen_closure_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UMockdevStartListenClosure), 0, (GInstanceInitFunc) umockdev_start_listen_closure_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType umockdev_start_listen_closure_type_id;
	umockdev_start_listen_closure_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UMockdevStartListenClosure", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return umockdev_start_listen_closure_type_id;
}

GType
umockdev_start_listen_closure_get_type (void)
{
	static volatile gsize umockdev_start_listen_closure_type_id__once = 0;
	if (g_once_init_enter (&umockdev_start_listen_closure_type_id__once)) {
		GType umockdev_start_listen_closure_type_id;
		umockdev_start_listen_closure_type_id = umockdev_start_listen_closure_get_type_once ();
		g_once_init_leave (&umockdev_start_listen_closure_type_id__once, umockdev_start_listen_closure_type_id);
	}
	return umockdev_start_listen_closure_type_id__once;
}

gpointer
umockdev_start_listen_closure_ref (gpointer instance)
{
	UMockdevStartListenClosure * self;
	self = instance;
#line 734 "../src/umockdev-ioctl.vala"
	g_atomic_int_inc (&self->ref_count);
#line 734 "../src/umockdev-ioctl.vala"
	return instance;
#line 4385 "umockdev-ioctl.c"
}

void
umockdev_start_listen_closure_unref (gpointer instance)
{
	UMockdevStartListenClosure * self;
	self = instance;
#line 734 "../src/umockdev-ioctl.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 734 "../src/umockdev-ioctl.vala"
		UMOCKDEV_START_LISTEN_CLOSURE_GET_CLASS (self)->finalize (self);
#line 734 "../src/umockdev-ioctl.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4399 "umockdev-ioctl.c"
	}
}

static inline gpointer
umockdev_ioctl_base_get_instance_private (UMockdevIoctlBase* self)
{
	return G_STRUCT_MEMBER_P (self, UMockdevIoctlBase_private_offset);
}

static void
umockdev_ioctl_base_socket_listen_data_free (gpointer _data)
{
	UmockdevIoctlBaseSocketListenData* _data_;
	_data_ = _data;
#line 759 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (_data_->listener);
#line 759 "../src/umockdev-ioctl.vala"
	_g_free0 (_data_->devnode);
#line 759 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (_data_->self);
#line 759 "../src/umockdev-ioctl.vala"
	g_slice_free (UmockdevIoctlBaseSocketListenData, _data_);
#line 4422 "umockdev-ioctl.c"
}

void
umockdev_ioctl_base_socket_listen (UMockdevIoctlBase* self,
                                   GSocketListener* listener,
                                   const gchar* devnode,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	UmockdevIoctlBaseSocketListenData* _data_;
	UMockdevIoctlBase* _tmp0_;
	GSocketListener* _tmp1_;
	gchar* _tmp2_;
#line 759 "../src/umockdev-ioctl.vala"
	g_return_if_fail (self != NULL);
#line 759 "../src/umockdev-ioctl.vala"
	g_return_if_fail (listener != NULL);
#line 759 "../src/umockdev-ioctl.vala"
	g_return_if_fail (devnode != NULL);
#line 759 "../src/umockdev-ioctl.vala"
	_data_ = g_slice_new0 (UmockdevIoctlBaseSocketListenData);
#line 759 "../src/umockdev-ioctl.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 759 "../src/umockdev-ioctl.vala"
	g_task_set_task_data (_data_->_async_result, _data_, umockdev_ioctl_base_socket_listen_data_free);
#line 759 "../src/umockdev-ioctl.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 759 "../src/umockdev-ioctl.vala"
	_data_->self = _tmp0_;
#line 759 "../src/umockdev-ioctl.vala"
	_tmp1_ = _g_object_ref0 (listener);
#line 759 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (_data_->listener);
#line 759 "../src/umockdev-ioctl.vala"
	_data_->listener = _tmp1_;
#line 759 "../src/umockdev-ioctl.vala"
	_tmp2_ = g_strdup (devnode);
#line 759 "../src/umockdev-ioctl.vala"
	_g_free0 (_data_->devnode);
#line 759 "../src/umockdev-ioctl.vala"
	_data_->devnode = _tmp2_;
#line 759 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_base_socket_listen_co (_data_);
#line 4466 "umockdev-ioctl.c"
}

void
umockdev_ioctl_base_socket_listen_finish (UMockdevIoctlBase* self,
                                          GAsyncResult* _res_)
{
	UmockdevIoctlBaseSocketListenData* _data_;
#line 759 "../src/umockdev-ioctl.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4476 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_base_socket_listen_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	UmockdevIoctlBaseSocketListenData* _data_;
#line 788 "../src/umockdev-ioctl.vala"
	_data_ = _user_data_;
#line 788 "../src/umockdev-ioctl.vala"
	_data_->_source_object_ = source_object;
#line 788 "../src/umockdev-ioctl.vala"
	_data_->_res_ = _res_;
#line 788 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_base_socket_listen_co (_data_);
#line 4493 "umockdev-ioctl.c"
}

static gboolean
umockdev_ioctl_base_socket_listen_co (UmockdevIoctlBaseSocketListenData* _data_)
{
#line 776 "../src/umockdev-ioctl.vala"
	switch (_data_->_state_) {
#line 776 "../src/umockdev-ioctl.vala"
		case 0:
#line 4503 "umockdev-ioctl.c"
		goto _state_0;
#line 776 "../src/umockdev-ioctl.vala"
		case 1:
#line 4507 "umockdev-ioctl.c"
		goto _state_1;
		default:
#line 776 "../src/umockdev-ioctl.vala"
		g_assert_not_reached ();
#line 4512 "umockdev-ioctl.c"
	}
	_state_0:
	{
#line 780 "../src/umockdev-ioctl.vala"
		_data_->_tmp0_ = _data_->self->priv->listeners;
#line 780 "../src/umockdev-ioctl.vala"
		g_rec_mutex_lock (&_data_->self->priv->__lock_listeners);
#line 4520 "umockdev-ioctl.c"
		{
#line 781 "../src/umockdev-ioctl.vala"
			_data_->_tmp1_ = _data_->self->priv->listeners;
#line 781 "../src/umockdev-ioctl.vala"
			_data_->_tmp2_ = g_hash_table_lookup (_data_->_tmp1_, _data_->devnode);
#line 781 "../src/umockdev-ioctl.vala"
			_data_->_tmp3_ = _g_object_ref0 ((GCancellable*) _data_->_tmp2_);
#line 781 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->cancellable);
#line 781 "../src/umockdev-ioctl.vala"
			_data_->cancellable = _data_->_tmp3_;
#line 4532 "umockdev-ioctl.c"
		}
		__finally0:
		{
#line 780 "../src/umockdev-ioctl.vala"
			_data_->_tmp4_ = _data_->self->priv->listeners;
#line 780 "../src/umockdev-ioctl.vala"
			g_rec_mutex_unlock (&_data_->self->priv->__lock_listeners);
#line 4540 "umockdev-ioctl.c"
		}
#line 780 "../src/umockdev-ioctl.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 780 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->cancellable);
#line 780 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 780 "../src/umockdev-ioctl.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 780 "../src/umockdev-ioctl.vala"
			g_object_unref (_data_->_async_result);
#line 780 "../src/umockdev-ioctl.vala"
			return FALSE;
#line 4554 "umockdev-ioctl.c"
		}
	}
	{
#line 784 "../src/umockdev-ioctl.vala"
		while (TRUE) {
#line 788 "../src/umockdev-ioctl.vala"
			_data_->_state_ = 1;
#line 788 "../src/umockdev-ioctl.vala"
			g_socket_listener_accept_async (_data_->listener, _data_->cancellable, umockdev_ioctl_base_socket_listen_ready, _data_);
#line 788 "../src/umockdev-ioctl.vala"
			return FALSE;
#line 4566 "umockdev-ioctl.c"
			_state_1:
#line 788 "../src/umockdev-ioctl.vala"
			_data_->_tmp6_ = g_socket_listener_accept_finish (_data_->listener, _data_->_res_, NULL, &_data_->_inner_error0_);
#line 788 "../src/umockdev-ioctl.vala"
			_data_->_tmp5_ = _data_->_tmp6_;
#line 788 "../src/umockdev-ioctl.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 788 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (_data_->client);
#line 788 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (_data_->connection);
#line 4578 "umockdev-ioctl.c"
				goto __catch1_g_error;
			}
#line 788 "../src/umockdev-ioctl.vala"
			_data_->_tmp7_ = _data_->_tmp5_;
#line 788 "../src/umockdev-ioctl.vala"
			_data_->_tmp5_ = NULL;
#line 788 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->connection);
#line 788 "../src/umockdev-ioctl.vala"
			_data_->connection = _data_->_tmp7_;
#line 790 "../src/umockdev-ioctl.vala"
			_data_->_tmp8_ = _data_->connection;
#line 790 "../src/umockdev-ioctl.vala"
			_data_->_tmp9_ = umockdev_ioctl_client_new (_data_->self, (GIOStream*) _data_->_tmp8_, _data_->devnode);
#line 790 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->client);
#line 790 "../src/umockdev-ioctl.vala"
			_data_->client = _data_->_tmp9_;
#line 792 "../src/umockdev-ioctl.vala"
			_data_->_tmp10_ = _data_->client;
#line 792 "../src/umockdev-ioctl.vala"
			g_signal_emit (_data_->self, umockdev_ioctl_base_signals[UMOCKDEV_IOCTL_BASE_CLIENT_CONNECTED_SIGNAL], 0, _data_->_tmp10_);
#line 793 "../src/umockdev-ioctl.vala"
			_data_->_tmp11_ = _data_->client;
#line 793 "../src/umockdev-ioctl.vala"
			umockdev_ioctl_client_read_ioctl (_data_->_tmp11_, NULL, NULL);
#line 784 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->_tmp5_);
#line 784 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->client);
#line 784 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_data_->connection);
#line 4611 "umockdev-ioctl.c"
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 783 "../src/umockdev-ioctl.vala"
		_data_->e = _data_->_inner_error0_;
#line 783 "../src/umockdev-ioctl.vala"
		_data_->_inner_error0_ = NULL;
#line 796 "../src/umockdev-ioctl.vala"
		if (!g_error_matches (_data_->e, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 797 "../src/umockdev-ioctl.vala"
			_data_->_tmp12_ = _data_->e->message;
#line 797 "../src/umockdev-ioctl.vala"
			g_error ("umockdev-ioctl.vala:797: Could not accept new connection: %s", _data_->_tmp12_);
#line 4627 "umockdev-ioctl.c"
		}
#line 783 "../src/umockdev-ioctl.vala"
		_g_error_free0 (_data_->e);
#line 4631 "umockdev-ioctl.c"
	}
	__finally1:
#line 783 "../src/umockdev-ioctl.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 783 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (_data_->cancellable);
#line 783 "../src/umockdev-ioctl.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 783 "../src/umockdev-ioctl.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 783 "../src/umockdev-ioctl.vala"
		g_object_unref (_data_->_async_result);
#line 783 "../src/umockdev-ioctl.vala"
		return FALSE;
#line 4646 "umockdev-ioctl.c"
	}
#line 800 "../src/umockdev-ioctl.vala"
	g_socket_listener_close (_data_->listener);
#line 776 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (_data_->cancellable);
#line 776 "../src/umockdev-ioctl.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 776 "../src/umockdev-ioctl.vala"
	if (_data_->_state_ != 0) {
#line 776 "../src/umockdev-ioctl.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 776 "../src/umockdev-ioctl.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4660 "umockdev-ioctl.c"
		}
	}
#line 776 "../src/umockdev-ioctl.vala"
	g_object_unref (_data_->_async_result);
#line 776 "../src/umockdev-ioctl.vala"
	return FALSE;
#line 4667 "umockdev-ioctl.c"
}

static gboolean
_umockdev_start_listen_closure_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = umockdev_start_listen_closure_cb ((UMockdevStartListenClosure*) self);
#line 830 "../src/umockdev-ioctl.vala"
	return result;
#line 4677 "umockdev-ioctl.c"
}

void
umockdev_ioctl_base_register_path (UMockdevIoctlBase* self,
                                   GMainContext* ctx,
                                   const gchar* devnode,
                                   const gchar* sockpath)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GCancellable* cancellable = NULL;
	GCancellable* _tmp2_;
	GCancellable* _tmp3_;
	gchar* _tmp4_;
	GSocketListener* listener = NULL;
	GSocketAddress* addr = NULL;
	GSocketListener* _tmp5_;
	GUnixSocketAddress* _tmp6_;
	UMockdevStartListenClosure* tmp = NULL;
	GSocketListener* _tmp15_;
	UMockdevStartListenClosure* _tmp16_;
	UMockdevStartListenClosure* _tmp17_;
	GError* _inner_error0_ = NULL;
#line 804 "../src/umockdev-ioctl.vala"
	g_return_if_fail (self != NULL);
#line 804 "../src/umockdev-ioctl.vala"
	g_return_if_fail (devnode != NULL);
#line 804 "../src/umockdev-ioctl.vala"
	g_return_if_fail (sockpath != NULL);
#line 806 "../src/umockdev-ioctl.vala"
	_tmp0_ = g_path_get_dirname (sockpath);
#line 806 "../src/umockdev-ioctl.vala"
	_tmp1_ = _tmp0_;
#line 806 "../src/umockdev-ioctl.vala"
	_vala_assert (g_mkdir_with_parents (_tmp1_, 0755) == 0, "DirUtils.create_with_parents(Path.get_dirname(sockpath), 0755) == 0");
#line 806 "../src/umockdev-ioctl.vala"
	_g_free0 (_tmp1_);
#line 808 "../src/umockdev-ioctl.vala"
	_tmp2_ = g_cancellable_new ();
#line 808 "../src/umockdev-ioctl.vala"
	cancellable = _tmp2_;
#line 810 "../src/umockdev-ioctl.vala"
	_tmp3_ = cancellable;
#line 810 "../src/umockdev-ioctl.vala"
	_tmp4_ = g_strdup (sockpath);
#line 810 "../src/umockdev-ioctl.vala"
	g_object_set_data_full ((GObject*) _tmp3_, "sockpath", _tmp4_, g_free);
#line 817 "../src/umockdev-ioctl.vala"
	_tmp5_ = g_socket_listener_new ();
#line 817 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (listener);
#line 817 "../src/umockdev-ioctl.vala"
	listener = _tmp5_;
#line 818 "../src/umockdev-ioctl.vala"
	_tmp6_ = (GUnixSocketAddress*) g_unix_socket_address_new (sockpath);
#line 818 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (addr);
#line 818 "../src/umockdev-ioctl.vala"
	addr = (GSocketAddress*) _tmp6_;
#line 4737 "umockdev-ioctl.c"
	{
		GSocketListener* _tmp7_;
		GSocketAddress* _tmp8_;
#line 820 "../src/umockdev-ioctl.vala"
		_tmp7_ = listener;
#line 820 "../src/umockdev-ioctl.vala"
		_tmp8_ = addr;
#line 820 "../src/umockdev-ioctl.vala"
		g_socket_listener_add_address (_tmp7_, _tmp8_, G_SOCKET_TYPE_STREAM, G_SOCKET_PROTOCOL_DEFAULT, (GObject*) self, NULL, &_inner_error0_);
#line 820 "../src/umockdev-ioctl.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4749 "umockdev-ioctl.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 819 "../src/umockdev-ioctl.vala"
		g_clear_error (&_inner_error0_);
#line 822 "../src/umockdev-ioctl.vala"
		g_warning ("umockdev-ioctl.vala:822: Error listening on ioctl socket for %s", devnode);
#line 823 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (addr);
#line 823 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (listener);
#line 823 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (cancellable);
#line 823 "../src/umockdev-ioctl.vala"
		return;
#line 4768 "umockdev-ioctl.c"
	}
	__finally0:
#line 819 "../src/umockdev-ioctl.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 819 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (addr);
#line 819 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (listener);
#line 819 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (cancellable);
#line 819 "../src/umockdev-ioctl.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 819 "../src/umockdev-ioctl.vala"
		g_clear_error (&_inner_error0_);
#line 819 "../src/umockdev-ioctl.vala"
		return;
#line 4785 "umockdev-ioctl.c"
	}
	{
		GHashTable* _tmp9_;
#line 826 "../src/umockdev-ioctl.vala"
		_tmp9_ = self->priv->listeners;
#line 826 "../src/umockdev-ioctl.vala"
		g_rec_mutex_lock (&self->priv->__lock_listeners);
#line 4793 "umockdev-ioctl.c"
		{
			GHashTable* _tmp10_;
			gchar* _tmp11_;
			GCancellable* _tmp12_;
			GCancellable* _tmp13_;
#line 827 "../src/umockdev-ioctl.vala"
			_tmp10_ = self->priv->listeners;
#line 827 "../src/umockdev-ioctl.vala"
			_tmp11_ = g_strdup (devnode);
#line 827 "../src/umockdev-ioctl.vala"
			_tmp12_ = cancellable;
#line 827 "../src/umockdev-ioctl.vala"
			_tmp13_ = _g_object_ref0 (_tmp12_);
#line 827 "../src/umockdev-ioctl.vala"
			g_hash_table_insert (_tmp10_, _tmp11_, _tmp13_);
#line 4809 "umockdev-ioctl.c"
		}
		__finally1:
		{
			GHashTable* _tmp14_;
#line 826 "../src/umockdev-ioctl.vala"
			_tmp14_ = self->priv->listeners;
#line 826 "../src/umockdev-ioctl.vala"
			g_rec_mutex_unlock (&self->priv->__lock_listeners);
#line 4818 "umockdev-ioctl.c"
		}
#line 826 "../src/umockdev-ioctl.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 826 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (addr);
#line 826 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (listener);
#line 826 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (cancellable);
#line 826 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 826 "../src/umockdev-ioctl.vala"
			g_clear_error (&_inner_error0_);
#line 826 "../src/umockdev-ioctl.vala"
			return;
#line 4834 "umockdev-ioctl.c"
		}
	}
#line 829 "../src/umockdev-ioctl.vala"
	_tmp15_ = listener;
#line 829 "../src/umockdev-ioctl.vala"
	_tmp16_ = umockdev_start_listen_closure_new (self, _tmp15_, devnode);
#line 829 "../src/umockdev-ioctl.vala"
	tmp = _tmp16_;
#line 830 "../src/umockdev-ioctl.vala"
	_tmp17_ = tmp;
#line 830 "../src/umockdev-ioctl.vala"
	g_main_context_invoke_full (ctx, G_PRIORITY_DEFAULT, _umockdev_start_listen_closure_cb_gsource_func, umockdev_start_listen_closure_ref (_tmp17_), umockdev_start_listen_closure_unref);
#line 804 "../src/umockdev-ioctl.vala"
	_umockdev_start_listen_closure_unref0 (tmp);
#line 804 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (addr);
#line 804 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (listener);
#line 804 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (cancellable);
#line 4855 "umockdev-ioctl.c"
}

static gboolean
___lambda4_ (UMockdevIoctlBase* self,
             const gchar* key,
             GCancellable* val)
{
	gconstpointer _tmp0_;
	gboolean result;
#line 848 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 848 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (val != NULL, FALSE);
#line 849 "../src/umockdev-ioctl.vala"
	g_cancellable_cancel (val);
#line 850 "../src/umockdev-ioctl.vala"
	_tmp0_ = g_object_get_data ((GObject*) val, "sockpath");
#line 850 "../src/umockdev-ioctl.vala"
	unlink ((const gchar*) _tmp0_);
#line 851 "../src/umockdev-ioctl.vala"
	result = TRUE;
#line 851 "../src/umockdev-ioctl.vala"
	return result;
#line 4879 "umockdev-ioctl.c"
}

static gboolean
____lambda4__ghr_func (gconstpointer key,
                       gconstpointer value,
                       gpointer self)
{
	gboolean result;
	result = ___lambda4_ ((UMockdevIoctlBase*) self, (const gchar*) key, (GCancellable*) value);
#line 848 "../src/umockdev-ioctl.vala"
	return result;
#line 4891 "umockdev-ioctl.c"
}

void
umockdev_ioctl_base_unregister_all (UMockdevIoctlBase* self)
{
	GError* _inner_error0_ = NULL;
#line 845 "../src/umockdev-ioctl.vala"
	g_return_if_fail (self != NULL);
#line 4900 "umockdev-ioctl.c"
	{
		GHashTable* _tmp0_;
#line 847 "../src/umockdev-ioctl.vala"
		_tmp0_ = self->priv->listeners;
#line 847 "../src/umockdev-ioctl.vala"
		g_rec_mutex_lock (&self->priv->__lock_listeners);
#line 4907 "umockdev-ioctl.c"
		{
			GHashTable* _tmp1_;
#line 848 "../src/umockdev-ioctl.vala"
			_tmp1_ = self->priv->listeners;
#line 848 "../src/umockdev-ioctl.vala"
			g_hash_table_foreach_remove (_tmp1_, ____lambda4__ghr_func, self);
#line 4914 "umockdev-ioctl.c"
		}
		__finally0:
		{
			GHashTable* _tmp2_;
#line 847 "../src/umockdev-ioctl.vala"
			_tmp2_ = self->priv->listeners;
#line 847 "../src/umockdev-ioctl.vala"
			g_rec_mutex_unlock (&self->priv->__lock_listeners);
#line 4923 "umockdev-ioctl.c"
		}
#line 847 "../src/umockdev-ioctl.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 847 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 847 "../src/umockdev-ioctl.vala"
			g_clear_error (&_inner_error0_);
#line 847 "../src/umockdev-ioctl.vala"
			return;
#line 4933 "umockdev-ioctl.c"
		}
	}
}

static gboolean
umockdev_ioctl_base_real_handle_ioctl (UMockdevIoctlBase* self,
                                       UMockdevIoctlClient* client)
{
	gboolean result;
#line 860 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (client != NULL, FALSE);
#line 861 "../src/umockdev-ioctl.vala"
	result = FALSE;
#line 861 "../src/umockdev-ioctl.vala"
	return result;
#line 4949 "umockdev-ioctl.c"
}

gboolean
umockdev_ioctl_base_handle_ioctl (UMockdevIoctlBase* self,
                                  UMockdevIoctlClient* client)
{
	UMockdevIoctlBaseClass* _klass_;
#line 860 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 860 "../src/umockdev-ioctl.vala"
	_klass_ = UMOCKDEV_IOCTL_BASE_GET_CLASS (self);
#line 860 "../src/umockdev-ioctl.vala"
	if (_klass_->handle_ioctl) {
#line 860 "../src/umockdev-ioctl.vala"
		return _klass_->handle_ioctl (self, client);
#line 4965 "umockdev-ioctl.c"
	}
#line 860 "../src/umockdev-ioctl.vala"
	return FALSE;
#line 4969 "umockdev-ioctl.c"
}

static gboolean
umockdev_ioctl_base_real_handle_read (UMockdevIoctlBase* self,
                                      UMockdevIoctlClient* client)
{
	gboolean result;
#line 864 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (client != NULL, FALSE);
#line 865 "../src/umockdev-ioctl.vala"
	result = FALSE;
#line 865 "../src/umockdev-ioctl.vala"
	return result;
#line 4983 "umockdev-ioctl.c"
}

gboolean
umockdev_ioctl_base_handle_read (UMockdevIoctlBase* self,
                                 UMockdevIoctlClient* client)
{
	UMockdevIoctlBaseClass* _klass_;
#line 864 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 864 "../src/umockdev-ioctl.vala"
	_klass_ = UMOCKDEV_IOCTL_BASE_GET_CLASS (self);
#line 864 "../src/umockdev-ioctl.vala"
	if (_klass_->handle_read) {
#line 864 "../src/umockdev-ioctl.vala"
		return _klass_->handle_read (self, client);
#line 4999 "umockdev-ioctl.c"
	}
#line 864 "../src/umockdev-ioctl.vala"
	return FALSE;
#line 5003 "umockdev-ioctl.c"
}

static gboolean
umockdev_ioctl_base_real_handle_write (UMockdevIoctlBase* self,
                                       UMockdevIoctlClient* client)
{
	gboolean result;
#line 868 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (client != NULL, FALSE);
#line 869 "../src/umockdev-ioctl.vala"
	result = FALSE;
#line 869 "../src/umockdev-ioctl.vala"
	return result;
#line 5017 "umockdev-ioctl.c"
}

gboolean
umockdev_ioctl_base_handle_write (UMockdevIoctlBase* self,
                                  UMockdevIoctlClient* client)
{
	UMockdevIoctlBaseClass* _klass_;
#line 868 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 868 "../src/umockdev-ioctl.vala"
	_klass_ = UMOCKDEV_IOCTL_BASE_GET_CLASS (self);
#line 868 "../src/umockdev-ioctl.vala"
	if (_klass_->handle_write) {
#line 868 "../src/umockdev-ioctl.vala"
		return _klass_->handle_write (self, client);
#line 5033 "umockdev-ioctl.c"
	}
#line 868 "../src/umockdev-ioctl.vala"
	return FALSE;
#line 5037 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_base_real_client_connected (UMockdevIoctlBase* self,
                                           UMockdevIoctlClient* client)
{
#line 872 "../src/umockdev-ioctl.vala"
	g_return_if_fail (client != NULL);
#line 5046 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_base_real_client_vanished (UMockdevIoctlBase* self,
                                          UMockdevIoctlClient* client)
{
#line 875 "../src/umockdev-ioctl.vala"
	g_return_if_fail (client != NULL);
#line 5055 "umockdev-ioctl.c"
}

UMockdevIoctlBase*
umockdev_ioctl_base_construct (GType object_type)
{
	UMockdevIoctlBase * self = NULL;
#line 759 "../src/umockdev-ioctl.vala"
	self = (UMockdevIoctlBase*) g_object_new (object_type, NULL);
#line 759 "../src/umockdev-ioctl.vala"
	return self;
#line 5066 "umockdev-ioctl.c"
}

UMockdevIoctlBase*
umockdev_ioctl_base_new (void)
{
#line 759 "../src/umockdev-ioctl.vala"
	return umockdev_ioctl_base_construct (UMOCKDEV_TYPE_IOCTL_BASE);
#line 5074 "umockdev-ioctl.c"
}

static void
_g_free0_ (gpointer var)
{
#line 769 "../src/umockdev-ioctl.vala"
	var = (g_free (var), NULL);
#line 5082 "umockdev-ioctl.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 769 "../src/umockdev-ioctl.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 5090 "umockdev-ioctl.c"
}

static GObject *
umockdev_ioctl_base_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	UMockdevIoctlBase * self;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
#line 768 "../src/umockdev-ioctl.vala"
	parent_class = G_OBJECT_CLASS (umockdev_ioctl_base_parent_class);
#line 768 "../src/umockdev-ioctl.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 768 "../src/umockdev-ioctl.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UMOCKDEV_TYPE_IOCTL_BASE, UMockdevIoctlBase);
#line 769 "../src/umockdev-ioctl.vala"
	_tmp0_ = g_str_hash;
#line 769 "../src/umockdev-ioctl.vala"
	_tmp1_ = g_str_equal;
#line 769 "../src/umockdev-ioctl.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 769 "../src/umockdev-ioctl.vala"
	_g_hash_table_unref0 (self->priv->listeners);
#line 769 "../src/umockdev-ioctl.vala"
	self->priv->listeners = _tmp2_;
#line 768 "../src/umockdev-ioctl.vala"
	return obj;
#line 5122 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_base_class_init (UMockdevIoctlBaseClass * klass,
                                gpointer klass_data)
{
#line 759 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_base_parent_class = g_type_class_peek_parent (klass);
#line 759 "../src/umockdev-ioctl.vala"
	g_type_class_adjust_private_offset (klass, &UMockdevIoctlBase_private_offset);
#line 759 "../src/umockdev-ioctl.vala"
	((UMockdevIoctlBaseClass *) klass)->handle_ioctl = (gboolean (*) (UMockdevIoctlBase*, UMockdevIoctlClient*)) umockdev_ioctl_base_real_handle_ioctl;
#line 759 "../src/umockdev-ioctl.vala"
	((UMockdevIoctlBaseClass *) klass)->handle_read = (gboolean (*) (UMockdevIoctlBase*, UMockdevIoctlClient*)) umockdev_ioctl_base_real_handle_read;
#line 759 "../src/umockdev-ioctl.vala"
	((UMockdevIoctlBaseClass *) klass)->handle_write = (gboolean (*) (UMockdevIoctlBase*, UMockdevIoctlClient*)) umockdev_ioctl_base_real_handle_write;
#line 759 "../src/umockdev-ioctl.vala"
	((UMockdevIoctlBaseClass *) klass)->client_connected = umockdev_ioctl_base_real_client_connected;
#line 759 "../src/umockdev-ioctl.vala"
	((UMockdevIoctlBaseClass *) klass)->client_vanished = umockdev_ioctl_base_real_client_vanished;
#line 759 "../src/umockdev-ioctl.vala"
	G_OBJECT_CLASS (klass)->constructor = umockdev_ioctl_base_constructor;
#line 759 "../src/umockdev-ioctl.vala"
	G_OBJECT_CLASS (klass)->finalize = umockdev_ioctl_base_finalize;
#line 759 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_base_signals[UMOCKDEV_IOCTL_BASE_CLIENT_CONNECTED_SIGNAL] = g_signal_new ("client-connected", UMOCKDEV_TYPE_IOCTL_BASE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (UMockdevIoctlBaseClass, client_connected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, UMOCKDEV_TYPE_IOCTL_CLIENT);
#line 759 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_base_signals[UMOCKDEV_IOCTL_BASE_CLIENT_VANISHED_SIGNAL] = g_signal_new ("client-vanished", UMOCKDEV_TYPE_IOCTL_BASE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (UMockdevIoctlBaseClass, client_vanished), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, UMOCKDEV_TYPE_IOCTL_CLIENT);
#line 763 "../src/umockdev-ioctl.vala"
	g_signal_new ("handle-ioctl", UMOCKDEV_TYPE_IOCTL_BASE, G_SIGNAL_RUN_LAST, (guint) G_STRUCT_OFFSET(UMockdevIoctlBaseClass, handle_ioctl), _umockdev_signal_accumulator_true_handled_gsignal_accumulator, NULL, NULL, G_TYPE_BOOLEAN, (guint) 1, UMOCKDEV_TYPE_IOCTL_CLIENT, NULL);
#line 764 "../src/umockdev-ioctl.vala"
	g_signal_new ("handle-read", UMOCKDEV_TYPE_IOCTL_BASE, G_SIGNAL_RUN_LAST, (guint) G_STRUCT_OFFSET(UMockdevIoctlBaseClass, handle_read), _umockdev_signal_accumulator_true_handled_gsignal_accumulator, NULL, NULL, G_TYPE_BOOLEAN, (guint) 1, UMOCKDEV_TYPE_IOCTL_CLIENT, NULL);
#line 765 "../src/umockdev-ioctl.vala"
	g_signal_new ("handle-write", UMOCKDEV_TYPE_IOCTL_BASE, G_SIGNAL_RUN_LAST, (guint) G_STRUCT_OFFSET(UMockdevIoctlBaseClass, handle_write), _umockdev_signal_accumulator_true_handled_gsignal_accumulator, NULL, NULL, G_TYPE_BOOLEAN, (guint) 1, UMOCKDEV_TYPE_IOCTL_CLIENT, NULL);
#line 5157 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_base_instance_init (UMockdevIoctlBase * self,
                                   gpointer klass)
{
#line 759 "../src/umockdev-ioctl.vala"
	self->priv = umockdev_ioctl_base_get_instance_private (self);
#line 760 "../src/umockdev-ioctl.vala"
	g_rec_mutex_init (&self->priv->__lock_listeners);
#line 5168 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_base_finalize (GObject * obj)
{
	UMockdevIoctlBase * self;
#line 759 "../src/umockdev-ioctl.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UMOCKDEV_TYPE_IOCTL_BASE, UMockdevIoctlBase);
#line 760 "../src/umockdev-ioctl.vala"
	g_rec_mutex_clear (&self->priv->__lock_listeners);
#line 760 "../src/umockdev-ioctl.vala"
	_g_hash_table_unref0 (self->priv->listeners);
#line 759 "../src/umockdev-ioctl.vala"
	G_OBJECT_CLASS (umockdev_ioctl_base_parent_class)->finalize (obj);
#line 5183 "umockdev-ioctl.c"
}

static GType
umockdev_ioctl_base_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UMockdevIoctlBaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) umockdev_ioctl_base_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UMockdevIoctlBase), 0, (GInstanceInitFunc) umockdev_ioctl_base_instance_init, NULL };
	GType umockdev_ioctl_base_type_id;
	umockdev_ioctl_base_type_id = g_type_register_static (G_TYPE_OBJECT, "UMockdevIoctlBase", &g_define_type_info, 0);
	UMockdevIoctlBase_private_offset = g_type_add_instance_private (umockdev_ioctl_base_type_id, sizeof (UMockdevIoctlBasePrivate));
	return umockdev_ioctl_base_type_id;
}

GType
umockdev_ioctl_base_get_type (void)
{
	static volatile gsize umockdev_ioctl_base_type_id__once = 0;
	if (g_once_init_enter (&umockdev_ioctl_base_type_id__once)) {
		GType umockdev_ioctl_base_type_id;
		umockdev_ioctl_base_type_id = umockdev_ioctl_base_get_type_once ();
		g_once_init_leave (&umockdev_ioctl_base_type_id__once, umockdev_ioctl_base_type_id);
	}
	return umockdev_ioctl_base_type_id__once;
}

static inline gpointer
umockdev_ioctl_tree_handler_get_instance_private (UMockdevIoctlTreeHandler* self)
{
	return G_STRUCT_MEMBER_P (self, UMockdevIoctlTreeHandler_private_offset);
}

UMockdevIoctlTreeHandler*
umockdev_ioctl_tree_handler_construct (GType object_type,
                                       const gchar* file)
{
	UMockdevIoctlTreeHandler * self = NULL;
	FILE* f = NULL;
	FILE* _tmp0_;
	ioctl_tree* _tmp1_;
#line 886 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 888 "../src/umockdev-ioctl.vala"
	self = (UMockdevIoctlTreeHandler*) umockdev_ioctl_base_construct (object_type);
#line 890 "../src/umockdev-ioctl.vala"
	_tmp0_ = fopen (file, "r");
#line 890 "../src/umockdev-ioctl.vala"
	f = _tmp0_;
#line 891 "../src/umockdev-ioctl.vala"
	_tmp1_ = ioctl_tree_read (f);
#line 891 "../src/umockdev-ioctl.vala"
	_ioctl_tree_free0 (self->priv->tree);
#line 891 "../src/umockdev-ioctl.vala"
	self->priv->tree = _tmp1_;
#line 886 "../src/umockdev-ioctl.vala"
	_fclose0 (f);
#line 886 "../src/umockdev-ioctl.vala"
	return self;
#line 5240 "umockdev-ioctl.c"
}

UMockdevIoctlTreeHandler*
umockdev_ioctl_tree_handler_new (const gchar* file)
{
#line 886 "../src/umockdev-ioctl.vala"
	return umockdev_ioctl_tree_handler_construct (UMOCKDEV_TYPE_IOCTL_TREE_HANDLER, file);
#line 5248 "umockdev-ioctl.c"
}

static gboolean
umockdev_ioctl_tree_handler_real_handle_ioctl (UMockdevIoctlBase* base,
                                               UMockdevIoctlClient* client)
{
	UMockdevIoctlTreeHandler * self;
	void* last = NULL;
	UMockdevIoctlData* data = NULL;
	gulong request = 0UL;
	gulong _tmp0_;
	gulong _tmp1_;
	gulong size = 0UL;
	gulong type = 0UL;
	gint ret = 0;
	gint my_errno = 0;
	ioctl_tree* _tmp2_;
	gconstpointer _tmp5_;
	ioctl_tree* _tmp26_;
	void* _tmp27_;
	UMockdevIoctlData* _tmp28_;
	UMockdevIoctlData* _tmp29_;
	guint8* _tmp30_;
	gint _tmp30__length1;
	gint _tmp31_ = 0;
	void* _tmp32_;
	void* _tmp33_;
	gboolean _tmp35_ = FALSE;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 894 "../src/umockdev-ioctl.vala"
	self = (UMockdevIoctlTreeHandler*) base;
#line 894 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (client != NULL, FALSE);
#line 895 "../src/umockdev-ioctl.vala"
	last = NULL;
#line 896 "../src/umockdev-ioctl.vala"
	data = NULL;
#line 897 "../src/umockdev-ioctl.vala"
	_tmp0_ = umockdev_ioctl_client_get_request (client);
#line 897 "../src/umockdev-ioctl.vala"
	_tmp1_ = _tmp0_;
#line 897 "../src/umockdev-ioctl.vala"
	request = _tmp1_;
#line 898 "../src/umockdev-ioctl.vala"
	size = (gulong) ioctl_data_size_by_id (request);
#line 899 "../src/umockdev-ioctl.vala"
	type = (request >> _IOC_TYPESHIFT) & ((1 << _IOC_TYPEBITS) - 1);
#line 903 "../src/umockdev-ioctl.vala"
	_tmp2_ = self->priv->tree;
#line 903 "../src/umockdev-ioctl.vala"
	if (_tmp2_ == NULL) {
#line 5303 "umockdev-ioctl.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 904 "../src/umockdev-ioctl.vala"
		_tmp3_ = umockdev_ioctl_client_get_devnode (client);
#line 904 "../src/umockdev-ioctl.vala"
		_tmp4_ = _tmp3_;
#line 904 "../src/umockdev-ioctl.vala"
		g_debug ("umockdev-ioctl.vala:904: Aborting client because ioctl tree for %s is " \
"empty", _tmp4_);
#line 905 "../src/umockdev-ioctl.vala"
		umockdev_ioctl_client_abort (client);
#line 906 "../src/umockdev-ioctl.vala"
		result = TRUE;
#line 906 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (data);
#line 906 "../src/umockdev-ioctl.vala"
		return result;
#line 5320 "umockdev-ioctl.c"
	}
#line 909 "../src/umockdev-ioctl.vala"
	_tmp5_ = g_object_get_data ((GObject*) client, "last");
#line 909 "../src/umockdev-ioctl.vala"
	last = _tmp5_;
#line 5326 "umockdev-ioctl.c"
	{
		UMockdevIoctlData* _tmp14_;
#line 912 "../src/umockdev-ioctl.vala"
		if (request == ((gulong) CROS_EC_DEV_IOCXCMD_V2)) {
#line 5331 "umockdev-ioctl.c"
			ioctl_tree* _tmp6_;
			void* _tmp7_;
#line 913 "../src/umockdev-ioctl.vala"
			_tmp6_ = self->priv->tree;
#line 913 "../src/umockdev-ioctl.vala"
			_tmp7_ = last;
#line 913 "../src/umockdev-ioctl.vala"
			size += (gulong) ioctl_tree_next_ret (_tmp6_, _tmp7_);
#line 5340 "umockdev-ioctl.c"
		}
#line 916 "../src/umockdev-ioctl.vala"
		if (size > ((gulong) 0)) {
#line 5344 "umockdev-ioctl.c"
			UMockdevIoctlData* _tmp8_ = NULL;
			UMockdevIoctlData* _tmp9_;
			UMockdevIoctlData* _tmp10_;
			UMockdevIoctlData* _tmp11_;
			UMockdevIoctlData* _tmp13_;
#line 917 "../src/umockdev-ioctl.vala"
			_tmp9_ = umockdev_ioctl_client_get_arg (client);
#line 917 "../src/umockdev-ioctl.vala"
			_tmp10_ = _tmp9_;
#line 917 "../src/umockdev-ioctl.vala"
			_tmp11_ = umockdev_ioctl_data_resolve (_tmp10_, (gsize) 0, (gsize) size, &_inner_error0_);
#line 917 "../src/umockdev-ioctl.vala"
			_tmp8_ = _tmp11_;
#line 917 "../src/umockdev-ioctl.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5360 "umockdev-ioctl.c"
				gboolean _tmp12_ = FALSE;
#line 917 "../src/umockdev-ioctl.vala"
				if (_inner_error0_->domain == G_IO_ERROR) {
#line 5364 "umockdev-ioctl.c"
					goto __catch0_g_io_error;
				}
#line 917 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (data);
#line 917 "../src/umockdev-ioctl.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 917 "../src/umockdev-ioctl.vala"
				g_clear_error (&_inner_error0_);
#line 917 "../src/umockdev-ioctl.vala"
				return _tmp12_;
#line 5375 "umockdev-ioctl.c"
			}
#line 917 "../src/umockdev-ioctl.vala"
			_tmp13_ = _tmp8_;
#line 917 "../src/umockdev-ioctl.vala"
			_tmp8_ = NULL;
#line 917 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (data);
#line 917 "../src/umockdev-ioctl.vala"
			data = _tmp13_;
#line 916 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_tmp8_);
#line 5387 "umockdev-ioctl.c"
		}
#line 922 "../src/umockdev-ioctl.vala"
		_tmp14_ = data;
#line 922 "../src/umockdev-ioctl.vala"
		if (_tmp14_ != NULL) {
#line 923 "../src/umockdev-ioctl.vala"
			if (request == ((gulong) USBDEVFS_SUBMITURB)) {
#line 5395 "umockdev-ioctl.c"
				struct usbdevfs_urb* urb = NULL;
				UMockdevIoctlData* _tmp15_;
				guint8* _tmp16_;
				gint _tmp16__length1;
				gsize offset = 0UL;
				struct usbdevfs_urb* _tmp17_;
				UMockdevIoctlData* _tmp18_;
				struct usbdevfs_urb* _tmp19_;
				UMockdevIoctlData* _tmp20_;
				UMockdevIoctlData* _tmp21_;
#line 924 "../src/umockdev-ioctl.vala"
				_tmp15_ = data;
#line 924 "../src/umockdev-ioctl.vala"
				_tmp16_ = _tmp15_->data;
#line 924 "../src/umockdev-ioctl.vala"
				_tmp16__length1 = _tmp15_->data_len;
#line 924 "../src/umockdev-ioctl.vala"
				urb = (struct usbdevfs_urb*) _tmp16_;
#line 926 "../src/umockdev-ioctl.vala"
				_tmp17_ = urb;
#line 926 "../src/umockdev-ioctl.vala"
				offset = (gsize) (((gulong) (&(*urb).buffer)) - ((gulong) _tmp17_));
#line 928 "../src/umockdev-ioctl.vala"
				_tmp18_ = data;
#line 928 "../src/umockdev-ioctl.vala"
				_tmp19_ = urb;
#line 928 "../src/umockdev-ioctl.vala"
				_tmp20_ = umockdev_ioctl_data_resolve (_tmp18_, offset, (gsize) (*_tmp19_).buffer_length, &_inner_error0_);
#line 928 "../src/umockdev-ioctl.vala"
				_tmp21_ = _tmp20_;
#line 928 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (_tmp21_);
#line 928 "../src/umockdev-ioctl.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5430 "umockdev-ioctl.c"
					gboolean _tmp22_ = FALSE;
#line 928 "../src/umockdev-ioctl.vala"
					if (_inner_error0_->domain == G_IO_ERROR) {
#line 5434 "umockdev-ioctl.c"
						goto __catch0_g_io_error;
					}
#line 928 "../src/umockdev-ioctl.vala"
					_g_object_unref0 (data);
#line 928 "../src/umockdev-ioctl.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 928 "../src/umockdev-ioctl.vala"
					g_clear_error (&_inner_error0_);
#line 928 "../src/umockdev-ioctl.vala"
					return _tmp22_;
#line 5445 "umockdev-ioctl.c"
				}
			}
		}
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
#line 911 "../src/umockdev-ioctl.vala"
		e = _inner_error0_;
#line 911 "../src/umockdev-ioctl.vala"
		_inner_error0_ = NULL;
#line 932 "../src/umockdev-ioctl.vala"
		_tmp23_ = e;
#line 932 "../src/umockdev-ioctl.vala"
		_tmp24_ = _tmp23_->message;
#line 932 "../src/umockdev-ioctl.vala"
		g_warning ("umockdev-ioctl.vala:932: Error resolving IOCtl data: %s", _tmp24_);
#line 933 "../src/umockdev-ioctl.vala"
		result = FALSE;
#line 933 "../src/umockdev-ioctl.vala"
		_g_error_free0 (e);
#line 933 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (data);
#line 933 "../src/umockdev-ioctl.vala"
		return result;
#line 5474 "umockdev-ioctl.c"
	}
	__finally0:
#line 911 "../src/umockdev-ioctl.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5479 "umockdev-ioctl.c"
		gboolean _tmp25_ = FALSE;
#line 911 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (data);
#line 911 "../src/umockdev-ioctl.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 911 "../src/umockdev-ioctl.vala"
		g_clear_error (&_inner_error0_);
#line 911 "../src/umockdev-ioctl.vala"
		return _tmp25_;
#line 5489 "umockdev-ioctl.c"
	}
#line 936 "../src/umockdev-ioctl.vala"
	if (((gchar) type) == 'E') {
#line 937 "../src/umockdev-ioctl.vala"
		errno = ENOENT;
#line 5495 "umockdev-ioctl.c"
	} else {
#line 939 "../src/umockdev-ioctl.vala"
		errno = ENOTTY;
#line 5499 "umockdev-ioctl.c"
	}
#line 941 "../src/umockdev-ioctl.vala"
	_tmp26_ = self->priv->tree;
#line 941 "../src/umockdev-ioctl.vala"
	_tmp27_ = last;
#line 941 "../src/umockdev-ioctl.vala"
	_tmp28_ = umockdev_ioctl_client_get_arg (client);
#line 941 "../src/umockdev-ioctl.vala"
	_tmp29_ = _tmp28_;
#line 941 "../src/umockdev-ioctl.vala"
	_tmp30_ = _tmp29_->data;
#line 941 "../src/umockdev-ioctl.vala"
	_tmp30__length1 = _tmp29_->data_len;
#line 941 "../src/umockdev-ioctl.vala"
	_tmp32_ = ioctl_tree_execute (_tmp26_, _tmp27_, request, *((void**) _tmp30_), &_tmp31_);
#line 941 "../src/umockdev-ioctl.vala"
	ret = _tmp31_;
#line 941 "../src/umockdev-ioctl.vala"
	last = _tmp32_;
#line 942 "../src/umockdev-ioctl.vala"
	my_errno = errno;
#line 943 "../src/umockdev-ioctl.vala"
	errno = 0;
#line 944 "../src/umockdev-ioctl.vala"
	_tmp33_ = last;
#line 944 "../src/umockdev-ioctl.vala"
	if (_tmp33_ != NULL) {
#line 5527 "umockdev-ioctl.c"
		void* _tmp34_;
#line 945 "../src/umockdev-ioctl.vala"
		_tmp34_ = last;
#line 945 "../src/umockdev-ioctl.vala"
		g_object_set_data_full ((GObject*) client, "last", _tmp34_, NULL);
#line 5533 "umockdev-ioctl.c"
	}
#line 947 "../src/umockdev-ioctl.vala"
	if (ret != -1) {
#line 948 "../src/umockdev-ioctl.vala"
		my_errno = 0;
#line 5539 "umockdev-ioctl.c"
	}
#line 951 "../src/umockdev-ioctl.vala"
	if (request == ((gulong) USBDEVFS_SUBMITURB)) {
#line 951 "../src/umockdev-ioctl.vala"
		_tmp35_ = ret == 0;
#line 5545 "umockdev-ioctl.c"
	} else {
#line 951 "../src/umockdev-ioctl.vala"
		_tmp35_ = FALSE;
#line 5549 "umockdev-ioctl.c"
	}
#line 951 "../src/umockdev-ioctl.vala"
	if (_tmp35_) {
#line 5553 "umockdev-ioctl.c"
		UMockdevIoctlData* _tmp36_;
		UMockdevIoctlData* _tmp37_;
#line 952 "../src/umockdev-ioctl.vala"
		_tmp36_ = data;
#line 952 "../src/umockdev-ioctl.vala"
		_tmp37_ = _g_object_ref0 (_tmp36_);
#line 952 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (umockdev_last_submit_urb);
#line 952 "../src/umockdev-ioctl.vala"
		umockdev_last_submit_urb = _tmp37_;
#line 5564 "umockdev-ioctl.c"
	}
#line 955 "../src/umockdev-ioctl.vala"
	if (request == ((gulong) USBDEVFS_REAPURB)) {
#line 955 "../src/umockdev-ioctl.vala"
		_tmp39_ = TRUE;
#line 5570 "umockdev-ioctl.c"
	} else {
#line 955 "../src/umockdev-ioctl.vala"
		_tmp39_ = request == ((gulong) USBDEVFS_REAPURBNDELAY);
#line 5574 "umockdev-ioctl.c"
	}
#line 955 "../src/umockdev-ioctl.vala"
	if (_tmp39_) {
#line 5578 "umockdev-ioctl.c"
		UMockdevIoctlData* _tmp40_;
#line 955 "../src/umockdev-ioctl.vala"
		_tmp40_ = umockdev_last_submit_urb;
#line 955 "../src/umockdev-ioctl.vala"
		_tmp38_ = _tmp40_ != NULL;
#line 5584 "umockdev-ioctl.c"
	} else {
#line 955 "../src/umockdev-ioctl.vala"
		_tmp38_ = FALSE;
#line 5588 "umockdev-ioctl.c"
	}
#line 955 "../src/umockdev-ioctl.vala"
	if (_tmp38_) {
#line 5592 "umockdev-ioctl.c"
		UMockdevIoctlData* _tmp41_;
		guint8* _tmp42_;
		gint _tmp42__length1;
		UMockdevIoctlData* _tmp43_;
		guint8* _tmp44_;
		gint _tmp44__length1;
#line 962 "../src/umockdev-ioctl.vala"
		_tmp41_ = data;
#line 962 "../src/umockdev-ioctl.vala"
		_tmp42_ = _tmp41_->data;
#line 962 "../src/umockdev-ioctl.vala"
		_tmp42__length1 = _tmp41_->data_len;
#line 962 "../src/umockdev-ioctl.vala"
		_tmp43_ = umockdev_last_submit_urb;
#line 962 "../src/umockdev-ioctl.vala"
		_tmp44_ = _tmp43_->data;
#line 962 "../src/umockdev-ioctl.vala"
		_tmp44__length1 = _tmp43_->data_len;
#line 962 "../src/umockdev-ioctl.vala"
		if ((*((void**) _tmp42_)) == ((void*) _tmp44_)) {
#line 5613 "umockdev-ioctl.c"
			UMockdevIoctlData* _tmp45_;
			UMockdevIoctlData* _tmp46_;
#line 963 "../src/umockdev-ioctl.vala"
			_tmp45_ = data;
#line 963 "../src/umockdev-ioctl.vala"
			_tmp46_ = umockdev_last_submit_urb;
#line 963 "../src/umockdev-ioctl.vala"
			umockdev_ioctl_data_set_ptr (_tmp45_, (gsize) 0, _tmp46_);
#line 965 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (umockdev_last_submit_urb);
#line 965 "../src/umockdev-ioctl.vala"
			umockdev_last_submit_urb = NULL;
#line 5626 "umockdev-ioctl.c"
		}
	}
#line 969 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_client_complete (client, (glong) ret, my_errno);
#line 971 "../src/umockdev-ioctl.vala"
	result = TRUE;
#line 971 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (data);
#line 971 "../src/umockdev-ioctl.vala"
	return result;
#line 5637 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_tree_handler_class_init (UMockdevIoctlTreeHandlerClass * klass,
                                        gpointer klass_data)
{
#line 882 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_tree_handler_parent_class = g_type_class_peek_parent (klass);
#line 882 "../src/umockdev-ioctl.vala"
	g_type_class_adjust_private_offset (klass, &UMockdevIoctlTreeHandler_private_offset);
#line 882 "../src/umockdev-ioctl.vala"
	((UMockdevIoctlBaseClass *) klass)->handle_ioctl = (gboolean (*) (UMockdevIoctlBase*, UMockdevIoctlClient*)) umockdev_ioctl_tree_handler_real_handle_ioctl;
#line 882 "../src/umockdev-ioctl.vala"
	G_OBJECT_CLASS (klass)->finalize = umockdev_ioctl_tree_handler_finalize;
#line 5652 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_tree_handler_instance_init (UMockdevIoctlTreeHandler * self,
                                           gpointer klass)
{
#line 882 "../src/umockdev-ioctl.vala"
	self->priv = umockdev_ioctl_tree_handler_get_instance_private (self);
#line 5661 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_tree_handler_finalize (GObject * obj)
{
	UMockdevIoctlTreeHandler * self;
#line 882 "../src/umockdev-ioctl.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UMOCKDEV_TYPE_IOCTL_TREE_HANDLER, UMockdevIoctlTreeHandler);
#line 884 "../src/umockdev-ioctl.vala"
	_ioctl_tree_free0 (self->priv->tree);
#line 882 "../src/umockdev-ioctl.vala"
	G_OBJECT_CLASS (umockdev_ioctl_tree_handler_parent_class)->finalize (obj);
#line 5674 "umockdev-ioctl.c"
}

static GType
umockdev_ioctl_tree_handler_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UMockdevIoctlTreeHandlerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) umockdev_ioctl_tree_handler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UMockdevIoctlTreeHandler), 0, (GInstanceInitFunc) umockdev_ioctl_tree_handler_instance_init, NULL };
	GType umockdev_ioctl_tree_handler_type_id;
	umockdev_ioctl_tree_handler_type_id = g_type_register_static (UMOCKDEV_TYPE_IOCTL_BASE, "UMockdevIoctlTreeHandler", &g_define_type_info, 0);
	UMockdevIoctlTreeHandler_private_offset = g_type_add_instance_private (umockdev_ioctl_tree_handler_type_id, sizeof (UMockdevIoctlTreeHandlerPrivate));
	return umockdev_ioctl_tree_handler_type_id;
}

GType
umockdev_ioctl_tree_handler_get_type (void)
{
	static volatile gsize umockdev_ioctl_tree_handler_type_id__once = 0;
	if (g_once_init_enter (&umockdev_ioctl_tree_handler_type_id__once)) {
		GType umockdev_ioctl_tree_handler_type_id;
		umockdev_ioctl_tree_handler_type_id = umockdev_ioctl_tree_handler_get_type_once ();
		g_once_init_leave (&umockdev_ioctl_tree_handler_type_id__once, umockdev_ioctl_tree_handler_type_id);
	}
	return umockdev_ioctl_tree_handler_type_id__once;
}

static inline gpointer
umockdev_ioctl_tree_recorder_get_instance_private (UMockdevIoctlTreeRecorder* self)
{
	return G_STRUCT_MEMBER_P (self, UMockdevIoctlTreeRecorder_private_offset);
}

UMockdevIoctlTreeRecorder*
umockdev_ioctl_tree_recorder_construct (GType object_type,
                                        const gchar* device,
                                        const gchar* file)
{
	UMockdevIoctlTreeRecorder * self = NULL;
	gchar* existing_device_path = NULL;
	FILE* log = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	FILE* _tmp3_;
	FILE* _tmp4_;
	gboolean _tmp5_ = FALSE;
	FILE* _tmp6_;
	FILE* _tmp8_;
	ioctl_tree* _tmp9_;
#line 982 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 982 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 984 "../src/umockdev-ioctl.vala"
	existing_device_path = NULL;
#line 986 "../src/umockdev-ioctl.vala"
	self = (UMockdevIoctlTreeRecorder*) umockdev_ioctl_base_construct (object_type);
#line 988 "../src/umockdev-ioctl.vala"
	_tmp0_ = g_strdup (file);
#line 988 "../src/umockdev-ioctl.vala"
	_g_free0 (self->priv->logfile);
#line 988 "../src/umockdev-ioctl.vala"
	self->priv->logfile = _tmp0_;
#line 989 "../src/umockdev-ioctl.vala"
	_tmp1_ = g_strdup (device);
#line 989 "../src/umockdev-ioctl.vala"
	_g_free0 (self->priv->device);
#line 989 "../src/umockdev-ioctl.vala"
	self->priv->device = _tmp1_;
#line 990 "../src/umockdev-ioctl.vala"
	_tmp2_ = self->priv->logfile;
#line 990 "../src/umockdev-ioctl.vala"
	_tmp3_ = fopen (_tmp2_, "r");
#line 990 "../src/umockdev-ioctl.vala"
	_fclose0 (log);
#line 990 "../src/umockdev-ioctl.vala"
	log = _tmp3_;
#line 991 "../src/umockdev-ioctl.vala"
	_tmp4_ = log;
#line 991 "../src/umockdev-ioctl.vala"
	if (_tmp4_ == NULL) {
#line 992 "../src/umockdev-ioctl.vala"
		_fclose0 (log);
#line 992 "../src/umockdev-ioctl.vala"
		_g_free0 (existing_device_path);
#line 992 "../src/umockdev-ioctl.vala"
		return self;
#line 5760 "umockdev-ioctl.c"
	}
#line 995 "../src/umockdev-ioctl.vala"
	_tmp6_ = log;
#line 995 "../src/umockdev-ioctl.vala"
	if (fscanf (_tmp6_, "@DEV %ms\n", &existing_device_path) == 1) {
#line 5766 "umockdev-ioctl.c"
		const gchar* _tmp7_;
#line 995 "../src/umockdev-ioctl.vala"
		_tmp7_ = existing_device_path;
#line 995 "../src/umockdev-ioctl.vala"
		_tmp5_ = g_strcmp0 (_tmp7_, device) != 0;
#line 5772 "umockdev-ioctl.c"
	} else {
#line 995 "../src/umockdev-ioctl.vala"
		_tmp5_ = FALSE;
#line 5776 "umockdev-ioctl.c"
	}
#line 995 "../src/umockdev-ioctl.vala"
	if (_tmp5_) {
#line 996 "../src/umockdev-ioctl.vala"
		g_error ("umockdev-ioctl.vala:996: attempt to record two different devices to th" \
"e same ioctl recording");
#line 5782 "umockdev-ioctl.c"
	}
#line 997 "../src/umockdev-ioctl.vala"
	_tmp8_ = log;
#line 997 "../src/umockdev-ioctl.vala"
	_tmp9_ = ioctl_tree_read (_tmp8_);
#line 997 "../src/umockdev-ioctl.vala"
	_ioctl_tree_free0 (self->priv->tree);
#line 997 "../src/umockdev-ioctl.vala"
	self->priv->tree = _tmp9_;
#line 982 "../src/umockdev-ioctl.vala"
	_fclose0 (log);
#line 982 "../src/umockdev-ioctl.vala"
	_g_free0 (existing_device_path);
#line 982 "../src/umockdev-ioctl.vala"
	return self;
#line 5798 "umockdev-ioctl.c"
}

UMockdevIoctlTreeRecorder*
umockdev_ioctl_tree_recorder_new (const gchar* device,
                                  const gchar* file)
{
#line 982 "../src/umockdev-ioctl.vala"
	return umockdev_ioctl_tree_recorder_construct (UMOCKDEV_TYPE_IOCTL_TREE_RECORDER, device, file);
#line 5807 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_tree_recorder_flush_log (UMockdevIoctlTreeRecorder* self)
{
	FILE* log = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	FILE* _tmp2_;
	FILE* _tmp3_;
	const gchar* _tmp4_;
	ioctl_tree* _tmp5_;
	FILE* _tmp6_;
#line 1005 "../src/umockdev-ioctl.vala"
	g_return_if_fail (self != NULL);
#line 1009 "../src/umockdev-ioctl.vala"
	if (!self->priv->write_log) {
#line 1010 "../src/umockdev-ioctl.vala"
		_fclose0 (log);
#line 1010 "../src/umockdev-ioctl.vala"
		return;
#line 5829 "umockdev-ioctl.c"
	}
#line 1012 "../src/umockdev-ioctl.vala"
	_tmp0_ = self->priv->device;
#line 1012 "../src/umockdev-ioctl.vala"
	_vala_assert (_tmp0_ != NULL, "device != null");
#line 1014 "../src/umockdev-ioctl.vala"
	_tmp1_ = self->priv->logfile;
#line 1014 "../src/umockdev-ioctl.vala"
	_tmp2_ = fopen (_tmp1_, "w+");
#line 1014 "../src/umockdev-ioctl.vala"
	_fclose0 (log);
#line 1014 "../src/umockdev-ioctl.vala"
	log = _tmp2_;
#line 1015 "../src/umockdev-ioctl.vala"
	_tmp3_ = log;
#line 1015 "../src/umockdev-ioctl.vala"
	_tmp4_ = self->priv->device;
#line 1015 "../src/umockdev-ioctl.vala"
	fprintf (_tmp3_, "@DEV %s\n", _tmp4_);
#line 1016 "../src/umockdev-ioctl.vala"
	_tmp5_ = self->priv->tree;
#line 1016 "../src/umockdev-ioctl.vala"
	_tmp6_ = log;
#line 1016 "../src/umockdev-ioctl.vala"
	ioctl_tree_write (_tmp6_, _tmp5_);
#line 1005 "../src/umockdev-ioctl.vala"
	_fclose0 (log);
#line 5857 "umockdev-ioctl.c"
}

static gboolean
umockdev_ioctl_tree_recorder_real_handle_ioctl (UMockdevIoctlBase* base,
                                                UMockdevIoctlClient* client)
{
	UMockdevIoctlTreeRecorder * self;
	gulong request = 0UL;
	gulong _tmp0_;
	gulong _tmp1_;
	gulong size = 0UL;
	UMockdevIoctlData* data = NULL;
	ioctl_tree* node = NULL;
	gint ret = 0;
	gint my_errno = 0;
	UMockdevIoctlData* _tmp33_;
	UMockdevIoctlData* _tmp34_;
	guint8* _tmp35_;
	gint _tmp35__length1;
	ioctl_tree* _tmp36_;
	ioctl_tree* _tmp37_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1019 "../src/umockdev-ioctl.vala"
	self = (UMockdevIoctlTreeRecorder*) base;
#line 1019 "../src/umockdev-ioctl.vala"
	g_return_val_if_fail (client != NULL, FALSE);
#line 1020 "../src/umockdev-ioctl.vala"
	_tmp0_ = umockdev_ioctl_client_get_request (client);
#line 1020 "../src/umockdev-ioctl.vala"
	_tmp1_ = _tmp0_;
#line 1020 "../src/umockdev-ioctl.vala"
	request = _tmp1_;
#line 1021 "../src/umockdev-ioctl.vala"
	size = (gulong) ioctl_data_size_by_id (request);
#line 1022 "../src/umockdev-ioctl.vala"
	data = NULL;
#line 5895 "umockdev-ioctl.c"
	{
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		gint _tmp4_;
		UMockdevIoctlData* _tmp12_;
#line 1029 "../src/umockdev-ioctl.vala"
		_tmp4_ = umockdev_ioctl_client_execute (client, &_tmp3_, &_inner_error0_);
#line 1029 "../src/umockdev-ioctl.vala"
		my_errno = _tmp3_;
#line 1029 "../src/umockdev-ioctl.vala"
		_tmp2_ = _tmp4_;
#line 1029 "../src/umockdev-ioctl.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5909 "umockdev-ioctl.c"
			gboolean _tmp5_ = FALSE;
#line 1029 "../src/umockdev-ioctl.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 5913 "umockdev-ioctl.c"
				goto __catch0_g_io_error;
			}
#line 1029 "../src/umockdev-ioctl.vala"
			_ioctl_tree_free0 (node);
#line 1029 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (data);
#line 1029 "../src/umockdev-ioctl.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1029 "../src/umockdev-ioctl.vala"
			g_clear_error (&_inner_error0_);
#line 1029 "../src/umockdev-ioctl.vala"
			return _tmp5_;
#line 5926 "umockdev-ioctl.c"
		}
#line 1029 "../src/umockdev-ioctl.vala"
		ret = _tmp2_;
#line 1032 "../src/umockdev-ioctl.vala"
		if (ret == -1) {
#line 1033 "../src/umockdev-ioctl.vala"
			umockdev_ioctl_client_complete (client, (glong) ret, my_errno);
#line 1034 "../src/umockdev-ioctl.vala"
			result = TRUE;
#line 1034 "../src/umockdev-ioctl.vala"
			_ioctl_tree_free0 (node);
#line 1034 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (data);
#line 1034 "../src/umockdev-ioctl.vala"
			return result;
#line 5942 "umockdev-ioctl.c"
		}
#line 1037 "../src/umockdev-ioctl.vala"
		if (request == ((gulong) CROS_EC_DEV_IOCXCMD_V2)) {
#line 1038 "../src/umockdev-ioctl.vala"
			size += (gulong) ret;
#line 5948 "umockdev-ioctl.c"
		}
#line 1042 "../src/umockdev-ioctl.vala"
		if (size > ((gulong) 0)) {
#line 5952 "umockdev-ioctl.c"
			UMockdevIoctlData* _tmp6_ = NULL;
			UMockdevIoctlData* _tmp7_;
			UMockdevIoctlData* _tmp8_;
			UMockdevIoctlData* _tmp9_;
			UMockdevIoctlData* _tmp11_;
#line 1043 "../src/umockdev-ioctl.vala"
			_tmp7_ = umockdev_ioctl_client_get_arg (client);
#line 1043 "../src/umockdev-ioctl.vala"
			_tmp8_ = _tmp7_;
#line 1043 "../src/umockdev-ioctl.vala"
			_tmp9_ = umockdev_ioctl_data_resolve (_tmp8_, (gsize) 0, (gsize) size, &_inner_error0_);
#line 1043 "../src/umockdev-ioctl.vala"
			_tmp6_ = _tmp9_;
#line 1043 "../src/umockdev-ioctl.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5968 "umockdev-ioctl.c"
				gboolean _tmp10_ = FALSE;
#line 1043 "../src/umockdev-ioctl.vala"
				if (_inner_error0_->domain == G_IO_ERROR) {
#line 5972 "umockdev-ioctl.c"
					goto __catch0_g_io_error;
				}
#line 1043 "../src/umockdev-ioctl.vala"
				_ioctl_tree_free0 (node);
#line 1043 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (data);
#line 1043 "../src/umockdev-ioctl.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1043 "../src/umockdev-ioctl.vala"
				g_clear_error (&_inner_error0_);
#line 1043 "../src/umockdev-ioctl.vala"
				return _tmp10_;
#line 5985 "umockdev-ioctl.c"
			}
#line 1043 "../src/umockdev-ioctl.vala"
			_tmp11_ = _tmp6_;
#line 1043 "../src/umockdev-ioctl.vala"
			_tmp6_ = NULL;
#line 1043 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (data);
#line 1043 "../src/umockdev-ioctl.vala"
			data = _tmp11_;
#line 1042 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (_tmp6_);
#line 5997 "umockdev-ioctl.c"
		}
#line 1048 "../src/umockdev-ioctl.vala"
		_tmp12_ = data;
#line 1048 "../src/umockdev-ioctl.vala"
		if (_tmp12_ != NULL) {
#line 6003 "umockdev-ioctl.c"
			UMockdevIoctlData* urb_data = NULL;
			gboolean _tmp13_ = FALSE;
			UMockdevIoctlData* _tmp21_;
#line 1049 "../src/umockdev-ioctl.vala"
			urb_data = NULL;
#line 1051 "../src/umockdev-ioctl.vala"
			if (request == ((gulong) USBDEVFS_REAPURB)) {
#line 1051 "../src/umockdev-ioctl.vala"
				_tmp13_ = TRUE;
#line 6013 "umockdev-ioctl.c"
			} else {
#line 1052 "../src/umockdev-ioctl.vala"
				_tmp13_ = request == ((gulong) USBDEVFS_REAPURBNDELAY);
#line 6017 "umockdev-ioctl.c"
			}
#line 1051 "../src/umockdev-ioctl.vala"
			if (_tmp13_) {
#line 6021 "umockdev-ioctl.c"
				UMockdevIoctlData* _tmp14_ = NULL;
				UMockdevIoctlData* _tmp15_;
				UMockdevIoctlData* _tmp16_;
				UMockdevIoctlData* _tmp18_;
#line 1054 "../src/umockdev-ioctl.vala"
				_tmp15_ = data;
#line 1054 "../src/umockdev-ioctl.vala"
				_tmp16_ = umockdev_ioctl_data_resolve (_tmp15_, (gsize) 0, (gsize) sizeof (struct usbdevfs_urb), &_inner_error0_);
#line 1054 "../src/umockdev-ioctl.vala"
				_tmp14_ = _tmp16_;
#line 1054 "../src/umockdev-ioctl.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6034 "umockdev-ioctl.c"
					gboolean _tmp17_ = FALSE;
#line 1054 "../src/umockdev-ioctl.vala"
					_g_object_unref0 (urb_data);
#line 1054 "../src/umockdev-ioctl.vala"
					if (_inner_error0_->domain == G_IO_ERROR) {
#line 6040 "umockdev-ioctl.c"
						goto __catch0_g_io_error;
					}
#line 1054 "../src/umockdev-ioctl.vala"
					_ioctl_tree_free0 (node);
#line 1054 "../src/umockdev-ioctl.vala"
					_g_object_unref0 (data);
#line 1054 "../src/umockdev-ioctl.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1054 "../src/umockdev-ioctl.vala"
					g_clear_error (&_inner_error0_);
#line 1054 "../src/umockdev-ioctl.vala"
					return _tmp17_;
#line 6053 "umockdev-ioctl.c"
				}
#line 1054 "../src/umockdev-ioctl.vala"
				_tmp18_ = _tmp14_;
#line 1054 "../src/umockdev-ioctl.vala"
				_tmp14_ = NULL;
#line 1054 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (urb_data);
#line 1054 "../src/umockdev-ioctl.vala"
				urb_data = _tmp18_;
#line 1051 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (_tmp14_);
#line 6065 "umockdev-ioctl.c"
			} else {
#line 1055 "../src/umockdev-ioctl.vala"
				if (request == ((gulong) USBDEVFS_SUBMITURB)) {
#line 6069 "umockdev-ioctl.c"
					UMockdevIoctlData* _tmp19_;
					UMockdevIoctlData* _tmp20_;
#line 1056 "../src/umockdev-ioctl.vala"
					_tmp19_ = data;
#line 1056 "../src/umockdev-ioctl.vala"
					_tmp20_ = _g_object_ref0 (_tmp19_);
#line 1056 "../src/umockdev-ioctl.vala"
					_g_object_unref0 (urb_data);
#line 1056 "../src/umockdev-ioctl.vala"
					urb_data = _tmp20_;
#line 6080 "umockdev-ioctl.c"
				}
			}
#line 1059 "../src/umockdev-ioctl.vala"
			_tmp21_ = urb_data;
#line 1059 "../src/umockdev-ioctl.vala"
			if (_tmp21_ != NULL) {
#line 6087 "umockdev-ioctl.c"
				struct usbdevfs_urb* urb = NULL;
				UMockdevIoctlData* _tmp22_;
				guint8* _tmp23_;
				gint _tmp23__length1;
				gsize offset = 0UL;
				struct usbdevfs_urb* _tmp24_;
				UMockdevIoctlData* _tmp25_;
				struct usbdevfs_urb* _tmp26_;
				UMockdevIoctlData* _tmp27_;
				UMockdevIoctlData* _tmp28_;
#line 1060 "../src/umockdev-ioctl.vala"
				_tmp22_ = urb_data;
#line 1060 "../src/umockdev-ioctl.vala"
				_tmp23_ = _tmp22_->data;
#line 1060 "../src/umockdev-ioctl.vala"
				_tmp23__length1 = _tmp22_->data_len;
#line 1060 "../src/umockdev-ioctl.vala"
				urb = (struct usbdevfs_urb*) _tmp23_;
#line 1062 "../src/umockdev-ioctl.vala"
				_tmp24_ = urb;
#line 1062 "../src/umockdev-ioctl.vala"
				offset = (gsize) (((gulong) (&(*urb).buffer)) - ((gulong) _tmp24_));
#line 1064 "../src/umockdev-ioctl.vala"
				_tmp25_ = urb_data;
#line 1064 "../src/umockdev-ioctl.vala"
				_tmp26_ = urb;
#line 1064 "../src/umockdev-ioctl.vala"
				_tmp27_ = umockdev_ioctl_data_resolve (_tmp25_, offset, (gsize) (*_tmp26_).buffer_length, &_inner_error0_);
#line 1064 "../src/umockdev-ioctl.vala"
				_tmp28_ = _tmp27_;
#line 1064 "../src/umockdev-ioctl.vala"
				_g_object_unref0 (_tmp28_);
#line 1064 "../src/umockdev-ioctl.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6122 "umockdev-ioctl.c"
					gboolean _tmp29_ = FALSE;
#line 1064 "../src/umockdev-ioctl.vala"
					_g_object_unref0 (urb_data);
#line 1064 "../src/umockdev-ioctl.vala"
					if (_inner_error0_->domain == G_IO_ERROR) {
#line 6128 "umockdev-ioctl.c"
						goto __catch0_g_io_error;
					}
#line 1064 "../src/umockdev-ioctl.vala"
					_ioctl_tree_free0 (node);
#line 1064 "../src/umockdev-ioctl.vala"
					_g_object_unref0 (data);
#line 1064 "../src/umockdev-ioctl.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1064 "../src/umockdev-ioctl.vala"
					g_clear_error (&_inner_error0_);
#line 1064 "../src/umockdev-ioctl.vala"
					return _tmp29_;
#line 6141 "umockdev-ioctl.c"
				}
			}
#line 1048 "../src/umockdev-ioctl.vala"
			_g_object_unref0 (urb_data);
#line 6146 "umockdev-ioctl.c"
		}
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp30_;
		const gchar* _tmp31_;
#line 1027 "../src/umockdev-ioctl.vala"
		e = _inner_error0_;
#line 1027 "../src/umockdev-ioctl.vala"
		_inner_error0_ = NULL;
#line 1068 "../src/umockdev-ioctl.vala"
		_tmp30_ = e;
#line 1068 "../src/umockdev-ioctl.vala"
		_tmp31_ = _tmp30_->message;
#line 1068 "../src/umockdev-ioctl.vala"
		g_warning ("umockdev-ioctl.vala:1068: Error executing and recording ioctl: %s", _tmp31_);
#line 1069 "../src/umockdev-ioctl.vala"
		result = FALSE;
#line 1069 "../src/umockdev-ioctl.vala"
		_g_error_free0 (e);
#line 1069 "../src/umockdev-ioctl.vala"
		_ioctl_tree_free0 (node);
#line 1069 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (data);
#line 1069 "../src/umockdev-ioctl.vala"
		return result;
#line 6175 "umockdev-ioctl.c"
	}
	__finally0:
#line 1027 "../src/umockdev-ioctl.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6180 "umockdev-ioctl.c"
		gboolean _tmp32_ = FALSE;
#line 1027 "../src/umockdev-ioctl.vala"
		_ioctl_tree_free0 (node);
#line 1027 "../src/umockdev-ioctl.vala"
		_g_object_unref0 (data);
#line 1027 "../src/umockdev-ioctl.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1027 "../src/umockdev-ioctl.vala"
		g_clear_error (&_inner_error0_);
#line 1027 "../src/umockdev-ioctl.vala"
		return _tmp32_;
#line 6192 "umockdev-ioctl.c"
	}
#line 1073 "../src/umockdev-ioctl.vala"
	_tmp33_ = umockdev_ioctl_client_get_arg (client);
#line 1073 "../src/umockdev-ioctl.vala"
	_tmp34_ = _tmp33_;
#line 1073 "../src/umockdev-ioctl.vala"
	_tmp35_ = _tmp34_->data;
#line 1073 "../src/umockdev-ioctl.vala"
	_tmp35__length1 = _tmp34_->data_len;
#line 1073 "../src/umockdev-ioctl.vala"
	_tmp36_ = ioctl_tree_new_from_bin (request, *((void**) _tmp35_), ret);
#line 1073 "../src/umockdev-ioctl.vala"
	_ioctl_tree_free0 (node);
#line 1073 "../src/umockdev-ioctl.vala"
	node = _tmp36_;
#line 1074 "../src/umockdev-ioctl.vala"
	_tmp37_ = node;
#line 1074 "../src/umockdev-ioctl.vala"
	if (_tmp37_ != NULL) {
#line 6212 "umockdev-ioctl.c"
		ioctl_tree* _tmp38_;
#line 1075 "../src/umockdev-ioctl.vala"
		_tmp38_ = node;
#line 1075 "../src/umockdev-ioctl.vala"
		node = NULL;
#line 1075 "../src/umockdev-ioctl.vala"
		self->priv->tree = ioctl_tree_insert (self->priv->tree, _tmp38_);
#line 6220 "umockdev-ioctl.c"
	}
#line 1079 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_client_complete (client, (glong) ret, my_errno);
#line 1081 "../src/umockdev-ioctl.vala"
	result = TRUE;
#line 1081 "../src/umockdev-ioctl.vala"
	_ioctl_tree_free0 (node);
#line 1081 "../src/umockdev-ioctl.vala"
	_g_object_unref0 (data);
#line 1081 "../src/umockdev-ioctl.vala"
	return result;
#line 6232 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_tree_recorder_real_client_connected (UMockdevIoctlBase* base,
                                                    UMockdevIoctlClient* client)
{
	UMockdevIoctlTreeRecorder * self;
#line 1084 "../src/umockdev-ioctl.vala"
	self = (UMockdevIoctlTreeRecorder*) base;
#line 1084 "../src/umockdev-ioctl.vala"
	g_return_if_fail (client != NULL);
#line 1085 "../src/umockdev-ioctl.vala"
	self->priv->write_log = TRUE;
#line 6246 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_tree_recorder_class_init (UMockdevIoctlTreeRecorderClass * klass,
                                         gpointer klass_data)
{
#line 975 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_tree_recorder_parent_class = g_type_class_peek_parent (klass);
#line 975 "../src/umockdev-ioctl.vala"
	g_type_class_adjust_private_offset (klass, &UMockdevIoctlTreeRecorder_private_offset);
#line 975 "../src/umockdev-ioctl.vala"
	((UMockdevIoctlBaseClass *) klass)->handle_ioctl = (gboolean (*) (UMockdevIoctlBase*, UMockdevIoctlClient*)) umockdev_ioctl_tree_recorder_real_handle_ioctl;
#line 975 "../src/umockdev-ioctl.vala"
	((UMockdevIoctlBaseClass *) klass)->client_connected = (void (*) (UMockdevIoctlBase*, UMockdevIoctlClient*)) umockdev_ioctl_tree_recorder_real_client_connected;
#line 975 "../src/umockdev-ioctl.vala"
	G_OBJECT_CLASS (klass)->finalize = umockdev_ioctl_tree_recorder_finalize;
#line 6263 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_tree_recorder_instance_init (UMockdevIoctlTreeRecorder * self,
                                            gpointer klass)
{
#line 975 "../src/umockdev-ioctl.vala"
	self->priv = umockdev_ioctl_tree_recorder_get_instance_private (self);
#line 6272 "umockdev-ioctl.c"
}

static void
umockdev_ioctl_tree_recorder_finalize (GObject * obj)
{
	UMockdevIoctlTreeRecorder * self;
#line 975 "../src/umockdev-ioctl.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UMOCKDEV_TYPE_IOCTL_TREE_RECORDER, UMockdevIoctlTreeRecorder);
#line 1002 "../src/umockdev-ioctl.vala"
	umockdev_ioctl_tree_recorder_flush_log (self);
#line 978 "../src/umockdev-ioctl.vala"
	_g_free0 (self->priv->logfile);
#line 979 "../src/umockdev-ioctl.vala"
	_g_free0 (self->priv->device);
#line 980 "../src/umockdev-ioctl.vala"
	_ioctl_tree_free0 (self->priv->tree);
#line 975 "../src/umockdev-ioctl.vala"
	G_OBJECT_CLASS (umockdev_ioctl_tree_recorder_parent_class)->finalize (obj);
#line 6291 "umockdev-ioctl.c"
}

static GType
umockdev_ioctl_tree_recorder_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UMockdevIoctlTreeRecorderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) umockdev_ioctl_tree_recorder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UMockdevIoctlTreeRecorder), 0, (GInstanceInitFunc) umockdev_ioctl_tree_recorder_instance_init, NULL };
	GType umockdev_ioctl_tree_recorder_type_id;
	umockdev_ioctl_tree_recorder_type_id = g_type_register_static (UMOCKDEV_TYPE_IOCTL_BASE, "UMockdevIoctlTreeRecorder", &g_define_type_info, 0);
	UMockdevIoctlTreeRecorder_private_offset = g_type_add_instance_private (umockdev_ioctl_tree_recorder_type_id, sizeof (UMockdevIoctlTreeRecorderPrivate));
	return umockdev_ioctl_tree_recorder_type_id;
}

GType
umockdev_ioctl_tree_recorder_get_type (void)
{
	static volatile gsize umockdev_ioctl_tree_recorder_type_id__once = 0;
	if (g_once_init_enter (&umockdev_ioctl_tree_recorder_type_id__once)) {
		GType umockdev_ioctl_tree_recorder_type_id;
		umockdev_ioctl_tree_recorder_type_id = umockdev_ioctl_tree_recorder_get_type_once ();
		g_once_init_leave (&umockdev_ioctl_tree_recorder_type_id__once, umockdev_ioctl_tree_recorder_type_id);
	}
	return umockdev_ioctl_tree_recorder_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

